# -*- coding: ISO-8859-1 -*-
version = '4.4.5'
""" capellaScript -- Copyright (c) 2014 ... 2024 Peter Becker
>>>Tisch Harfen Tabulaturschrift mehrstimmig
    Umsetzen von Noten in die Tabulaturschrift fr die Tischharfen (Veeh-Harfe, Zauberharfe, Bauerharfe, Wantalugaharfe, Harmonieharfe, ...)
    Veeh-Harfe und Veeh-Noten sind ein eingetragenes Warenzeichen der Hermann Veeh GmbH & CO.KG
    Bei Problemen bitte eine Mail an peter_becker@freenet.de
<<<

<?xml version="1.0" encoding="ISO-8859-1"?>
<info>
  <lang id="de">
    <title>Tisch Harfen Tabulaturschrift 4.4.5.</title>
    <descr>
      <p>Capella-Datei in Tabulaturschrift fr Tischharfen umsetzen (Veeh-Harfe, Zauberharfe, Bauerharfe, Wantalugaharfe, Harmonieharfe, ...)</p>
      <p>  </p>
      <p>Voraussetzung: Tischharfen-Schriftarten mssen installiert sein. Es gibt neue Version (15.8.24) mit deutlicherer "Ganz-Note"</p>
      <p>Dokumentation und Schriftarten siehe http://peter-becker-cap.de/scripts_meine.htm</p>
      <p>Bei Problemen bitte eine Mail an peter_becker@freenet.de</p>
      <p>  </p>
      <p>Folgende Musiknotationen werden neben den normalen Wiederholungen bercksichtigt:</p>
      <p>- Segno / Kopf / D.C. / D.S. (d.c. und d.s. als Text oder capella-Symbol)</p>
      <p>- Textmarken mit Rahmen werden an die betreffende Tischharfen-Note kopiert</p>
      <p>- Nach eine "doppelten Taktstrich" oder "Textmarken mit Rahmen" wird die Linie unterdrckt</p>
      <p>- Font ist umschaltbar zwischen "rund" und "oval" und "oval mit Standard-Pausenzeichen"</p>
      <p>- Die Originaldatei wird jetzt nicht mehr berschrieben</p>
      <p>- Bis zu 4 Stimmen mglich, Optionen knnen pro Titel und Auswahl gespeichert werden,</p>
      <p>- Papierdefinition ist im Tischharfenformat (quadrat) mglich (nur mit Capella-PDF-Export sinnvoll) </p>
      <p>  </p>
      <p>- neu: Sprungziel kann farbig markiert werden</p>
      <p>- neu: Akkorde in einer Stimme werden genutzt in einer Melodiestimme ohne Begleitung oder in einer Begleitstimme</p>
      <p>- neu: Einstellung Taktstrich mit Taktzhlung unabhngig von Einstellung Taktpfeil</p>
      <p>  </p>
      <p>Veeh-Harfe und Veeh-Noten sind eingetragene Warenzeichen der Firma Hermann Veeh GmbH u. CO.KG</p>
    </descr>
  </lang>
</info>

History:    11.06.14 - V 1.0.0  PB    Erste Ausgabe
(Auszug)    11.11.14   V 2.0.0  PB    16-tel Noten, Pausen, Pausendarstellung whlbar als Haltenoten oder Pausen, keine Rhythmusverschiebung mehr bei bestimmten Noten- Pausenfolgen
            29.08.16   V 3.0.0  JK    Ergnzung Segno und Kopf-Sprnge / neuer Font:Tischharfe-oval / Notengre 3fach
            03.02.19   V 4.0.0  JK+PB Erweiterung auf 4 Stimmen + Speicherung Parameteroptionen je Capella-Quelle.
            10.09.19   V 4.0.2  JK    Option: rechtsbndig drucken (damit Blatt fr 25-er Tischharfe ungeschnitten auch fr Soloharfe passt)
            23.03.20   V 4.1    JK    Nachtrgliche nderung des Rastral (Stauchung) mglich z.B. ber Vergrerung/Verkleinerung
                                      Bei Abstand 1 kann Skalierung automatisch vorgenommen werden
                                      Taktnderung im System mglich
                                      Abfangen und Ausgeben von Systemfehlern
            04.04.20   V 4.1.1  JK    Bercksichtigung und Ausgabe der Voltennummern (z.B. 1-3), Bercksichtigung der Vorgabe von Taktnummern
                                      parametrierbar kleinerer Abstand fr 1. u. letzte Note bei Format A4hoch bzw. Solo-Harfe (wegen Drucken)
            15.01.21   V 4.1.5  JK    bernahme der Positionen von Titel, Takt, Stimmen aus vorhergehender VH-Datei. Eigene Klasse fr Dateinamen, um Verwaltung zu vereinfachen
            18.04.21   V 4.1.9  PB    Anlegekante auch rechts
            05.12.21   V 4.1.11 PB    Anpassung an Capella 9
            30.01.22   V 4.1.12 JK    Erweiterung fr 2 Stcke auf einer Seite: Linienunterbrechung / Leerzeile auch bei "End"-Takt
                                      dazu auch Erweiterung der bernahme der Positionen aus VH-Dateien auf slle Draw-Objekte und mehrere Takte auf einer Seite
            15.01.23   V 4.2.1  JK    neu: Papierformat im Tischharfenformat A4hoch/A4quer vorgebbar (ab Capella 8)
                                      d.c. und d.s. werden sowohl als Text als auch im Capellaformat ausgewertet
                                      Umschaltbar: "da capo" mit Wiederholungslinie oder nur als Text
                                      Korrektur: unsichtbare Ganztakt-Pausen hatten zu unntigen "Leerzeilen" gefhrt
                                      remove "Brackets" aus Layout
            05.05.23   V 4.2.2  JK    Behandlung Doppel-# und Doppel-B ergnzt
            12.05.23   V 4.2.3  JK    nderung 4.2.2. verbessert, Korr. Double-Taktlinie als erste Taktlinie
            20.02.24   V 4.3.1  JK    Sprungziel auf Wunsch bunt markieren / Akkorde in einer Stimme mglich / Ganztakt-Pausen werden richtig verarbeitet
            02.06.24   V 4.3.2  JK    Akkorde parametriert nutzen
                                      Pausen-Umschaltungen neu nach der Beschreibung im Einstellmen,
            13.06.24   V 4.3.3  JK    Einstellung Taktstrich mit Taktzhlung unabhngig von Taktpfeil-Einstellung, Taktnummerierung korrigiert auch fr Ganztakt-Pausen
            19.06.24   V 4.3.4  JK    Korrektur Taktstrich / Taktpfeil
                                      weitere versteckter Parameter Zeile 123-126
            27.07.24   V 4.4.0  JK    Menue und Texte umstellen fr ALLE Tischharfen (verallgemeinern), Hilfe-Hinweis auf Dokumentation
            16.08.24   V 4.4.1  JK    Hinweis: Schriftarten Tischharfe-Oval und Tischharfe-Oval2 mit "breiterer "1"-Note fr bessere Differenzierung zur "1/2"-Note
            18.08.24   V 4.4.2  JK    Abfangen: "Nicht Speichern" bei genderter Datei und Demo-Version
            20.08.24   V 4.4.3  PB    Node editOptions entfernen falls vorhanden um Absturz nach der Bearbeitung zu verhindern. Kompatibilitt zu Capella 9
            21.08.24   V 4.4.4  JK    Attribut autoplacement lschen / Abfangen: noch nicht gespeicherte Datei
            22.08.24   V 4.4.5  JK    pageObject definiert VOR 'systems' anlegen, Reihenfolge ist Wichtig; Instrumentenname auch in staffLayout eintragen
        """

""" zur INFO:    messageBox(title, text, img=0, buttons=0, defBtn=1):
        Standard-Meldungsbox
        img:     0=keines, 1=Fragezeichen, 2=Info, 3=Ausrufezeichen, 4=Stop
        buttons: 0=OK, 1=OK/Abbrechen, 2=Ja/Nein, 3=Ja/Nein/Abbrechen
        defBtn:  Button, der mit OK gewhlt werden kann (Zhlung ab 1)
        Funktionswert: 0=Abbrechen, 1=OK, 2=Ja, 3=Nein wurde gewhlt

        Bei "if messageBox(...,0,1)==0:" kann mit "raise Abbruch" das debugging abgebrochen werden. Es wird dann das "Original" wieder geffnet.
        mit "raise Err" wird beim Abbruch zustzlich der aktuelle Zwischenstand als temporre Datei angezeigt
        """


# Verwendete Tags :
# 2086-100      Wiederholungsbeginn
# 2086-101-x-NN Wiederholungsende mit String Voltenzahl (x=1 --> Wdh-Linie Rechts)
# 2086-102-n    Melodiestimme n(0..3)
# 2086-103-n    Begleitstimme
# 2086-104-n    Melodiestimme + Haltebogen
# 2086-105-n    Begleitstimme + Haltebogen
# 2086-106      Triole
# 2086-107-x    Voltenklammer Sprung Start (x=1 --> Wdh-Linie Rechts)
# 2086-108-0-NN Voltenklammer Sprung Ziel + String mit Voltenzahl

# 2086-109-x  d.s. (Sprung Start)
# 2086-110-x  d.c. (Sprung Start)
# 2086-111    Segno Sprung Ziel (egal normal oder lang)
# 2086-112-x  Coda Sprung Start
# 2086-113    Coda Sprung Ziel
# 2086-114    Fine
# 2086-115    Doppelter Taktstrich, danach "Linie" unterdrcken
# 2086-116    d.c. (Sprung Start) OHNE Linie, nur Text (wie Fine)

# 2086-118    Marker fr Taktnummer
# 2086-119    Page-Objekt kennzeichnen als "Footer" (fr Datum und Anlegekante)

import tempfile
import time
import copy
import sys
import zipfile
import traceback
import xml.dom
from xml.dom.minidom import NodeList, Node, Element
from caplib.capDOM import *
#from caplib.capDOM import ScoreChange

klammerpaare = [                # 'xxx': gibt es nicht --> Anfang nehmen
    ['2086-100', '2086-101'],   # wdh-Zeichen
    ['2086-107', '2086-108'],   # volten-klammer
    ['2086-111', '2086-109'],   # d.s.
    ['2086-112', '2086-113'],   # coda
    ['2086-xxx', '2086-110']    # d.c. Ziel=Beginn
    ]

##################################################
# globale Parameter, (noch) nicht in Parameterfenster
doppelteWdhLinien = 0        #Wiederholungspfeile fr jede Melodiestimme !! nur sinnvoll, wenn Stimmen weit auseinanderliegen
##################################################
# intern ##########
debugging=0            #Werte > 0 nur zum Test !!!!!!!!!!!!!!


Notengroessen = (30, 38, 50)
Fontfaces=("Tischharfe", "Tischharfe-oval2", "Tischharfe-oval")

mySegnos=  ['y','$','n','d.c.','d.s.','fine','d','e']
SegnoIsSym=[ 1 , 1 , 1 , 0    , 0    , 0    , 1 , 1]
#         1   "y":"Segno"
#         2   "$":"Segno lang"
#         3   "n":"Coda"  (groer Coda-Kopf)
#         4   "d.c.":"Da Capo"
#         5   "d.s.":"Dal Segno"
#         6   "fine":"fine"
#         7   "d": "Da Capo" (Capella-Symbol)
#         8   "e": "Dal Segno" (Capella-Symbol)

#codaCnt = 0

# Tischharfe - 18 Saiten (Sopran: h - e" )
notenPosition  = dict(
                  B4  = dict(wert=1,ton="h"),
                  B4P = dict(wert=2,ton="his"),
                  C5M = dict(wert=1,ton="ces'"),
                  C5  = dict(wert=2,ton="c'"),
                  C5P = dict(wert=3,ton="cis'"),
                  D5M = dict(wert=3,ton="des'"),
                  D5  = dict(wert=4,ton="d'"),
                  D5P = dict(wert=5,ton="dis'"),
                  E5M = dict(wert=5,ton="es'"),
                  E5  = dict(wert=6,ton="e'"),
                  E5P = dict(wert=7,ton="eis'"),
                  F5M = dict(wert=6,ton="fes'"),
                  F5  = dict(wert=7,ton="f'"),
                  F5P = dict(wert=8,ton="fis'"),
                  G5M = dict(wert=8,ton="ges'"),
                  G5  = dict(wert=9,ton="g'"),
                  G5P = dict(wert=10,ton="gis'"),
                  A5M = dict(wert=10,ton="as'"),
                  A5  = dict(wert=11,ton="a'"),
                  A5P = dict(wert=12,ton="ais'"),
                  B5M = dict(wert=12,ton="b'"),
                  B5  = dict(wert=13,ton="h'"),
                  B5P = dict(wert=14,ton="his'"),
                  C6M = dict(wert=13,ton="ces''"),
                  C6  = dict(wert=14,ton="c''"),
                  C6P = dict(wert=15,ton="cis''"),
                  D6M = dict(wert=15,ton="des''"),
                  D6  = dict(wert=16,ton="d''"),
                  D6P = dict(wert=17,ton="dis''"),
                  E6M = dict(wert=17,ton="es''"),
                  E6  = dict(wert=18,ton="e''")
                 )

# Tischharfe - 25 Saiten (Sopran/Alt: g - g" )
notenPosition1  = dict(
                  G4  = dict(wert=1,ton="g"),
                  G4P = dict(wert=2,ton="gis"),
                  A4M = dict(wert=2,ton="as"),
                  A4  = dict(wert=3,ton="a"),
                  A4P = dict(wert=4,ton="ais"),
                  B4M = dict(wert=4,ton="b"),
                  B4  = dict(wert=5,ton="h"),
                  B4P = dict(wert=6,ton="his"),
                  C5M = dict(wert=5,ton="ces'"),
                  C5  = dict(wert=6,ton="c'"),
                  C5P = dict(wert=7,ton="cis'"),
                  D5M = dict(wert=7,ton="des'"),
                  D5  = dict(wert=8,ton="d'"),
                  D5P = dict(wert=9,ton="dis'"),
                  E5M = dict(wert=9,ton="es'"),
                  E5  = dict(wert=10,ton="e'"),
                  E5P = dict(wert=11,ton="eis'"),
                  F5M = dict(wert=10,ton="fes'"),
                  F5  = dict(wert=11,ton="f'"),
                  F5P = dict(wert=12,ton="fis'"),
                  G5M = dict(wert=12,ton="ges'"),
                  G5  = dict(wert=13,ton="g'"),
                  G5P = dict(wert=14,ton="gis'"),
                  A5M = dict(wert=14,ton="as'"),
                  A5  = dict(wert=15,ton="a'"),
                  A5P = dict(wert=16,ton="ais'"),
                  B5M = dict(wert=16,ton="b'"),
                  B5  = dict(wert=17,ton="h'"),
                  B5P = dict(wert=18,ton="his'"),
                  C6M = dict(wert=17,ton="ces''"),
                  C6  = dict(wert=18,ton="c''"),
                  C6P = dict(wert=19,ton="cis''"),
                  D6M = dict(wert=19,ton="des''"),
                  D6  = dict(wert=20,ton="d''"),
                  D6P = dict(wert=21,ton="dis''"),
                  E6M = dict(wert=21,ton="es''"),
                  E6  = dict(wert=22,ton="e''"),
                  E6P = dict(wert=23,ton="eis''"),
                  F6M = dict(wert=22,ton="fes''"),
                  F6  = dict(wert=23,ton="f''"),
                  F6P = dict(wert=24,ton="fis''"),
                  G6M = dict(wert=24,ton="ges''"),
                  G6  = dict(wert=25,ton="g''")
                 )

# Tischharfe - 21 Saiten (Sopran: a - f" )
notenPosition2  = dict(
                  A4  = dict(wert=1,ton="a"),
                  A4P = dict(wert=2,ton="ais"),
                  B4M = dict(wert=2,ton="b"),
                  B4  = dict(wert=3,ton="h"),
                  B4P = dict(wert=4,ton="his"),
                  C5M = dict(wert=3,ton="ces'"),
                  C5  = dict(wert=4,ton="c'"),
                  C5P = dict(wert=5,ton="cis'"),
                  D5M = dict(wert=5,ton="des'"),
                  D5  = dict(wert=6,ton="d'"),
                  D5P = dict(wert=7,ton="dis'"),
                  E5M = dict(wert=7,ton="es'"),
                  E5  = dict(wert=8,ton="e'"),
                  E5P = dict(wert=9,ton="eis'"),
                  F5M = dict(wert=8,ton="fes'"),
                  F5  = dict(wert=9,ton="f'"),
                  F5P = dict(wert=10,ton="fis'"),
                  G5M = dict(wert=10,ton="ges'"),
                  G5  = dict(wert=11,ton="g'"),
                  G5P = dict(wert=12,ton="gis'"),
                  A5M = dict(wert=12,ton="as'"),
                  A5  = dict(wert=13,ton="a'"),
                  A5P = dict(wert=14,ton="ais'"),
                  B5M = dict(wert=14,ton="b'"),
                  B5  = dict(wert=15,ton="h'"),
                  B5P = dict(wert=16,ton="his'"),
                  C6M = dict(wert=15,ton="ces''"),
                  C6  = dict(wert=16,ton="c''"),
                  C6P = dict(wert=17,ton="cis''"),
                  D6M = dict(wert=17,ton="des''"),
                  D6  = dict(wert=18,ton="d''"),
                  D6P = dict(wert=19,ton="dis''"),
                  E6M = dict(wert=19,ton="es''"),
                  E6  = dict(wert=20,ton="e''"),
                  E6P = dict(wert=21,ton="eis''"),
                  F6M = dict(wert=20,ton="fes''"),
                  F6  = dict(wert=21,ton="f''")
                 )

# Tischharfe - 25 Saiten (Bass: F - f' )
notenPosition3  = dict(
                  F3  = dict(wert=1,ton="F"),
                  F3P = dict(wert=2,ton="Fis"),
                  G3M = dict(wert=2,ton="Ges"),
                  G3  = dict(wert=3,ton="G"),
                  G3P = dict(wert=4,ton="Gis"),
                  A3M = dict(wert=4,ton="As"),
                  A3  = dict(wert=5,ton="A"),
                  A3P = dict(wert=6,ton="Ais"),
                  B3M = dict(wert=5,ton="B"),
                  B3  = dict(wert=6,ton="H"),
                  B3P = dict(wert=7,ton="His"),
                  C4M = dict(wert=7,ton="ces"),
                  C4  = dict(wert=8,ton="c"),
                  C4P = dict(wert=9,ton="cis"),
                  D4M = dict(wert=9,ton="des"),
                  D4  = dict(wert=10,ton="d"),
                  D4P = dict(wert=11,ton="dis"),
                  E4M = dict(wert=11,ton="es"),
                  E4  = dict(wert=12,ton="e"),
                  E4P = dict(wert=13,ton="eis"),
                  F4M = dict(wert=12,ton="fes"),
                  F4  = dict(wert=13,ton="f"),
                  F4P = dict(wert=14,ton="fis"),
                  G4M = dict(wert=14,ton="ges"),
                  G4  = dict(wert=15,ton="g"),
                  G4P = dict(wert=16,ton="gis"),
                  A4M = dict(wert=16,ton="as"),
                  A4  = dict(wert=17,ton="a"),
                  A4P = dict(wert=18,ton="ais"),
                  B4M = dict(wert=18,ton="b"),
                  B4  = dict(wert=19,ton="h"),
                  B4P = dict(wert=20,ton="his"),
                  C5M = dict(wert=19,ton="ces'"),
                  C5  = dict(wert=20,ton="c'"),
                  C5P = dict(wert=21,ton="cis'"),
                  D5M = dict(wert=21,ton="des'"),
                  D5  = dict(wert=22,ton="d'"),
                  D5P = dict(wert=23,ton="dis'"),
                  E5M = dict(wert=23,ton="es'"),
                  E5  = dict(wert=24,ton="e'"),
                  E5P = dict(wert=25,ton="eis'"),
                  F5M = dict(wert=24,ton="fes'"),
                  F5  = dict(wert=25,ton="f'")
                 )

# Tischharfe - 18 Saiten (Bass: H - e' )
notenPosition4  = dict(
                  B3  = dict(wert=1,ton="H"),
                  B3P = dict(wert=2,ton="His"),
                  C4M = dict(wert=1,ton="ces"),
                  C4  = dict(wert=2,ton="c"),
                  C4P = dict(wert=3,ton="cis"),
                  D4M = dict(wert=3,ton="des"),
                  D4  = dict(wert=4,ton="d"),
                  D4P = dict(wert=5,ton="dis"),
                  E4M = dict(wert=5,ton="es"),
                  E4  = dict(wert=6,ton="e"),
                  E4P = dict(wert=7,ton="eis"),
                  F4M = dict(wert=6,ton="fes"),
                  F4  = dict(wert=7,ton="f"),
                  F4P = dict(wert=8,ton="fis"),
                  G4M = dict(wert=8,ton="ges"),
                  G4  = dict(wert=9,ton="g"),
                  G4P = dict(wert=10,ton="gis"),
                  A4M = dict(wert=10,ton="as"),
                  A4  = dict(wert=11,ton="a"),
                  A4P = dict(wert=12,ton="ais"),
                  B4M = dict(wert=12,ton="b"),
                  B4  = dict(wert=13,ton="h"),
                  B4P = dict(wert=14,ton="his"),
                  C5M = dict(wert=13,ton="ces'"),
                  C5  = dict(wert=14,ton="c'"),
                  C5P = dict(wert=15,ton="cis'"),
                  D5M = dict(wert=15,ton="des'"),
                  D5  = dict(wert=16,ton="d'"),
                  D5P = dict(wert=17,ton="dis'"),
                  E5M = dict(wert=17,ton="es'"),
                  E5  = dict(wert=18,ton="e'")
                 )

# Tischharfe - 25 Saiten (Tenor/Bass: G - g' )
notenPosition5  = dict(
                  G3  = dict(wert=1,ton="G"),
                  G3P = dict(wert=2,ton="Gis"),
                  A3M = dict(wert=2,ton="As"),
                  A3  = dict(wert=3,ton="A"),
                  A3P = dict(wert=4,ton="Ais"),
                  B3M = dict(wert=4,ton="B"),
                  B3  = dict(wert=5,ton="H"),
                  B3P = dict(wert=6,ton="His"),
                  C4M = dict(wert=5,ton="ces"),
                  C4  = dict(wert=6,ton="c"),
                  C4P = dict(wert=7,ton="cis"),
                  D4M = dict(wert=7,ton="des"),
                  D4  = dict(wert=8,ton="d"),
                  D4P = dict(wert=9,ton="dis"),
                  E4M = dict(wert=9,ton="es"),
                  E4  = dict(wert=10,ton="e"),
                  E4P = dict(wert=11,ton="eis"),
                  F4M = dict(wert=10,ton="fes"),
                  F4  = dict(wert=11,ton="f"),
                  F4P = dict(wert=12,ton="fis"),
                  G4M = dict(wert=12,ton="ges"),
                  G4  = dict(wert=13,ton="g"),
                  G4P = dict(wert=14,ton="gis"),
                  A4M = dict(wert=14,ton="as"),
                  A4  = dict(wert=15,ton="a"),
                  A4P = dict(wert=16,ton="ais"),
                  B4M = dict(wert=16,ton="b"),
                  B4  = dict(wert=17,ton="h"),
                  B4P = dict(wert=18,ton="his"),
                  C5M = dict(wert=17,ton="ces'"),
                  C5  = dict(wert=18,ton="c'"),
                  C5P = dict(wert=19,ton="cis'"),
                  D5M = dict(wert=19,ton="des'"),
                  D5  = dict(wert=20,ton="d'"),
                  D5P = dict(wert=21,ton="dis'"),
                  E5M = dict(wert=21,ton="es'"),
                  E5  = dict(wert=22,ton="e'"),
                  E5P = dict(wert=23,ton="eis'"),
                  F5M = dict(wert=22,ton="fes'"),
                  F5  = dict(wert=23,ton="f'"),
                  F5P = dict(wert=24,ton="fis'"),
                  G5M = dict(wert=24,ton="ges'"),
                  G5  = dict(wert=25,ton="g'")
                 )

# Tischharfe - 37 Saiten (Solo: G - g" )
notenPosition6  = dict(
                  G3  = dict(wert=1,ton="G"),
                  G3P = dict(wert=2,ton="Gis"),
                  A3M = dict(wert=2,ton="As"),
                  A3  = dict(wert=3,ton="A"),
                  A3P = dict(wert=4,ton="Ais"),
                  B3M = dict(wert=4,ton="B"),
                  B3  = dict(wert=5,ton="H"),
                  B3P = dict(wert=6,ton="His"),
                  C4M = dict(wert=5,ton="ces"),
                  C4  = dict(wert=6,ton="c"),
                  C4P = dict(wert=7,ton="cis"),
                  D4M = dict(wert=7,ton="des"),
                  D4  = dict(wert=8,ton="d"),
                  D4P = dict(wert=9,ton="dis"),
                  E4M = dict(wert=9,ton="es"),
                  E4  = dict(wert=10,ton="e"),
                  E4P = dict(wert=11,ton="eis"),
                  F4M = dict(wert=10,ton="fes"),
                  F4  = dict(wert=11,ton="f"),
                  F4P = dict(wert=12,ton="fis"),
                  G4M = dict(wert=12,ton="ges"),
                  G4  = dict(wert=13,ton="g"),
                  G4P = dict(wert=14,ton="gis"),
                  A4M = dict(wert=14,ton="as"),
                  A4  = dict(wert=15,ton="a"),
                  A4P = dict(wert=16,ton="ais"),
                  B4M = dict(wert=16,ton="b"),
                  B4  = dict(wert=17,ton="h"),
                  B4P = dict(wert=18,ton="his"),
                  C5M = dict(wert=17,ton="ces'"),
                  C5  = dict(wert=18,ton="c'"),
                  C5P = dict(wert=19,ton="cis'"),
                  D5M = dict(wert=19,ton="des'"),
                  D5  = dict(wert=20,ton="d'"),
                  D5P = dict(wert=21,ton="dis'"),
                  E5M = dict(wert=21,ton="es'"),
                  E5  = dict(wert=22,ton="e'"),
                  E5P = dict(wert=23,ton="eis'"),
                  F5M = dict(wert=22,ton="fes'"),
                  F5  = dict(wert=23,ton="f'"),
                  F5P = dict(wert=24,ton="fis'"),
                  G5M = dict(wert=24,ton="ges'"),
                  G5  = dict(wert=25,ton="g'"),
                  G5P = dict(wert=26,ton="gis'"),
                  A5M = dict(wert=26,ton="as'"),
                  A5  = dict(wert=27,ton="a'"),
                  A5P = dict(wert=28,ton="ais'"),
                  B5M = dict(wert=28,ton="b'"),
                  B5  = dict(wert=29,ton="h'"),
                  B5P = dict(wert=30,ton="his'"),
                  C6M = dict(wert=29,ton="ces''"),
                  C6  = dict(wert=30,ton="c''"),
                  C6P = dict(wert=31,ton="cis''"),
                  D6M = dict(wert=31,ton="des''"),
                  D6  = dict(wert=32,ton="d''"),
                  D6P = dict(wert=33,ton="dis''"),
                  E6M = dict(wert=33,ton="es''"),
                  E6  = dict(wert=34,ton="e''"),
                  E6P = dict(wert=35,ton="eis''"),
                  F6M = dict(wert=34,ton="fes''"),
                  F6  = dict(wert=35,ton="f''"),
                  F6P = dict(wert=36,ton="fis''"),
                  G6M = dict(wert=36,ton="ges''"),
                  G6  = dict(wert=37,ton="g''")
                 )
#xx = druckList['D300']['wert']  #so wird das Dictionary abgefragt

notenNamen   = {1:"h",2:"c'",3:"cis'",4:"d'",5:"dis'",6:"e'",7:"f'",8:"fis'",9:"g'",10:"gis'",11:"a'",12:"ais'",13:"h'",14:"c''",
               15:"cis''",16:"d''",17:"dis''",18:"e''"}

notenNamen1  = {1:"g",2:"gis",3:"a",4:"ais",5:"h",6:"c'",7:"cis'",8:"d'",9:"dis'",10:"e'",11:"f'",12:"fis'",13:"g'",14:"gis'",15:"a'",16:"ais'",17:"h'",18:"c''",
               19:"cis''",20:"d''",21:"dis''",22:"e''",23:"f''",24:"fis''",25:"g''"}

notenNamen2  = {1:"a",2:"ais",3:"h",4:"c'",5:"cis'",6:"d'",7:"dis'",8:"e'",9:"f'",10:"fis'",11:"g'",12:"gis'",13:"a'",14:"ais'",15:"h'",16:"c''",
               17:"cis''",18:"d''",19:"dis''",20:"e''",21:"f''"}

notenNamen3  = {1:"F",2:"Fis",3:"G",4:"Gis",5:"A",6:"Ais",7:"H",8:"c",9:"cis",10:"d",11:"dis",12:"e",13:"f",14:"fis",15:"g",16:"gis",
               17:"a",18:"ais",19:"h",20:"c'",21:"cis'",22:"d'",23:"dis'",24:"e'",25:"f'"}

notenNamen4  = {1:"H",2:"c",3:"cis",4:"d",5:"dis",6:"e",7:"f",8:"fis",9:"g",10:"gis",11:"a",12:"ais",13:"h",14:"c'",
               15:"cis'",16:"d'",17:"dis'",18:"e'"}

notenNamen5  = {1:"G",2:"Gis",3:"A",4:"Ais",5:"H",6:"c",7:"cis",8:"d",9:"dis",10:"e",11:"f",12:"fis",13:"g",14:"gis",15:"a",16:"ais",17:"h",18:"c'",
               19:"cis'",20:"d'",21:"dis'",22:"e'",23:"f'",24:"fis'",25:"g'"}

notenNamen6  = {1:"G",2:"Gis",3:"A",4:"Ais",5:"H",6:"c",7:"cis",8:"d",9:"dis",10:"e",11:"f",12:"fis",13:"g",14:"gis",15:"a",16:"ais",17:"h",18:"c'",
               19:"cis'",20:"d'",21:"dis'",22:"e'",23:"f'",24:"fis'",25:"g'",26:"gis'",27:"a'",28:"ais'",29:"h'",30:"c''",31:"cis''",32:"d''",33:"dis''",34:"e''",35:"f''",36:"fis''",37:"g''"}

stauchung    = {0:'2.3',1:'2.0',2:'1.88',3:'1.76',4:'1.6',5:'1.52',6:'1.4',7:'1.3',8:'1.2',9:'1.1',10:'1.02',11:'0.95'}

MaxZeilenA3_Abst1=270     #Fr automatische Skalierung bei Zeilenabstand1
#Ansonsten kann mit dem -+-Vergrerungsmenue oder Einstellen des Rastral ein Blatt auf eine Seite skaliert werden

StdFontSize  = {0:'10',1:'10',2:'10',3:'12',4:'12',5:'12',6:'17',7:'17',8:'17',9:'19',10:'19',11:'19'}

UmrechnungVonMM  = 1.8
offsetAnlegekante= 0.4
abstandSaiten = (11.5, 6.47)   # 1/4: 11.5mm ; 1/16: 11.5*0.75*0.75=6.47mm

anzahlSaiten = ( 18,  18,  18,  18,  25,  25,  25,  25,  37,  21,  25,  21,  25)
paperSizeX   = (210, 297, 210, 297, 297, 297, 420, 420, 420, 297, 297, 420, 420)
paperSizeY   = (297, 210, 297, 210, 210, 210, 297, 297, 297, 210, 210, 297, 297)
paperDef     = {"Top":10,"Bottom":5,"Left":10,"LeftKlein":4,"LeftSolo":0,"LeftSoloOpt":5, "minLeft":20, "minRight":20 }
# Wiederholungslinien werden innerhalb der uersten Noten gefhrt, wenn der Rand den min-Wert unterschreitet
#Rechter Rand und Anlegekanten werden gerechnet, siehe calcPageDefinition
XanlegeKanten=[0,0]

FarbenListeX=[('FF0000'),# rot
              ('FF8000'),# orange
              ('FFC000'),# orangegelb
              ('FFFF00'),# gelb
              ('80FF00'),# gelbgrn
              ('008000'),# grn
              ('007080'),# blaugrn
              ('003090'),# grnblau
              ('0000FF'),# blau
              ('6000A0'),# violett
              ('E00050'),# rotviolett
              ('000000'),# schwarz
              ('808080'),# dunkelgrau
              ('C0C0C0'),# hellgrau
              ('00FFFF'),# cyan
              ('FFFFFF')]# weiss

FormToene= {0:{'1/16':'I','1/8':'A','1/4':'B','1/2':'C','1/1':'D'},   #Noten
            1:{'1/16':'J','1/8':'E','1/4':'F','1/2':'G','1/1':'H'},   #Noten mit '.'
            2:{'3/4':'G','2/4':'C','3/8':'F','4/8':'C','6/8':'G'}   #Ganztakt
            }
FormPause= {0:{'1/16':'O','1/8':'N','1/4':'M','1/2':'L','1/1':'K'},
            1:{'1/16':'T','1/8':'S','1/4':'R','1/2':'Q','1/1':'P'},
            2:{'3/4':'Q','2/4':'L','3/8':'R','4/8':'L','6/8':'Q'}   #GanztaktPause
            }

global Erg, FirstLine, gdgorg, gdgtab, Datei

Erg = 'xxx'
showAuftakt    = 0          #showAuftakt=0: 1. Note, =1: warten auf Auftakt, =2:nichts mehr tun
volta          = 0
voltaSave      = 0
voltaDO        = 'NA'
voltaStringR   = 'NA'       #Label an Rcksprung-Voltenklammer
voltaStringF   = 'NA'       #Label an Vorwrts-Voltenklammer
circleObj      = 'NA'
barline4Takt   = 'Start'
ersterTakt     = 1
taktinhWdh     = 'NA'
taktnummerBasis  = '[0,0]'    #Basiswert aus nAdd, Reset Nummerierung

lineCount      = 0
takt           = 0          #default, damit Variable definiert ist auch wenn kein Takt da ist
taktNbr        = 10000      #default: Taktzeichen nur ber feste Taktstriche (bei Noten ohne Takt)
timeSign       = 'NA'

drawObj_TaktPfeil  = [['NA','NA'],['NA','NA'],['NA','NA'],['NA','NA']]
drawObj_TaktLine   = ['NA','NA']

class Abbruch(LookupError):
    '''Abbruch Message-Debugging'''

class DateiNamen:
    def __init__(self, Quelle):                                         #Bsp
        self.src    = Quelle                                            #c:/beispiel/test.capx
        self.dir    = os.path.dirname(Quelle)+'/'                       #c:/beispiel/
        self.name   = os.path.splitext(os.path.basename(Quelle))[0]     #test
        self.nameVH = self.name+ '_VH'                                  #test_VH
        self.parDir = self.dir+'par/'                                   #c:/beispiel/par/
        self.nameErw= ''                #Erweiterung um Stimmennummern  z.B. _1_2
        self.gen    = ''                #Erweiterung um Generationen    z.B. (1)
        self.nameOldVH = ''             #alter Name aus opt: zB test_VH_1(2)

    def genErw(self,gdgtabLok):
        global Melodiestimmen

        if gdgtabLok>=1:
            Erw_VH = '_'+str(Melodiestimmen[0]+1)
            if Melodiestimmen[1]>=0:
                Erw_VH = Erw_VH+'_'+str(Melodiestimmen[1]+1)
            if Melodiestimmen[2]>=0:
                Erw_VH = Erw_VH+'_'+str(Melodiestimmen[2]+1)
            if Melodiestimmen[3]>=0:
                Erw_VH = Erw_VH+'_'+str(Melodiestimmen[3]+1)
            self.nameErw=Erw_VH

            dateiVH = self.dir+self.nameVH+Erw_VH
            if gdgtabLok==2:
                gdg = 0
                while os.path.exists(dateiVH +'(' + str(gdg) + ').capx'):    # vorhandene Generationen berprfen
                    gdg = gdg +1
                self.gen='(' + str(gdg) + ')'

    def VH(self):
        return (self.dir+self.nameVH+self.nameErw+self.gen+'.capx')          #c:/beispiel/test_VH_1(2).capx

    def nameNewVH(self):
        return (self.nameVH+self.nameErw+self.gen)                           #test_VH_1(2)

    def oldVH(self):
        if self.nameOldVH=='':
            return ''
        else:
            return (self.dir+self.nameOldVH+'.capx')

    def parFile(self):
        return (self.parDir+self.nameVH+self.nameErw+'.opt')

################################################

#ScriptManagerOptionsFileName = optionFileName

class ScriptOptions(ScriptOptions):
    def __init__(self, optFileName=None):
        if optFileName:
            self._optionsFile = optFileName
        else:
            dir, rFile = os.path.split(sys.argv[0])
            rFile = os.path.splitext(rFile)[0] + ".opt"
            s = os.path.join(dir, rFile)
            s = s.replace(":", "$").replace("/", "#").replace("\\", "#")
            self._optionsFile = os.path.join(getUserDataDir(), s)

        self._oldOptionsFile = self._optionsFile    #fr Capella 7
        self._newOptionsFile = self._optionsFile


def KopfForm(KopfListe,base,dots,aktTakt):
    # Kopfform setzen aus Noten und ggf Takt
    ganztakt=0
    if not KopfListe[0].has_key(base):   #Notenwert in der Tabelle?
        base = '1/1'                     #Ganztakt '1/1' als Alternative
        ganztakt = 1
    if dots != '1':
        formKopf = KopfListe[0][base]
    else:
        formKopf = KopfListe[1][base]
    if ganztakt == 1 and aktTakt != 0:       #Note auf Taktwert setzen
        if KopfListe[2].has_key(aktTakt):
            formKopf = KopfListe[2][aktTakt]
    return (formKopf, ganztakt)


def prepareInstrument():
    # Dict abh vom Intrument in lokales Dict kopieren
    global instrument, notenNamenLok, notenDictLok

    if instrument == 0 or instrument == 1:                                         # Basis Sopran 18
        notenDictLok  = notenPosition
        notenNamenLok = notenNamen
    elif instrument == 2 or instrument == 3:                                       # Basis Bass 18
        notenDictLok = notenPosition4
        notenNamenLok = notenNamen4
    elif instrument == 4 or instrument == 6:                                       # Standard Sopran/Alt 25
        notenDictLok = notenPosition1
        notenNamenLok = notenNamen1
    elif instrument == 5 or instrument == 7:                                       # Standard Tenor/Bass 25
        notenDictLok = notenPosition5
        notenNamenLok = notenNamen5
    elif instrument == 8:                                                          # Solo 37
        notenDictLok = notenPosition6
        notenNamenLok = notenNamen6
    elif instrument == 9 or instrument == 11:                                      # 21 Saiten a-f"
        notenDictLok = notenPosition2
        notenNamenLok = notenNamen2
    elif instrument == 10 or instrument == 12:                                     # 25 Saiten
        notenDictLok = notenPosition3
        notenNamenLok = notenNamen3


def addElementNode(el,tagName):
    # addElementNode: Neuen Node zu "el" hinzufgen wenn Node "tagName" nicht existiert
    # ansonsten existierende Node zurckmelden
    global doc
    childs = el.childNodes
    for n in range(childs.length):
        if childs[n].nodeType == childs[n].ELEMENT_NODE and childs[n].tagName == tagName:
            return childs[n]
    newChild = doc.createElement(tagName)
    el.appendChild(newChild)
    return newChild


def addNewElementNode(el,tagName):
    # add new Node with tagName "tagName" to el
    global doc
    newChild = doc.createElement(tagName)
    el.appendChild(newChild)
    return newChild


def removeAttr(el, att):
    # Entfernt das Attribut, falls vorhanden
    if el.hasAttribute(att):
        el.removeAttribute(att)


def getNodePO(score):
    # pageObject holen, bzw. Anlegen, wenn nicht vorhanden
    if not score.getElementsByTagName('pageObjects'):
        newNode = score.parentNode.createElement('pageObjects')
        sy=score.getElementsByTagName('systems')
        score.insertBefore(newNode, sy[1])          #PageObjects mssen vor "systems" sein
    return score.getElementsByTagName('pageObjects')[0]


def getElementObjects(objList):
    # returns a List
    newList = NodeList()
    for n in range(objList.length):
        if objList[n].nodeType == objList[n].ELEMENT_NODE:
            newList.append(objList[n])
    return newList


def sortUnique(Liste):
    sortierteListe=[]
    for listElement in Liste:
        if listElement not in sortierteListe:
            sortierteListe.append(listElement)
    sortierteListe.sort()
    return sortierteListe


def insertText(score, el, text, groesse, farbe, basic, x, y, dicke, italic, align):
    # Text einfgen an el
    #messageBox('el',str(text))
    if el != 'NA':
        drawObjs    = addElementNode(el, 'drawObjects')
        newdrawObj1 = addNewElementNode(drawObjs, 'drawObj')
        newText1    = addNewElementNode(newdrawObj1, 'text')
        newFont1    = addNewElementNode(newText1, 'font')
        newContent1 = addNewElementNode(newText1, 'content')
        if basic != 'NA':
            newBasic1 = addElementNode(newText1, 'basic')
            newBasic1.setAttribute('tag', basic)
        newText1.setAttribute('x', x)
        newText1.setAttribute('y', y)
        if x < '0':
            newText1.setAttribute('align', 'right')    #neu ab 3.0.10
        if align == 'left':
            newText1.setAttribute('align', 'left')
        elif align == 'center':
            newText1.setAttribute('align', 'center')
        elif align == 'right':
            newText1.setAttribute('align', 'right')
        newFont1.setAttribute('face', 'Times New Roman')
        newFont1.setAttribute('height', str(groesse))
        newFont1.setAttribute('weight', dicke)
        newFont1.setAttribute('italic', italic)
        newFont1.setAttribute('charSet', "1")
        if farbe != 'NA':
            newFont1.setAttribute('color', farbe)
        newContent1.appendChild(score.parentNode.createTextNode(str(text)))


def insertTextOnPage(score, textListe, farbenListe, groesse, basic, x, y, dicke, italic, align, underline, tag):
    # Text einfgen an Seitenkopf
    global instrument
    newPO = getNodePO(score)
    newDO   = addNewElementNode(newPO,'drawObj')
    if len(textListe) == 1: #nur 1 Text
        newD1 = newDO
    else:       #Gruppe an NewDO hngen, damit Text gemeinsam verschoben werden kann
        newGO = addNewElementNode(newDO,'group')
        newD1 = addNewElementNode(newGO,'drawObj')
    vert = float(y)
    for tt in range(len(textListe)):
        newTxt   = addNewElementNode(newD1, 'text')
        newCont  = addNewElementNode(newTxt, 'content')
        newFont  = addNewElementNode(newTxt, 'font')
        newTxt.setAttribute('x', x)
        newTxt.setAttribute('y', str(vert))
        newTxt.setAttribute('align', align)
        if underline == '1':
            newFont.setAttribute('underline','true')
        elif underline == '2':
            newTxt.setAttribute('frame','rectangle')
            newTxt.setAttribute('frameDistance','0.5')
        newFont.setAttribute('face','Times New Roman')
        newFont.setAttribute('height',groesse)
        newFont.setAttribute('weight',dicke)
        newFont.setAttribute('italic',italic)
        newFont.setAttribute('color',farbenListe[tt])
        newFont.setAttribute('charSet',"1")
        textNode = doc.createTextNode(str(textListe[tt]))
        newCont.appendChild(textNode)
        vert=vert+2.5
    newBasic = addNewElementNode(newD1, 'basic')
    if basic == '1':
        newBasic.setAttribute('evenPages',"false")
    elif basic == '2':
        newBasic.setAttribute('firstPage',"false")
        newBasic.setAttribute('oddPagesExceptFirst',"false")
    newBasic.setAttribute('noAdjust',"true")
    if tag != '':
        newBasic.setAttribute('tag',tag)        #ggf tag anhngen (vor allem fr "Footer"


pageTaktObjKoordVH   =[]
pageStimmeObjKoordVH =['NA','NA']

def move_PageObjects(score):
    #Texte am Seitenkopf auf die Positionen schieben wie in den bergebenen Koordinaten
    global pageTaktObjKoordVH, pageStimmeObjKoordVH, datumprint, instrument, paperSizeY

    vhDatei=Datei.oldVH()
    if vhDatei =='' or not os.path.exists(vhDatei):
        return

    zf = zipfile.ZipFile(vhDatei,'r')
    textxml = zf.read('score.xml')
    capxFile = xml.dom.minidom.parseString(textxml)
    zf.close()
    pageTextObjsKoordVH  =[]
    listPO = capxFile.getElementsByTagName('pageObjects')

    for child in listPO[0].childNodes:
        if child.nodeType == child.ELEMENT_NODE:
            for enkel in child.childNodes:
                usekoord=1
                if enkel.nodeType == enkel.ELEMENT_NODE:
                    if enkel.tagName == 'group':
                        subtext=enkel.getElementsByTagName('text')      #kann Gruppe "Stimme" sein
                        enkel=subtext[0]
                    for basic in enkel.parentNode.getElementsByTagName('basic'):          # Tag Footer=119
                        if basic.getAttribute('tag')=='2086-119':       #Anlegekante oder Datum: beide haben feste Position
                            usekoord=0
                            continue

                    if usekoord==1:
                        if enkel.hasAttribute('x'):
                            x=enkel.getAttribute('x')
                            y=enkel.getAttribute('y')
                            ct=enkel.getElementsByTagName('content')
                            if ct:
                                text = ct[0].firstChild.nodeValue
                                if text.find(' Takt')!=-1:
                                    pageTaktObjKoordVH.append([x,y])    #falls unterschiedliche Takte im System
                                    break
                                elif text.find('Stimme')!=-1:
                                    pageStimmeObjKoordVH=[x,y]
                                    break
                            pageTextObjsKoordVH.append([x,y,0,0])
                        elif enkel.hasAttribute('x1'):
                            x1=enkel.getAttribute('x1')
                            x2=enkel.getAttribute('x2')
                            y1=enkel.getAttribute('y1')
                            y2=enkel.getAttribute('y2')
                            pageTextObjsKoordVH.append([x1,y1,x2,y2])

    listPO = score.getElementsByTagName('pageObjects')
    if listPO:
        for child in listPO[0].childNodes:
            if child.nodeType == child.ELEMENT_NODE:
                for enkel in child.childNodes:
                    if enkel.nodeType == enkel.ELEMENT_NODE:
                        if enkel.hasAttribute('x'):
                            if len(pageTextObjsKoordVH)>0:
                                koord=pageTextObjsKoordVH.pop(0)
                                enkel.setAttribute('x',koord[0])
                                enkel.setAttribute('y',koord[1])
                        elif enkel.hasAttribute('x1'):
                            if len(pageTextObjsKoordVH)>0:
                                koord=pageTextObjsKoordVH.pop(0)
                                enkel.setAttribute('x1',koord[0])
                                enkel.setAttribute('y1',koord[1])
                                enkel.setAttribute('x2',koord[2])
                                enkel.setAttribute('y2',koord[3])


def getPitch(child):
    #getPitch liefert die Liste aller Tne einer Stimme, beginnend mit dem hchsten Ton
    global notenDictLok, anzahlSaiten, instrument, akkordTon

    headlist = (child.getElementsByTagName('head')) #Unterster Ton zuerst

    #akkordTon=0:Oberster Ton, 1=alle, 2=unterster Ton
    if akkordTon==0:
        headlist=[headlist[-1]]
    elif akkordTon==1:
        headlist = reversed(headlist)               #Oberster Ton zuerst
    else:
        headlist=[headlist[0]]
    Pitches=[]
    for head in headlist:
        pitch = head.getAttribute('pitch')
        alter = head.getElementsByTagName('alter')
        if alter:
            step = alter[0].getAttribute('step')
            if not step:
                step=0
            else:
                step=int(step)
                if abs(int(step))>1:  #Liste durchsuchen auf Namen mit dem "neuen" Wert
                    if notenDictLok.has_key(pitch):
                        liste=list(notenDictLok.values())
                        keys=list(notenDictLok.keys())
                        wert=notenDictLok[pitch]['wert']+int(step)
                        pitch='NN'
                        if wert>0 and wert<=anzahlSaiten[instrument]:
                            for i in range(0,len(notenDictLok)):
                                if liste[i]['wert']==wert:
                                    pitch=keys[i]
                                    break
                    else:
                        pitch='NN'
                elif step == -1:
                    pitch = pitch + 'M'
                elif step == 1:
                    pitch = pitch + 'P'
        if notenDictLok.has_key(pitch):
            Pitches.append(pitch)
        else:
            Pitches.append('NN')
    #if messageBox('pitch','Pitches:'+str(Pitches),0,1)==0:
    #    raise Abbruch
    return Pitches


def searchCircle(chord):
    global circleObj
    # prfen ob Text mit Kreis am Objekt hngt
    if chord != 'NA':
        for dO in chord.getElementsByTagName('drawObj'):
            for nText in dO.getElementsByTagName('text'):
                if not nText.getAttribute('frame')=='':    #'circle' or frame=='rectangle' :
#nur fr messageBox
#                    Content = nText.getElementsByTagName('content')
#                    text = Content[0].firstChild.nodeValue
#                    if messageBox('circle',text+'  '+str(dO),0,1)==0:
#                          raise Abbruch
###
                    circleObj=dO
                    return True
    return False


def copyCircle(newCh,xPos):             #in xPos wird der Positionsindex bergeben
    global circleObj                    #evtl. gemerkt: circleObj gef. in "Barline"
    # Objekt kopieren
    #messageBox('CopyCircle', 'x: '+str(xPos)+',  newCh='+str(newCh)+',   circleObj='+str(circleObj))
    if circleObj != 'NA':
        d0c=circleObj.cloneNode(1)
        for fr in d0c.getElementsByTagName('text'):
            if xPos < 3:
                #messageBox('Circle nach rechts','')
                fr.setAttribute('x','+4')
                fr.setAttribute('align','left')
            else:
                fr.setAttribute('x','-4')
                fr.setAttribute('align','right')
            fr.setAttribute('y','-2.5')
#nur fr messageBox
#        co=d0c.getElementsByTagName('text')
#        content = co[0].getElementsByTagName('content')
#        text = content[0].firstChild.nodeValue
#        if messageBox('CopyCircle '+str(d0c),'pos='+str(xPos)+':   '+text+'  '+str(co),0,1)==0:
#            raise Abbruch
###
        dOnew=addElementNode(newCh,'drawObjects')
        d1=dOnew.appendChild(d0c)
        circleObj='NA'

def searchSegno(chord):
    global segnoDO

    # prfen ob segno-Zeichen am Objekt hngt
    if chord != 'NA':
        for dO in chord.getElementsByTagName('drawObj'):
            for nText in dO.getElementsByTagName('text'):
                Content = nText.getElementsByTagName('content')
                if Content[0].hasChildNodes():
                    Font = nText.getElementsByTagName('font')
                    issymbol = Font[0].getAttribute('charSet')=='2'
                    text = Content[0].firstChild.nodeValue
                    if not text==0:
                        text = text.lower()
                        for n in range(len(mySegnos)):
                            if mySegnos[n] in text and SegnoIsSym[n]==issymbol:
                                #messageBox('Segno',str(mySegnos[n]))
                                #if messageBox('Segno',mySegnos[n]+'  index: '+str(n),0,1)==0:
                                #    raise Abbruch
                                segnoDO = dO.cloneNode(1)
                                return n+1
    return 0


def checkSegno(score):
    # Segnos usw auf korrekte Verankerung berprfen

    erg='OK'
    msg=''
    codaCnt = 0
    segnoCnt=0
    #fehlerMarken=[]
    #fehlerZiele=[]
    fehlerM=0
    fehlerZ=0
    systems = score.getElementsByTagName('system')
    for sy in range(systems.length):                                                           # Voltenklammern oder Segnos in erster Stimme lokalisieren
        staff = systems[sy].getElementsByTagName('staff')
        voice = staff[0].getElementsByTagName('voice')
        nos = voice[0].getElementsByTagName('noteObjects')
        elPosIx = 0
        for child in nos[0].childNodes:
            if child.nodeType == child.ELEMENT_NODE:
                if (child.tagName == 'chord' or child.tagName == 'rest' or child.tagName == 'barline'):
                    segno4Check=searchSegno(child)
                    if segno4Check <> 0:
                        fehlerS=0
                        segnoCnt=segnoCnt+1
                        if segno4Check == 3:
                            codaCnt = codaCnt + 1
                        if ((segno4Check == 1 or segno4Check == 2 or (segno4Check == 3 and codaCnt == 2)) and (child.tagName <> 'chord' and child.tagName <> 'rest')):
                            #fehlerZiele.append(segnoCnt)
                            fehlerZ+=1
                            fehlerS=1
                        if ((segno4Check == 5 or segno4Check == 4 or (segno4Check == 3 and codaCnt <> 2)) and (child.tagName <> 'barline')):
                            #fehlerMarken.append(segnoCnt)
                            fehlerM+=1
                            fehlerS=1
                        if fehlerS==1:
                            Font = child.getElementsByTagName('font')
                            Font[0].setAttribute('color',str('E00050'))                                    # rot einfrben

#    if len(fehlerMarken)>0:
#        msg='Sprungmarken Nummer '+str(fehlerMarken)+' mssen an festen Taktstrichen verankert werden (rot markiert)\n'
#        erg= 'Err'
#    if len(fehlerZiele)>0:
#        msg=msg+'Sprungziele Nummer'+str(fehlerZiele)+' mssen an Noten oder Pausen verankert werden (rot markiert)\n'
#        erg= 'Err'
    if fehlerM==1:
        msg='Sprungmarken mssen an festen Taktstrichen verankert werden (rot markiert)\n'
        erg= 'Err'
    if fehlerZ==1:
        msg=msg+'Sprungziele mssen an Noten oder Pausen verankert werden (rot markiert)\n'
        erg= 'Err'
    if erg=='Err':
        messageBox('Partiturproblem',msg)

    return erg


def markSegno(score,chords, nIx, newCh,tagExtRechts):
    #chords[max(nIx)-1] entspricht newCh;
    #hier wird beiden bergeben. newCh ist einfacher,
    #das andere wird fr die Schleife bei segno 4,6,7 gebraucht
    global Coda_second, segno, vfarbe, DaCapoNurText, StimmenNutzung
    if segno>0:
        #maxIx=0
        #for st in range(4):
        #    if nIx[st]!='NA':
        #        maxIx=max(maxIx,nIx[st])
        #messageBox('Segnos','Segno-Nr. = '+str(segno)+'\nchordxs[maxIx-1]='+str(chords[maxIx-1])+'\nnewCh='+str(newCh))
        if segno == 1 or segno == 2:
            insertText(score,newCh,'SegnoZiel','12','NA','2086-111','0','0','700','false','0')
        elif segno == 3 and Coda_second == 0:
            insertText(score,newCh,'CodaStart','12','NA','2086-112-'+tagExtRechts,'0','0','700','false','0')
            appendEmptySystem(score,0,'CodaStart')
            Coda_second = 1
        elif segno == 3 and Coda_second == 1:
            insertText(score,newCh,'CodaZiel', '12','NA','2086-113','0','0','700','false','0')
            Coda_second = 2  #nur 2* Coda erlaubt
        elif (segno == 4 or segno == 7) and DaCapoNurText==0:
            insertText(score,newCh,'DaCapo','12','NA','2086-110-'+tagExtRechts,'0','0','700','false','0')
        elif segno == 5 or segno == 8:
            insertText(score,newCh,'DalSegno', '12','000000','2086-109-'+tagExtRechts,'0','0','700','false','0')
        elif segno in [6,4,7]:
            segnoIxAlt=-10
            for st in range(4):
                if StimmenNutzung[st]==0 and nIx[st]!='NA':
                    if doppelteWdhLinien>0 or abs(segnoIxAlt-nIx[st])>7 : #st ist Melodiestimme
                        if segno==6:
                            insertText(score,chords[nIx[st]-1],'Fine','14',FarbenListeX[vfarbe],'2086-114','7','1','700','false','0')
                        else:
                            insertText(score,chords[nIx[st]-1],'DaCapo','14',FarbenListeX[vfarbe],'2086-116','7','1','700','false','0')
        else:
            raise ValueError('Fehler bei Segno-Zeichen gefunden, Segno-Nr. = '+str(segno))
        segno=0    #done


def checkVolta(chord, clone):
    # prfen ob eine Voltenklammer am Objekt hngt
    # fr CopyObjects: clone=1--> Node merken
    global voltaDO, voltaStringR, voltaStringF

    number = 0
    #messageBox('CH',str(chord))
    if chord != 'NA':
        for dO in chord.getElementsByTagName('drawObj'):
            for voltaElem in dO.getElementsByTagName('volta'):
                if voltaElem:
                    for basic in dO.getElementsByTagName('basic'):
                        if basic:
                            cont= basic.getAttribute('continued')
                            num1 = voltaElem.getAttribute('firstNumber')
                            if cont!='true' and num1!='':
                                #messageBox('CheckVolta',str(num1))
                                number=int(num1)
                                if clone:
                                    voltaDO = dO.cloneNode(1)
                                else:
                                    vString=num1          #nur wenn nicht aus CopyObj aufgerufen
                                    num2 = voltaElem.getAttribute('lastNumber')
                                    if num2:
                                        vString=vString+'-'+num2
                                    if number==1:
                                        voltaStringR=vString    #fr Wiederholungs-Volta
                                    else:
                                        voltaStringF=vString    #fr Aussprung
    return number


def draw_TaktPfeil(chords,Saite,st):
    #Drawobjekt: TaktPfeile
    #TaktPfeil an newDos
    #Rckgabe: Objekt TaktPfeil
    global Pfeilanz

    GroupTaktPfeil='NA'

    if Pfeilanz==1:
        drawObjects  = addElementNode(chords[Saite],'drawObjects')
        newdrawObj   = addNewElementNode(drawObjects,'drawObj')
        newBasicG    = addElementNode(newdrawObj,'basic')
        GroupTaktPfeil= addNewElementNode(newdrawObj,'group')
        newdrawObj2  = addNewElementNode(GroupTaktPfeil,'drawObj')
        newpolygon   = addNewElementNode(newdrawObj2,'polygon')
        newPoints    = addNewElementNode(newpolygon,'points')
        newPoint1    = addNewElementNode(newPoints,'point')
        newPoint2    = addNewElementNode(newPoints,'point')
        newPoint3    = addNewElementNode(newPoints,'point')
        if abstand<=2:
            x_versch=1
        else:
            x_versch=0.6
        newpolygon.setAttribute('filled','true')
        newPoint1.setAttribute('x',str(2.21875+x_versch))
        newPoint1.setAttribute('y','-1.5625')
        newPoint2.setAttribute('x',str(2.8125+x_versch))
        newPoint2.setAttribute('y','-0.5625')
        newPoint3.setAttribute('x',str(1.65625+x_versch))
        newPoint3.setAttribute('y','-0.5625')
        newpolygon.setAttribute('fillColor',FarbenListeX[NFarbe[st]])
        newdrawObj2  = addNewElementNode(GroupTaktPfeil,'drawObj')
        newline      = addNewElementNode(newdrawObj2,'line')
        newline.setAttribute('x1',str(2.375+x_versch))
        newline.setAttribute('y1','-1.03125')
        newline.setAttribute('x2',str(4.31125+x_versch))
        newline.setAttribute('y2','-2.09375')
        newline.setAttribute('lineWidth','0.2')
        newline.setAttribute('color',FarbenListeX[NFarbe[st]])

        newBasicG.setAttribute('behindNotes','false')  #org:'true' macht Probleme mit "Zielmarker"

    return GroupTaktPfeil

def draw_TaktStrich(chords):
    #Drawobjekt: Taktstriche ggf. mit Taktnummerierung
    #Taktstrich an Chord index 0 mit Range
    #Rckgabe: Objekt: Taktstrich
    global abstand, instrument
    global taktnummerBasis, Taktstrichanz, Taktnummerierung
    #if messageBox('dTP','Aufruf draw_TaktStrich: '+str(taktnummerBasis)+', Taktstrichanz='+str(Taktstrichanz),0,1)==0:
    #    raise Abbruch

    GroupTaktLine ='NA'

    if Taktstrichanz == 1:
        drawObjects = addElementNode(chords[0],'drawObjects')
        newdrawObj  = addNewElementNode(drawObjects,'drawObj')
        newBasicG   = addElementNode(newdrawObj,'basic')
        GroupTaktLine= addNewElementNode(newdrawObj,'group')
        newdrawObj3 = addNewElementNode(GroupTaktLine,'drawObj')
        newTaktLine = addNewElementNode(newdrawObj3,'line')
        newTaktLine.setAttribute('x1', '0')
        newTaktLine.setAttribute('y1', '0')
        newTaktLine.setAttribute('x2', '0')
        newTaktLine.setAttribute('y2', '0' )
        newTaktLine.setAttribute('lineWidth','0.2')
        newTaktLine.setAttribute('color',FarbenListeX[13])   #hellgrau
        newBasic = addElementNode(newdrawObj3,'basic')
        newBasic.setAttribute('behindNotes','true')
        newBasic.setAttribute('noteRange',str(anzahlSaiten[instrument]))

        if Taktnummerierung>0:
#       hier Text direkt, damit er in Gruppe eingebunden ist, Text=dummy mit "tag"
#       Nummerierung erfolgt Ende mit Aufruf von set_Taktnummern
            newdrawObj4 = addNewElementNode(GroupTaktLine,'drawObj')
            newTextTaktnr = addNewElementNode(newdrawObj4,'text')
            newFont1     = addNewElementNode(newTextTaktnr,'font')
            newFont1.setAttribute('face','Times New Roman')
            newFont1.setAttribute('charSet',"1")
            newFont1.setAttribute('height','12')
            newFont1.setAttribute('weight','700')
            newFont1.setAttribute('color',FarbenListeX[12])
            newContent1  = addNewElementNode(newTextTaktnr,'content')
            textNode = doc.createTextNode(taktnummerBasis)              # Textdummy-Wert aus nAdd (nderung Taktzhlung) und Reset Nummerierung
            newBasic=addNewElementNode(newdrawObj4,'basic')
            newBasic.setAttribute('tag','2086-118')
            newContent1.appendChild(textNode)
            newTextTaktnr.setAttribute('x','0')
            newTextTaktnr.setAttribute('y','2')
        newBasicG.setAttribute('behindNotes','true')

    #messageBox('+Taktb',str(GroupTaktLine))
    return GroupTaktLine


def remove_TaktAnzeige(no):
    #Taktpfeil (Index no) lschen, da im Nachhinein erkannt wurde, dass er falsch ist
    global drawObj_TaktPfeil, drawObj_TaktLine

    #messageBox('-Taktb','no='+str(no)+': '+str(drawObj_TaktPfeil))
    for st in range(4):
        if drawObj_TaktPfeil[st][no]!='NA':
            drawObj_TaktPfeil[st][no].parentNode.removeChild(drawObj_TaktPfeil[st][no])
            drawObj_TaktPfeil[st][no]='NA'

    if drawObj_TaktLine[no]!='NA':
        drawObj_TaktLine[no].parentNode.removeChild(drawObj_TaktLine[no])
        drawObj_TaktLine[no]='NA'

taktWert=1
taktReset=0

def set_Taktnummern(score):
    #Taktnummerierung im Nachgang eintragen
    global Taktnummerierung, taktWert, taktReset

    for system in score.getElementsByTagName('system'):
        for drawgroup in system.getElementsByTagName('group'):
            for basic in drawgroup.getElementsByTagName('basic'):
                tag=basic.getAttribute('tag')
                if tag=='2086-118':
                    ddtxts=drawgroup.getElementsByTagName('text')
                    cont=ddtxts[0].getElementsByTagName('content')
                    taktnummerBasisStr=cont[0].firstChild.nodeValue     #String-Liste: ['TaktBasis','reset']
                    taktBasisWerte=taktnummerBasisStr[1:-1].split(",")
                    ResetCount=int(taktBasisWerte[1])
                    if ResetCount!=taktReset:   #Reset Numerierung (nderungserkennung)
                        taktReset=ResetCount
                        taktWert=1
                    takt=taktWert+int(taktBasisWerte[0])
                    if (Taktnummerierung>0) and (takt % Taktnummerierung == 0):
                        cont[0].firstChild.nodeValue=str(takt)
                    else:
                        cont[0].firstChild.nodeValue=''
                    taktWert+=1


def drawQuerlinie(obj, delta, farbe):
    global FarbenListeX, NFarbe

    newDos      = addElementNode(obj,'drawObjects')
    newdrawObj  = addNewElementNode(newDos,'drawObj')
    newSlur     = addElementNode(newdrawObj,'slur')
    newForm     = addElementNode(newSlur,'form')
    newBasic    = addElementNode(newdrawObj,'basic')
    newBasic.setAttribute('noAdjust','true')
    newBasic.setAttribute('noteRange',str(delta))

    #newBasic.setAttribute('behindNotes','true')   # 'Behind Note' macht rger mit Taktlinien
    newSlur.setAttribute('x1','1.7')
    newSlur.setAttribute('y1','0')
    #Attribute x2,y2,x3,y3 :default=0
    newSlur.setAttribute('x4','0')
    newSlur.setAttribute('y4','0')
    newSlur.setAttribute('color',farbe)
    newForm.setAttribute('endWidth','0.1875')
    newForm.setAttribute('midWidth','0.21875')   #??warum?? Bei dem Wert 0.2 macht Capella nur Punkte
    newForm.setAttribute('dotDist','2')
    newForm.setAttribute('dotWidth','0.8')


def calcQuerlinie(chords, Type, AkkordIx):
    global Melodiestimmen, StimmenNutzung, FarbenListeX, NFarbe, QuerlinieFarbig
    # Stimmen sind gekennzeichnet als "Melodie" (StimmenNutzung=0) oder Begleitung (StimmenNutzung>0)
    # AkkordIx: Index der Noten in der Zeile
    # Wenn AkkordIx[st] mehrere Eintrge hat, dann auch dazu Querlinien setzen
    # Wenn Melodiestimme, dann ist sie in AkkordIx[st][0]

    stAnker=[0,0,0,0]
    AnkerStartZiel=[]    #offene Liste, mit append anhngen??

    for st in range(4):
        stAnker=[]
        if StimmenNutzung[st]==0: #st ist Melodiestimme
            stAnker+=AkkordIx[st][:]
            Mst=st+1       # Mst ist gesuchter Eintrag in StimmenNutzung
            for i in range(4):
                if StimmenNutzung[i]==Mst:
                    stAnker+=AkkordIx[i]        #alle Noten, die zur Stimme gehren

            if len(stAnker)>1:
                stAnker.sort()                  #indices sortieren
                AnkerStartZiel.append([stAnker[0],abs(stAnker[0]-stAnker[-1])])   #kleinster Index + max. Delta

            #if messageBox('querx('+str(i)+')','st: '+str(st)+', Mst: '+str(Mst)
            #    +'\nAkkordIx: '+str(AkkordIx)
            #    +'\nstAnker: '+str(stAnker)+'\nStartZiel: '+str(AnkerStartZiel)
            #    +'\nStimmenNutzung: '+str(StimmenNutzung),0,1)==0:
            #    raise Abbruch

    farbe = FarbenListeX[11]
    for ql in range(len(AnkerStartZiel)):
        StartZiel=AnkerStartZiel[ql]
        lineAnker=StartZiel[0]
        deltaIndex = StartZiel[1]

        if deltaIndex != 0:  # wenn nicht Unisono oder beides Pausen
            drawQuerlinie(chords[lineAnker-1], deltaIndex, farbe)


AnzahlTaktSigns=0

def AuswertenTimeSign(timeSignLok):
    global takt, AnzahlTaktSigns
    #messageBox('TS',str(timeSign))
    AnzahlTaktSigns=AnzahlTaktSigns+1
    if timeSignLok == 'infinite':
        taktNbruch=10000     #Taktzeichen nur ber feste Taktstriche
    else:
        if timeSignLok == 'C':
            takt = '4/4'
        elif timeSignLok == 'allaBreve':
            takt = '2/2'
        elif timeSignLok == 'longAllaBreve':
            takt = '4/2'
        else:
            takt = timeSignLok
        taktTeilung = takt.split("/",2)
        zaehler = float(taktTeilung[0])
        nenner  = float(taktTeilung[1])
        taktNbruch = zaehler / nenner

    return (taktNbruch, AnzahlTaktSigns)


def suppressNoteLines(score):
    # Notenlinien weg
    global  rastral, abstand

    for notation in score.getElementsByTagName('notation'):                                        # Notenlinien weg
        notation.setAttribute('notelines',"")
    for barCount in score.getElementsByTagName('barCount'):                                        # Taktzhlung weg
        barCount.setAttribute('barInterval',"0")
    for staffLayout in score.getElementsByTagName('staffLayout'):                                  # Abstnde der Notenzeile untereinander setzen
        for distances in staffLayout.getElementsByTagName('distances'):
            distances.setAttribute('top',"0")
            distances.setAttribute('bottom',str(abstand))                                          # Zeilenabstand setzen
    for layout in score.getElementsByTagName('layout'):
        for notespace in layout.getElementsByTagName('noteSpaces'):
            notespace.setAttribute('firstNote','0')
        for systems in layout.getElementsByTagName('systems'):                                     # Abstand ber erstem System setzen, Seitenjustage aus
            systems.setAttribute('top',"4")
            systems.setAttribute('between',"0")
            removeAttr(systems,'pageJustified')
        for styles in layout.getElementsByTagName('style'):                                     # System-Separator aus
            removeAttr(styles,'systemSeparators')
    for staffLines in score.getElementsByTagName('staffLines'):                                    # Rastral setzen
        staffLines.setAttribute('normal',stauchung.get(rastral,'0'))                               # Stauchungsfaktor einlesen


def calcPageDefinition(score):
    # Papierformat einrichten: links / rechts / Quadratisches Papier / Anlegekanten
    # druckLayout: 0=links, 1=rechts,2=quadrat
    global instrument, druckLayout, horizAbstVar
    global paperDef, paperSizeX, paperSizeY, abstandSaiten, anzahlSaiten
    global XanlegeKanten, linkerRand, rechterRand

    linkerRand = paperDef.get('Left')
    if horizAbstVar==0:
        notwendigeBreite = abstandSaiten[0] * (anzahlSaiten[instrument]-1) + abstandSaiten[1]  #letzte Saite immer 1/16-Note
        if instrument==0 or instrument==2:
            linkerRand = paperDef.get('LeftKlein')   #linker Abstand kleiner
        elif instrument==8:
            linkerRand = paperDef.get('LeftSolo')    #linker Abstand kleiner

        XanlegeKanten[0]=offsetAnlegekante
        XanlegeKanten[1]=offsetAnlegekante+(notwendigeBreite-abstandSaiten[1])/UmrechnungVonMM
    else:
        notwendigeBreite = abstandSaiten[0] * (anzahlSaiten[instrument]-3) + 3*abstandSaiten[1]  #erste Saite und letzte 2 Saiten 1/16-Noten-Abstand
        if instrument==8:
            linkerRand = paperDef.get('LeftSoloOpt')    #linker Abstand kleiner

        XanlegeKanten[0] = offsetAnlegekante + abstandSaiten[1]/UmrechnungVonMM   #Anlegekanten auf 2.Saite
        XanlegeKanten[1] = offsetAnlegekante + (notwendigeBreite-2*abstandSaiten[1])/UmrechnungVonMM

    if druckLayout==2:
        SizeX=paperSizeY[instrument]
    else:
        SizeX=paperSizeX[instrument]

    rechterRand = max(0,SizeX - notwendigeBreite - linkerRand)

    if druckLayout==1:      # rechten und linken Rand vertauschen --> rechtsbndig drucken, damit kann Blatt fr Sopran+Solo-Harfe genutzt werden
        xxx=linkerRand
        linkerRand=rechterRand
        rechterRand=xxx

    for pages in score.getElementsByTagName('pages'):                                              # Druck-Seitenlayout setzen
        pages.setAttribute('left',str(linkerRand))
        pages.setAttribute('right',str(rechterRand))
        pages.setAttribute('top',str(paperDef.get('Top')))
        pages.setAttribute('bottom',str(paperDef.get('Bottom')))
        if druckLayout==2:          # Papier quadratisch
            removeAttr(pages,'paperSize')
            removeAttr(pages,'landscape')
            pages.setAttribute('paperSizeX',str(paperSizeY[instrument]))
            pages.setAttribute('paperSizeY',str(paperSizeY[instrument]))
        else:
            removeAttr(pages,'paperSizeX')
            removeAttr(pages,'paperSizeY')
            if paperSizeX[instrument]==420:
                paperSize = 'A3'
            else:
                paperSize = 'A4'
            if paperSizeX[instrument]>paperSizeY[instrument]:
                landscape='true'
            else:
                landscape='false'
            pages.setAttribute('paperSize',paperSize)
            pages.setAttribute('landscape',landscape)

    #if messageBox('Page','L='+str(left)+'; Saiten='+str(anzahlSaiten[instrument])
    #          +'\n notwendigeBreite= '+str(notwendigeBreite)+ '; rechts= '+str(rechterRand)+
    #          '\n; SizeX= '+str(paperSizeX[instrument]),0,1)==0:
    #    raise Abbruch

def checkRange(voice):
    # berprfung ob der Tonumfang fr das Instrument stimmt
    global notenDictLok, instrument

    rot = 0
    noteObjects = voice.getElementsByTagName('noteObjects')
    for child in noteObjects[0].childNodes:
        if child.nodeType == child.ELEMENT_NODE:
            if child.tagName == 'chord':
                Pitches=getPitch(child)  #mit Vorzeichen (h != b)
                if 'NN' in Pitches:
                    rot = 1
                    new = addElementNode(child,'display')              # Original Note
                    new.setAttribute('color',str('E00050'))            # rot einfrben
    return rot


def anlegekanteEinfuegen(score):
    # Anlegekante einfgen
    global instrument, anzahlSaiten, notenNamenLok
    global datumprint, paperSizeY, anlegeKante, horizAbstVar
    global XanlegeKanten

    y2 = (paperSizeY[instrument]-paperDef.get('Top')-paperDef.get('Bottom'))/UmrechnungVonMM -2
    y1 = y2-7

    newPO = getNodePO(score)

    for i in range(2):
        #i=0 --> links / i==1 --> rechts
        x = XanlegeKanten[i]
        if i==0:
            if datumprint==1:
                now = [time.strftime("%d.%m.%Y")]
                insertTextOnPage(score,now,['000000'],'9','1',str(x+1.5),str(y2),'500','false', 'false','false','2086-119')            # Datum ausdrucken
            if not anlegeKante in [1,3]:                      # Anlegekante links oder beide
                continue
            notenNr=2
        if i==1:
            if not anlegeKante in [2,3]:                      # Anlegekante rechts oder beide
                continue
            notenNr=anzahlSaiten[instrument]-1
        newDO = addNewElementNode(newPO,'drawObj')
        newLine  = addNewElementNode(newDO,'line')
        if horizAbstVar == 1:                                 # Anlegekante an 2.Saite -->   Hinweis: Anlegekante auf 2. und vorletzte Saite (Gis / fis"
            insertTextOnPage(score,[notenNamenLok.get(notenNr,' ')],['000000'],'9','1',str(x-0.5),str(y1-1),'900','false', 'false','false','2086-199')
        newLine.setAttribute('x1',str(x))
        newLine.setAttribute('x2',str(x))
        newBasic = addNewElementNode(newDO,'basic')
        newBasic.setAttribute('noAdjust',"true")
        newBasic.setAttribute('tag','2086-119')

        newLine.setAttribute('y1',str(y1))
        newLine.setAttribute('y2',str(y2))
        newLine.setAttribute('lineWidth',"0.4")



FirstLine=1   #zur Ausgabe Notenzeile

def appendEmptySystem(score,noLine,text):
    #leeres System anhngen
    #noLine=1: Tag '2086-115' an Element 0 schreiben, damit Notenlinien unterbrochen werden
    #text: Text zur Diagnose mit an Element 0 hngen
    global namenprint, rastral, FirstLine, notenNamenLok, lineCount
    global instrument
    #messageBox('NAMEN1',str(FirstLine) + '\n' + str(namenprint))

    lineCount=lineCount+1
    objList = getElementObjects(score.childNodes)

    newSystem = addNewElementNode(objList[-1],'system')
    newSystem.setAttribute('tempo',"120")
    newSystem.setAttribute('justified',"true")
    newSystem.setAttribute('leftIndent',"0")
    newStaves = addNewElementNode(newSystem,'staves')
    newStaff  = addNewElementNode(newStaves,'staff')
    newStaff.setAttribute('layout',"Tischharfe")        #genderte Bezeichnung
    newStaff.setAttribute('defaultTime',"infinite")
    newVoices = addNewElementNode(newStaff,'voices')
    newVoice  = addNewElementNode(newVoices,'voice')
    newLyric  = addNewElementNode(newVoice,'lyricsSettings')
    newLyric.setAttribute('firstLine',"5")
    newLyric.setAttribute('lineDist',"5")
    newFont  = addNewElementNode(newLyric,'font')
    newFont.setAttribute('face',"Arial")
    newFont.setAttribute('hight',"12")
    newOS1 = addNewElementNode(newVoice,'noteObjects')
    saitenzahl=anzahlSaiten[instrument]

    x = 1
    while x <= saitenzahl:
        newCh = addNewElementNode(newOS1,'chord')
        newDur = addNewElementNode(newCh,'duration')
        newDur.setAttribute('base',"1/4")
        if (horizAbstVar == 1 and (x == 1 or x == saitenzahl-1)):
            newDur.setAttribute('base',"1/16")      #1 und vorletzte Note = 1/16 --> 1. und letzte Note rcken nach innen
        if x == saitenzahl:
            newDur.setAttribute('base',"1/16")      #letzte Note immer 1/16 --> nahe an Rand
        newStm = addNewElementNode(newCh,'stem')
        newStm.setAttribute('invisible',"true")

        newHds = addNewElementNode(newCh,'heads')
        newHd  = addNewElementNode(newHds,'head')
        newHd.setAttribute('pitch',"B5")
        newHd.setAttribute('shape',"none")

# keine Abfrage auf ixs, da die Nummer abhngig ist von der Anzahl System im Original
        if namenprint == 1 and FirstLine==1:                                         # im ersten System Notennamen hinterlegen
            nton = notenNamenLok.get(x,' ')
            FontSize = StdFontSize.get(rastral,'0')                                  # fontsize fr Notenberschrift an Rastral anpassen
            insertText(score,newCh,nton,FontSize,'000000','NA', '0', '-4', '0', 'false','center')
        if x==1:
            if noLine:
                insertText(score,newCh,text,'12','000000','2086-115', '0','0','700','false','0')
            else:
                if len(text)>0 and debugging==2:   #nur fr debugging
                    insertText(score,newCh,text,'10','000000','2086-xyz', '0','0','0','false','0')
            #if len(text)>0:  #fr Diagnose
            #    if messageBox ('EmptyLine','Grund: '+text+', noLine='+str(noLine),0,1)==0:
            #        raise Abbruch

        x=x+1
    FirstLine=0
    return (newOS1)


def checkEndTie(tonLok):
    #prfen ob an der Note ein tie=end dranhngt

    heads = tonLok.getElementsByTagName('heads')
    head  = heads[0].getElementsByTagName('head')
    tie   = head[0].getElementsByTagName('tie')

    if tie:
        end = tie[0].getAttribute('end')
        #messageBox('TIE',str(begin))
        if end == 'true':
            tie = 'YES'
        else:
            tie = 'NA'
    else:
        tie = 'NA'
    return tie


nIx      = [15,7,5,3]
nIxSave  = [7,7,7,7]
AkkordIxNeu=[[],[],[],[]]
IxNeu    = ['NA','NA','NA','NA']
chordsMax   = 'NA'
typeBarLine = 'NA'
newOS       = 'NA'
chordsAktZeile =[]

def appendSystem(score, toene, Pitches, base, dots, Type):
    # vorbereitetes System mit Platzhaltern anhngen

    global form, chordOldRep, chordsAktZeile, typeBarLine, segno, FirstLine
    global instrument, rastral, ton, BkNumber, BkRange
    global nIxSave, AkkordIxNeu, nIx, IxNeu, pause, ersterTon, takt, taktinhalt, auftaktprint, timeSign, taktNbr, namenprint
    global volta, voltaSave, voltaStringR, voltaStringF, chordsMax
    global NFarbe, vfarbe, laengeTon, showAuftakt, notengroesse, FontFace
    global Melodiestimmen, StimmenNutzung, AkkordeNutzbar, AkkordeVerworfen, trioform, circleObj, circleSave, circleIdxSave,abstand, leer
    global notenDictLok, barline4Takt, drawObj_TaktPfeil, drawObj_TaktLine, taktinhWdh, ersterTakt
    global newOS, pageTaktObjKoordVH, pageStimmeObjKoordVH     #, TypeAlt

    #if messageBox('Append System - Interface','volta = ' + str(volta) + '\nvoltaSave =' + str(voltaSave)
    #            + '\nType = ' + str(Type)
    #            + '\nTon = ' + str(toene[0]) + ' / ' + str(Pitches)
    #            + '\nIx Neu = ' + str(IxNeu) +'    nIx = ' + str(nIx) +'    nIxSave = ' + str(nIxSave)
    #            + '\ntoene[1] = ' + str(toene[1]) + '   base = ' + str(base),0,1)==0:
    #    raise Abbruch

    circleIdxSave=-20
    circleSave  ='NA'

    saitenzahl=anzahlSaiten[instrument]
    druckeTakt=0
    druckeTaktStrich=0
    tagExtRechts=str(int(IxNeu[0]=='NA'))     #Wenn oberste Note nicht da ist, dann dafr sorgen, dass Pfeile immer Rechts laufen

# Leerzeile bei endStrich, doppelstrich
# zustzliche Leerzeile bei Abstand=1 oder "zustzlich" parametriert (leer=1)
#   bei endStrich, doppelstrich, repEnd mit Voltenklammer, repEndBegin ( mit Voltenklammer?), repBegin
# Linienunterbrechung bei endStrich, doppelstrich, repEnd mit Voltenklammer, repEndBegin mit Voltenklammer
# Text mit Rahmen behandeln wie Doppelstrich (Linienunterbrechung, ggf. zustzliche Leerzeile)

    Linienbruch=circleObj!='NA'
    if Type[0]=='BL':                                                     # jetzt kommt eine Barline
        typeBarLine='NA'
        if toene[0].tagName == 'barline':                                 # Test ob flschlicherweise der feste Taktstrich nur in der Begleitstimme steht V 2.7.8
            typeBarLine='fest'                                            #fester einfacher Taktstrich hat keinen typeBarLine
            if toene[0].hasAttribute('type'):
                typeBarLine  = toene[0].getAttribute('type')
        barline4Takt=typeBarLine                                          # merken fr TaktPfeile

        Linienbruch=Linienbruch or (typeBarLine in ['double','end']) or (typeBarLine in ['repEnd','repEndBegin'] and voltaStringR<>'NA')
        if FirstLine==0 and typeBarLine in ['double','repEnd']:   # nicht: 'end'
            appendEmptySystem(score,Linienbruch,typeBarLine)      #Linien unterbrechen
            #if messageBox ('AE','Type0: '+str(Type[0])+',  voltastrinR='+str(voltaStringR)
            #    +'\nBruch='+str(Linienbruch)+',  circleObj='+str(circleObj)
            #    +'\ntypeBarLine='+str(typeBarLine),0,1)==0:
            #    raise Abbruch

    if FirstLine==0 and (abstand==1 or leer==1) and (Linienbruch or (typeBarLine =='repBegin' and Type[0]=='BL')):
        appendEmptySystem(score,Linienbruch,typeBarLine)                  # zustzliche Leerzeile
    if Type[0]=='BL':                                                     # jetzt kommt eine Barline
        if typeBarLine in ['repEnd','repEndBegin']:                                              # Wiederholungszeichen vorbereiten
            el = chordOldRep
            #if messageBox ('Rep101','IxNeu: '+str(IxNeu)+'   tagExt='+str(tagExtRechts)+' \nvoltaR/F: '+str(voltaStringR)+' / '+str(voltaStringF),0,1)==0:
            #    raise Abbruch
            insertText(score,el,'repEnd','12','000000','2086-101-'+tagExtRechts+'-'+voltaStringR, '0','0','0','false','0')
            voltaStringR='NA'
            if typeBarLine == 'repEnd':
                typeBarLine = 'NA'
            elif typeBarLine == 'repEndBegin':
                typeBarLine = 'repBegin'

        markSegno(score,chordsAktZeile, nIx, chordsMax,tagExtRechts)
        return
#-------------

    if (volta==1 or voltaSave==1) and chordsMax!='NA':
#        tagExtRechts=str(int(IxNeu[0]=='NA'))     #Wenn oberste Note nicht da ist, dann dafr sorgen, dass Pfeile immer Rechts laufen
        #if messageBox('Volta','   IxNeu='+str(IxNeu)+'   tagExt='+str(tagExtRechts)+'\nvoltaStringF/R: '+str(voltaStringF)+'/'+str(voltaStringR),0,1)==0:
        #    raise Abbruch
        insertText(score, chordsMax,'startVolta1','12','000000','2086-107-'+tagExtRechts,'0','0','700','false','0')
        volta = 0
        voltaSave = 0


#    nIxalt=nIx[0]    #evtl. fr messageBox
    maxIx=0
    verschiebenX=[0.49, 0.49, 0.49, 0.49]
    verschiebenY=[0, 0, 0, 0]
    IxNeu=['NA','NA','NA','NA']

    AkkordIx=[[],[],[],[]]
    showPausenZeichen=['N','N','N','N'] #Werte: P=Pause zeigen, N=Note zeigen, U=Anzeige unterdrcken

    gleicheNote=0
    #if messageBox ('Ix','ersterTon: '+str(ersterTon)+'  IxNeu: '+str(IxNeu)+' maxIx='+str(maxIx)+' \nnIxSave='+str(nIxSave)+'  nIx:'+str(nIx)+'  \nPitches: '+str(Pitches)+'  type:'+str(Type),0,1)==0:
    #    raise Abbruch
    for st in range(4):
        if Melodiestimmen[st]>=0:           #?genutzt
            #Verarbeitung Einstellung "Pause" hier neu strukturiert
            if pause == 0:                                          # Pause immer anzeigen
                showPausenZeichen[st]='P'
            elif pause == 1 and ersterTon[st] == 'R':               # Pause nur bei "erstem Ton", sonst als "berbundene Note"
                showPausenZeichen[st]='P'
            elif pause == 2:                                        # Bei Mel wie pause==1, bei Begleitung: bei "erstem Ton" unterdrcken, sonst als "berbundene Note"
                if StimmenNutzung[st]==0:
                    if ersterTon[st] == 'R':
                        showPausenZeichen[st]='P'
                else:
                    if ersterTon[st] == 'R':
                        showPausenZeichen[st]='U'
                    #else: 'N' (default)
            else:   #pause==3                                        # Bei Mel wie pause==0, bei Begleitung: bei "erstem Ton" Pause anzeigen, sonst unterdrcken
                if StimmenNutzung[st]==0:
                    showPausenZeichen[st]='P'
                else:
                    if ersterTon[st] == 'R':
                        showPausenZeichen[st]='P'
                    else:
                        showPausenZeichen[st]='U'

            if Pitches[st][0] != 'NA':                                  # Stimme bearbeiten
                if len(Pitches[st])>1 and not AkkordeNutzbar[st]:
                    Pitches[st]=Pitches[st][:1]                         #nur den ersten Ton (index=0) nehmen (je nach Parameter akkordTon ist das der hchste oder niedrigste Ton)
                    AkkordeVerworfen[st]=True                           #Fr Hinweis am Ende des Scripts

                for akk in range(len(Pitches[st])):
                    AkkordIx[st].append(notenDictLok[Pitches[st][akk]]['wert'])

                AkkordIxNeu[st]=AkkordIx[st]
                nIx[st]=AkkordIx[st][0]
                IxNeu[st]=nIx[st]
                maxIx=max(maxIx,nIx[st])
            elif Type[st]=='R':
                if showPausenZeichen[st]!='U':
                    AkkordIx[st]=AkkordIxNeu[st]                       #Vorinitialiseren wegen "Pausen"
                if showPausenZeichen[st]=='P':
                    maxIx=max(maxIx,nIx[st])
                    IxNeu[st]=nIx[st]
                    if len(AkkordIx[st])==0:
                        AkkordIx[st]=[nIx[st]]
            if nIxSave[st] == nIx[st]:
                gleicheNote=1
            nIxSave[st] = nIx[st]

        else:
            nIx[st]='NA'
    #if messageBox('Pause '+str(pause),'PausenZeichen:'+str(showPausenZeichen)+',  Type: '+str(Type)+';  nIx/nIxSave= '+str(nIx)+' / '+str(nIxSave)+'\nAkkordIx='+str(AkkordIx),0,1)==0:
    #    raise Abbruch

    if gleicheNote==1 and abstand==1:
        appendEmptySystem(score,0,'abst1')

    #if messageBox('newLine',str(st)+': Type: '+str(Type)+';  AkkordIx='+str(AkkordIx)
    #    +'\nnIx/nIxSave/IxNeu= '+str(nIx)+' / '+str(nIxSave)+' / '+str(IxNeu),0,1)==0:
    #    raise Abbruch
    newOS = appendEmptySystem(score,0,'normal')
    chordsAktZeile=newOS.getElementsByTagName('chord')

    flat_list = [item for l in AkkordIx for item in l]
    for st in range(4):
        if Type[st]=='R' and showPausenZeichen[st]=='P':        #sichtbare Pausen wegschieben bei gleichem Pitch
            xdifp=0
            xdifn=0
            if flat_list.count(nIx[st])>1:      #Index mehrfach
                while flat_list.count(nIx[st]-xdifn)>0:
                    if nIx[st]-xdifn<=1:
                        xdifn=1000  #Wert gro machen --> wird nicht genommen
                        continue
                    xdifn=xdifn+1
                while flat_list.count(nIx[st]+xdifp)>0:
                    if nIx[st]+xdifp>=saitenzahl:
                        xdifp=1000  #Wert gro machen --> wird nicht genommen
                        continue
                    xdifp=xdifp+1
                if xdifp<xdifn:                 # minimale Verschiebung
                    nIx[st]=nIx[st]+xdifp
                else:
                    nIx[st]=nIx[st]-xdifn
                #messageBox('verschW',str(st)+'\nnIx/IxNeu= '+str(nIx)+' / '+str(IxNeu)+', Saiten='+str(saitenzahl)+'\nxdifp/n: '+str(xdifp)+'/'+str(xdifn))
                IxNeu[st]=nIx[st]
                AkkordIx[st][0]=nIx[st]
                maxIx=max(maxIx,nIx[st])        #bei nderung: maxIx nachziehen

    #if messageBox('newLine2',str(st)+': Type: '+str(Type)+';  AkkordIx='+str(AkkordIx)
    #    +'\nnIx/nIxSave/IxNeu= '+str(nIx)+' / '+str(nIxSave)+' / '+str(IxNeu)+'\nflat: '+str(flat_list),0,1)==0:
    #    raise Abbruch

    Doppel=[0,0,0,0]
    DoppelWerte=[]

    for st in range(4):
        lenAkk=len(AkkordIx[st])
        if lenAkk>0:
            for st1 in range(lenAkk):
                dopWert=AkkordIx[st][st1]
                if flat_list.count(dopWert)-1>0:  #Index mehrfach
                    dw=DoppelWerte.count(dopWert)
                    if dw>0:
                        Doppel[st]=dw
                    DoppelWerte.append(dopWert)
    for st in range(4):
        #messageBox('d',str(st)+'\nDoppel= '+str(Doppel)+', Werte= '+str(DoppelWerte))
        if StimmenNutzung[st]==0 or linie==0 or Doppel[st]>0:  # (alt: ==-1)  #nur bei Melodie --> doppelte Note verschieben
            verschiebenX[st]= verschiebenX[st]-(1 * Doppel[st])
            verschiebenY[st]=  0.3 * Doppel[st]
            #if messageBox('Doppelt '+str(linie),str(st)+' verschiebenX='+str(verschiebenX)+' verschiebenY='+str(verschiebenY)+
            #    '\nIxNeu '+str(IxNeu)+'\nbase '+str(base)+',  dots '+str(dots)+'  doppelt '+str(Doppel)+
            #    '\n'+str(Melodiestimmen)+' / '+str(StimmenNutzung),0,1)==0:
            #    raise Abbruch

    if Type[0] != 'NA' and Type[0] != 'BL':                                                        # Taktstellung in Melodiestimme berechnen
        if base[0] == '1/16':                                                                      # vor der Schleife, damit TaktPfeil ggf. in beiden Stimmen gedruckt werden kann
            laengeTon= 0.0625
        elif base[0] == '1/8':
            laengeTon= 0.125
        elif base[0] == '1/4':
            laengeTon= 0.25
        elif base[0] == '1/2':
            laengeTon= 0.5
        else:
            laengeTon= 1
        if dots[0] == '1':
            laengeTon = laengeTon * (1+ 0.5)
        if BkNumber[0] == '3' and BkRange[0] != 'NA':                                              # Triole
                                                                                                   # laengeTon = laengeTon *2 /3     # macht Probleme mit Rechengenauigkeit
            laengeTon = laengeTon *2 /3 + 0.0001                                                   # daher einen kleinen Wert dazu addieren und Takt auf ">=" prfen

# Taktsymbol / Status Auftakt-Kennzeichnung:
# Wiederholungszeichen muss nicht auf vollem Takt sein
# --> bei festem Taktstrich wird rckwrts Pfeil an Wdh-Zeichen gelscht oder an Start, je nach Status
# Status 0: 'Start' immer Takt drucken
# Status 1: Fester Taktstrich und Takt voll: Auftaktbehandlung zu Ende. Takt drucken
# Status 2: Fester Taktstrich und Takt nicht voll: Auftaktbehandlung zu Ende, Takt ist "Auftakt", alle Takt vorher (0) und (1) lschen
# Status 3: kein Taktstrich und Takt voll:
#                     vorher Wdh-Zeichen --> Wdh-Zeichen war "richtiger Taktstrich" und Auftakt
#                                        --> gemerkten Takt(1) lschen, Auftakt Ende
# Status 4: kein Taktstrich und Takt voll:
#                     vorher keine Wdh: Auftaktbehandlung zu Ende. Takt drucken
# Status 5: Wdh-Zeichen und Takt voll: wie Status 1, Auftaktende
# Status 6: Wdh-Zeichen und Takt nicht voll: vorhergehenden Pfeil in (1) merken

# Status "Auftakt Ende": Takt drucken
#
# Anzeigen: Taktlinien (ein oder aus) / Taktpfeile: Auftakt / 1. Ganzer Takt / Immer
#                                            bei Auftakt/1. Takt: Taktpfeile zhlen, es darf nur 1 angezeigt sein

# Nach Auswertung der Takte ggf. neue Taktnummern anzeigen (siehe eigene Routine set_Taktnummern
        #messageBox('DruckTakt','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
        dbgTaktAnz=''
        #if messageBox('DruckTakt '+ str(taktNbr),'Taktinhalt = ' + str(taktinhalt) + '\ndrawObj_TaktPfeil = ' + str( drawObj_TaktPfeil)
        #+'\nlaengeTon = '+str(laengeTon) +',   barline = '+ str(barline4Takt) + ', taktwdh ='+ str(taktinhWdh),0,1)==0:
        #   raise Abbruch
        dbgTaktAnz='nichts'
        if showAuftakt==0:                                                  # Auftaktbehandlung
            #messageBox('DruckTakt','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
            if ersterTakt==1:
                #messageBox('D1','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
                ersterTakt=0
                dbgTaktAnz='start'
                druckeTaktStrich=1
                if auftaktprint>0:
                    druckeTakt = 1
                else:
                    druckeTakt = 0                                          # Pfeil auf erster Note wenn 1.Takt Volltakt ist, nur wenn auftaktprint == 0 verhindern
            elif barline4Takt=='fest':                                      # fester Taktstrich
                #messageBox('D2','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
                if taktinhalt < taktNbr:                                    # Takt nicht voll
                    dbgTaktAnz='fester Takt, nicht voll'
                    remove_TaktAnzeige(1)
                    druckeTakt = 1                                          # auf jeden Fall Pfeil
                else:
                    #messageBox('D2a','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
                    dbgTaktAnz='fester Takt'
                    if auftaktprint == 2:
                        druckeTakt = 1                                      # Pfeil nur wenn alle Pfeile
                druckeTaktStrich=1
                remove_TaktAnzeige(0)
                showAuftakt= 1
                taktinhalt = 0
            elif barline4Takt == 'NA' and taktinhalt>=taktNbr:
                #messageBox('D3','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt)
                #+'\ntaktinhalt='+str(taktinhalt)+', taktNbr='+str(taktNbr) +', taktinhWdh='+str(taktinhWdh))
                if taktinhWdh !='NA':   # war vorher Wiederholung, die nicht auf Taktende war?
                    if taktinhalt-taktinhWdh < taktNbr:   # war vorher Wiederholung, die nicht auf Taktende war?
                        dbgTaktAnz='vorher wdh'
                        taktinhalt=taktinhalt-taktinhWdh                        # Wdh-Zeichen war "Takt-strich", Zaehler korr.
                        remove_TaktAnzeige(1) #gemerkten Takt lschen
                    else:
                        dbgTaktAnz='Ganztakt nach Wdh'
                        taktinhalt=0
                        if auftaktprint == 2:
                            druckeTakt = 1
                        remove_TaktAnzeige(1) #gemerkten Takt lschen
                        druckeTaktStrich=1
                    showAuftakt= 1
                    taktinhWdh='NA'
                else:
                    dbgTaktAnz='kein Auftakt'
                    druckeTaktStrich=1
                    if auftaktprint == 2:
                        druckeTakt = 1                                      # Pfeil nur wenn alle Pfeile
                    showAuftakt= 1
                    taktinhalt = 0
            elif (barline4Takt in ['repEndBegin','repBegin', 'repEnd','double']):
                #messageBox('D4','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt))
                if taktinhalt>=taktNbr:
                    dbgTaktAnz='wdh, voller Takt'
                    if auftaktprint == 2:
                        druckeTakt = 1                                      # Pfeil nur wenn alle Pfeile
                    showAuftakt= 1
                    taktinhalt = 0
                    taktinhWdh = 'NA'
                else:
                    dbgTaktAnz='merken'                                              # 2.Pfeil merken
                    for pfs in range(4):
                        drawObj_TaktPfeil[pfs][1] = drawObj_TaktPfeil[pfs][0]
                    drawObj_TaktLine[1]  = drawObj_TaktLine[0]
                    druckeTakt = 1                                          # auf jeden Fall Pfeil
                    taktinhWdh = taktinhalt
                druckeTaktStrich=1

        else:
            if (taktinhalt>=taktNbr or barline4Takt =='fest'):    # Bei Volltakt Anzeigen des Betonungspfeils, Abfrage auf ">=" wegen Ungenauigkeiten bei Triolen
                #messageBox('D5','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt) + '\ntaktinhalt=' + str(taktinhalt) + '\ntaktNbr=' + str(taktNbr) + '\nbarline4Takt=' + str(barline4Takt)+', taktinhWdh='+str(taktinhWdh))
                dbgTaktAnz='takt normal'
                druckeTaktStrich=1
                if auftaktprint == 2:
                    druckeTakt = 1
                taktinhalt = 0
            elif barline4Takt in ['repEndBegin','repEnd']:    #
                #messageBox('D6','auftaktprint=' + str(auftaktprint) + '\nshowAuftakt=' + str(showAuftakt) + '\ntaktinhalt=' + str(taktinhalt) + '\ntaktNbr=' + str(taktNbr) + '\nbarline4Takt=' + str(barline4Takt)+', taktinhWdh='+str(taktinhWdh))
                dbgTaktAnz='merken_nachWdh'                                       #Status 5
                taktinhWdh = 'NA'

        barline4Takt ='NA'

        if timeSign != 'NA':                                                        # neue Taktangabe auswerten
            taktNbr, anzTaktDef = AuswertenTimeSign(timeSign)
            taktinhalt=0
            timeSign='NA'
            if taktprint == 1:
                text = [takt + ' Takt']
                if len(pageTaktObjKoordVH)==0:
                    textx=str(5 + (anzTaktDef-1)*10)  #2. Takt daneben schreiben
                    texty='8'
                else:
                    textx,texty=pageTaktObjKoordVH.pop(0)
                insertTextOnPage(score,text,['000000'],'9','1',textx,texty,'700','false', 'false','false','')             # und Taktangabe ausdrucken (nicht Taktnummer)

        #if messageBox('DruckTakt_nach','Taktinhalt = ' + str(taktinhalt) + ', taktwdh =' + str(taktinhWdh) +'\ndrawObj_TaktLine = ' + str(drawObj_TaktLine)
        #+'\nlaengeTon = '+str(laengeTon) +',  drucke(Pfeil/Strich) = '+ str(druckeTakt)+'/'+str(druckeTaktStrich)
        #+ ',  showAuftakt ='+str(showAuftakt)+ '\n Pfad='+str(dbgTaktAnz),0,1)==0:
        #    raise Abbruch
        taktinhalt = taktinhalt + laengeTon

    chordsMax=chordsAktZeile[maxIx-1]

    for st in range(3,-1,-1):                   #mit Stimme 4 anfangen
        if Melodiestimmen[st]>=0:               #genutzt?
            #if messageBox('loop','st= '+str(st)+': Type= '+str(Type)+
            #    '\nnIx: '+str(nIx)+
            #    '\nAkkordIx  '+str(AkkordIx),0,1)==0:
            #    raise Abbruch
            if Type[st] != 'NA':
                idxNote = nIx[st]   #==AkkordIx[st][0]
                if idxNote==maxIx:
                    if typeBarLine == 'repBegin' or typeBarLine == 'repEndBegin':                                    # Wiederholungsbeginn markieren
                        #messageBox('repBegin',str(st)+': '+str(Type)+'  '+typeBarLine+'  '+str(score)+'\nindex  '+str(idxNote))
                        insertText(score,chordsMax,'repBegin','12','NA','2086-100', '0', '0', '0','false','0')
                        typeBarLine = 'NA'

                newCh = chordsAktZeile[idxNote-1]
                chordOldRep = newCh

                #messageBox('Tie 1',str(st)+':  AkkordIx= '+str(AkkordIx)+'  Type= '+str(Type)+', showPausenZeichen= '+str(showPausenZeichen))
                for akk in range (len(AkkordIx[st])):
                    if StimmenNutzung[st]==0 and akk==0:       #Melodie und nicht Akkord-Ton
                        tagNoTie= '2086-102-'+str(st)
                        tagTie  = '2086-104-'+str(st)
                    else:
                        tagNoTie= '2086-103-'+str(st)
                        tagTie  = '2086-105-'+str(st)

                    newChord=chordsAktZeile[AkkordIx[st][akk]-1]
                    #if messageBox('insertNote','akk: '+str(akk)+' base: '+str(base)+'  idx:'+str(idxNote)+'\n'+str(AkkordIx),0,1)==0:
                    #    raise Abbruch

                    newDos      = addElementNode(newChord,'drawObjects')
                    newdrawObj  = addNewElementNode(newDos,'drawObj')
                    newText     = addNewElementNode(newdrawObj,'text')
                    newFont     = addNewElementNode(newText,'font')
                    newContent  = addNewElementNode(newText,'content')
                    newBasic    = addElementNode(newdrawObj,'basic')
                    newFont.setAttribute('face',Fontfaces[FontFace])
                    newFont.setAttribute('height',str(Notengroessen[notengroesse]))
                    newFont.setAttribute('weight',"2")
                    newFont.setAttribute('charSet','1')
                    newFont.setAttribute('pitchAndFamily','0')
                    newFont.setAttribute('color',FarbenListeX[NFarbe[st]])
                    newText.setAttribute('x',str(verschiebenX[st]))
                    newText.setAttribute('y',str(verschiebenY[st]))

                    if akk==0:
                        markSegno(score,chordsAktZeile, nIx, chordsMax,tagExtRechts)
                        if circleObj!='NA':
                            cC= (doppelteWdhLinien>0 or idxNote-circleIdxSave>7)    #nur mehrfach, wenn Abstand gross oder doppelteWdhLinien eingeschaltet
                            #messageBox('CC='+str(cC), 'x/alt: '+str(idxNote)+' / '+str(circleIdxSave)+', circleSave='+str(circleSave)+'\nStimmenNutzung='+str(StimmenNutzung))
                            if cC:
                                circleSave=circleObj    #bei "doppelten Linien": Circle-Text an alle Noten
                                copyCircle(newCh,idxNote)
                            if cC :
                                circleObj=circleSave
                                circleIdxSave=idxNote

                    if Type[st] == 'C':
                        if checkEndTie(toene[st])=='YES':                                     # prfen ob tie = end an der Note hngt
                            newBasic.setAttribute('tag',tagTie)
                        else:
                            newBasic.setAttribute('tag',tagNoTie)

                        form, gt = KopfForm(FormToene,base[st],dots[st],0)                    # gt=Ganztakt wird ignoriert bei Taktangabe 0
                        newContent.appendChild(doc.createTextNode(form))                      # Kopf einfgen

                    #if messageBox('newDos','st/akk= '+str(st)+'/'+str(akk)+': Type= '+str(Type)+
                    #                    '\n nIx: '+str(nIx)+
                    #                    '\n newCh :' +str(newCh),0,1)==0:
                    #    raise Abbruch
                    if akk==0 and voltaSave >= 2 or (voltaSave==0 and volta>=2):
                                                                    # Melodieton, 1.Ton nach Barline ist Chord, Volta auf Barline, Tag 2 anhngen
                                                                    # Melodieton, 1.Ton nach Barline ist Chord oder Rest, Volta auf dem Ton, Tag 2 anhngen
                        #Voltenstring an Extension zum Tag merken
                        insertText(score,chordsMax,'targetVolta2','12','000000','2086-108-0-'+voltaStringF,'0','0','700','false','0')
                        volta = 0
                        voltaSave = 0
                        voltaStringF='NA'
                    if Type[st] == 'R' and showPausenZeichen[st]!='U':                                                                           # Kopfform setzen - Pause

                        if showPausenZeichen[st]=='P':
                            #messageBox('Tie 1',str(st)+':  Type= '+str(Type)+', showPausenZeichen= '+str(showPausenZeichen)+'   PausenTie='+str(tagNoTie))
                            pauseAufNoten = 0
                            newBasic.setAttribute('tag',tagNoTie)
                            form, gt = KopfForm(FormPause,base[st],dots[st],takt)                                    # Kopfform Pausen
                            if gt==1 and base[st] != '1':                                                            # Mehrtaktpause
                                farbe = FarbenListeX[NFarbe[st]]
                                insertText(score,newChord,base[st],'12',farbe,'NA', '-2', '-0.6', '700', 'true','0')
                        else:
                            pauseAufNoten = 1
                            #messageBox('Pause->Ton','PausenTie='+str(tagTie))
                            newBasic.setAttribute('tag',tagTie)
                            form, gt = KopfForm(FormToene,base[st],dots[st],takt)             # Kopfform Pausen auf Noten ndern wenn im Dialog gewnscht
                            if gt and base[st] != '1':                                        # Mehrtaktpause
                                farbe = FarbenListeX[NFarbe[st]]
                                insertText(score,newChord,base[st],'12',farbe,'NA', '2', '-0.6', '700', 'true','0')

                        newContent.appendChild(doc.createTextNode(form))                      # Kopf einfgen

                    if BkNumber[st] != 'NA' :                                                 # Triole beim Melodieton einfgen
                        if BkRange[st] != 'NA':
                            if trioform == 0:                                                 # Triolenanzeige auserhalb
                                xMt = 2.3+notengroesse*0.7
                                yMt = 0.6
                                farbe=FarbenListeX[NFarbe[st]]
                                tx = str(BkNumber[st])
                                insertText(score,newChord,tx,'12',farbe,'2086-106', str(xMt), str(yMt), '1200', 'true','0')
                                BkRange[st] = int(BkRange[st]) - 1
                                if int(BkRange[st]) == -1:
                                    BkRange[st] = 'NA'
                            else:                                                             # Triolenanzeige innerhalb
                                if Type[st] == 'R':                                           # Position der n-Tole abhngig von der Kopfform setzen
                                    if form == 'K' or form == 'P':
                                        xMt = '0.1'
                                        yMt = '1'
                                    elif form == 'L' or form == 'Q':
                                        xMt = '0.03'
                                        yMt = '0.16'
                                    else:
                                        xMt = '0.125'
                                        yMt = '0.47'
                                else:
                                    xMt = '0.1'
                                    yMt = '0.5'

                                farbe = FarbenListeX[NFarbe[st]]
                                if Type[st] == 'C':
                                    if base[st] in ['1/16', '1/8', '1/4']:
                                        farbe = 'FFFFFF'
                                elif Type[st] =='R':
                                    if (base[st] in ['1/16', '1/8', '1/4']) and pauseAufNoten == 1:
                                        farbe = 'FFFFFF'
                                        pauseAufNoten = 0
                                tx = str(BkNumber[st])
                                insertText(score,newChord,tx,'6',farbe,'2086-106', xMt, yMt, '700', 'true','0')
                                BkRange[st] = int(BkRange[st]) - 1
                                if int(BkRange[st]) == -1:
                                    BkRange[st] = 'NA'

                    if druckeTakt > 0 and StimmenNutzung[st]==0 and akk==0:             # Symbol drucken fr Taktanfang fr Melodiestimme (und obersten Ton eines Akkords) oder Linie=3
                        drawObj_TaktPfeil[st][0]  = draw_TaktPfeil(chordsAktZeile,idxNote-1,st)
    if druckeTaktStrich > 0 :             # Symbol drucken fr Taktanfang fr Melodiestimme (und obersten Ton eines Akkords) oder Linie=3
        drawObj_TaktLine[0]  = draw_TaktStrich(chordsAktZeile)

    circleObj='NA'
    #if messageBox('Zeile','Type-count:'+str(Type)+'/'+str(Type.count('NA'))+'  nIx: '+str(nIx)+'\nAkk: '+str(AkkordIx)+', len: '+str(len(AkkordIx)),0,1)==0:
    #    raise Abbruch
    calcQuerlinie(chordsAktZeile, Type, AkkordIx)          #Abfrage, ob Querlinie gezeichnet werden muss, erfolgt in der Routine

    druckeTakt=0                                                  # Rcksetzen
    druckeTaktStrich=0
    return


def drawLines(score, mode, Mst, st):    #Mst: zugeordete Masterstimme
    # Linien zwischen Melodienoten, bzw Begleitnoten ziehen
    global linie, abstand

    systems = score.getElementsByTagName('system')
    startIx     = 0
    targetIx    = 0
    chordStart  = 'NA'
    chordTarget = 'NA'
    ix          = 0
    stCnt       = 0
    childX      = 0
    childXstart = 0

    taglist02='2086-102-'+str(Mst)
    taglist03='2086-103-'+str(st)
    taglist04='2086-104-'+str(Mst)
    taglist05='2086-105-'+str(st)

    if mode == 'MT':                                                           # Melodienoten oder Begleitnoten
        mTag1 = taglist02
        mTag2 = taglist04
    else:
        mTag1 = taglist03
        mTag2 = taglist05

    startIx = 0
    tagx='NA'
    for sy in range(systems.length):
        found = 0
        ix = 0
        staves = systems[sy].getElementsByTagName('staff')                     # erzeugt Liste mit DOM Elementen - Notenzeilen
        voices = staves[0].getElementsByTagName('voice')                       # erzeugt Liste mit DOM Elementen - Stimmen
        noteObjects = voices[0].getElementsByTagName('noteObjects')            # erzeugt Liste mit DOM Elementen - NoteObjects

        stCnt = stCnt + 1

        mtFound = 0
        btFound = 0
        for child in noteObjects[0].childNodes:
            if child.nodeType == child.ELEMENT_NODE:
                if child.tagName == 'chord':
                    for basic in child.getElementsByTagName('basic'):          # alle Noten der Zeile auf gewnschtes Tag untersuchen
                        tag = basic.getAttribute('tag')
                        if tag == taglist02 or tag == taglist04:
                            mtFound = 1
                        if tag == taglist03 or tag == taglist05:
                            btFound = 1
                        #tagx nur festhalten, wenn vorher schon eine Note gefunden wurde
                        tag=tag[:8]
                        if chordStart!='NA' and (tag in ['2086-108', '2086-113', '2086-115']):       # wenn Volten-Ziel oder Coda-ziel gefunden
                            #messageBox('tagxX',str(mode) + '   ' + str(mtFound) + '    ' + str(btFound) + '    ' + str(chordStart))
                            tagx=tag                                           #tagx merken, bis es "benutzt wurde"
        for child in noteObjects[0].childNodes:
            #messageBox('Slur1','child: '+str(child)+',   node: '+str(child.nodeType))
            if child.nodeType == child.ELEMENT_NODE:
                if child.tagName == 'chord':
                    ix = ix + 1
                    for basic in child.getElementsByTagName('basic'):          # alle Noten der Zeile auf gewnschtes Tag untersuchen
                        tag = basic.getAttribute('tag')
                        #if messageBox('Linedraw',mode+' ix= '+str(ix)+', Ziel= '+str(targetIx)+'   '+child.tagName + ' '+tag+'  '+tagx,0,1)==0:
                        #    raise Abbruch
                        if tag == mTag1 or tag == mTag2:                       # wenn gefunden
                            if chordStart == 'NA':                             # und wenn es das erste Auftreten in der Partitur ist, merken
                                found = 1
                                chordStart = child
                                startIx = ix
                                stCnt = 0
                                break
                            else:                                              # bei Folgeauftritten
                                found = 2                                      # als Zielnote merken
                                chordTarget = child
                                targetIx = ix
                                break

                    if found == 1:                                             # wenn es das erste Auftreten war, nchste Zeile untersuchen
                        break
                    elif found == 2:                                           # wenn es eine Zielnote war
                        #Bearbeitung 'Frame' hier weglassen:
                        #1. keine Linie mehr an Frame, frame-Verschiebung in copyCircle direkt beim Kopieren
                        #2. Linienunterbrechung nur durch "doppelten Taktstrich"

                        if tagx in ['2086-108', '2086-113', '2086-115']:       # wenn Volten-Ziel oder Coda-Ziel gefunden
                            found=1                                            # keine Linie!
                            stCnt = 0
                            startIx = targetIx                                 # alte Zielnote wird jetzt Startnote
                            chordStart = chordTarget
                            childXstart = childX                               # Target X Wert der Verbindungslinie wird jetzt Startwert.
                        tagx='NA'

                    if found == 2:                                             # wenn es eine Zielnote war
                        distance = targetIx - startIx                          # Linie ziehen
                        x2 = 0.3
                        y2 = stCnt * abstand                                   # bersprungene Zeile mit einbeziehen (stCnt) * Zeilenabstand
                        x1 = 0.3
                        y1 = 0

                        if tag == taglist02 or tag == taglist03:             # wenn keine Haltebgen, Noten mit Linie verbinden
                            if tag == taglist03:
                                childX = basic.parentNode.getAttribute('x')
                                if childX == '-1':                             # wenn Unisono, Linie etwas verschieben. childX ist von der Target Note !
                                    x2 = x2 - 1.4                              # Target
                                    y2 = y2 + 0.2
                                if childXstart == '-1':                        # childXstart ist von der Source Note
                                    x1 = x1 - 1.4                              # Source
                                    y1 = y1 + 0.2

                            #if messageBox('XX',str(mode) + '   ' + str(mtFound) + '    ' + str(btFound) + '    ' + str(linie)+' x1='+str(x1)+' x2='+str(x2),0,1)==0:
                            #    raise Abbruch
                            if (mode == 'BT' and mtFound == 0 and btFound == 1 and linie == 2) or (mode == 'BT' and linie == 0) or mode == 'MT':
                                if distance>=0:
                                    newDos  = addElementNode(chordStart,'drawObjects')
                                else:
                                    newDos   = addElementNode(chordTarget,'drawObjects')
                                    y2=-y2
                                newdrawObj   = addNewElementNode(newDos,'drawObj')
                                newLine      = addNewElementNode(newdrawObj,'line')
                                newBasic     = addElementNode(newdrawObj,'basic')
                                newLine.setAttribute('x2',str(x2))
                                newLine.setAttribute('y2',str(y2))
                                newLine.setAttribute('x1',str(x1))
                                newLine.setAttribute('y1',str(y1))
                                newLine.setAttribute('lineWidth','0.2')
                                newBasic.setAttribute('noAdjust','true')
                                newBasic.setAttribute('behindNotes','true')
                                newBasic.setAttribute('noteRange',str(abs(distance)))
                                newLine.setAttribute('color',FarbenListeX[NFarbe[st]])

# der "else"-Zweig zum Zeichnen einer Haltelinie entfllt hier, dazu wird immer drawSlur genutzt
                        stCnt = 0
                        startIx = targetIx                                     # alte Zielnote wird jetzt Startnote
                        chordStart = chordTarget
                        childXstart = childX                                   # Target X Wert der Verbindungslinie wird jetzt Startwert. Unisono Feststellung
                        break


def drawSlur(score, st):
    # Haltebogen an Noten ziehen
    global NFarbe, abstand

    systems = score.getElementsByTagName('system')
    StartChordList=TargetChordList=[]
    #StartSpalteList=TargetSpalteList=[] ##nur fr debug
    StartZeile=TargetZeile=-1
    found=0
    sy_start=-1
    Targettag='NA'

    Tags=['2086-102-'+str(st),'2086-103-'+str(st),'2086-104-'+str(st),'2086-105-'+str(st)]
    #      Melodienote         mit Haltebogen      Begleitnote         mit Haltebogen

    for sy in range(systems.length):
        tag_found=0
        found=0
        chordObjects = systems[sy].getElementsByTagName('chord')               # erzeugt Liste mit DOM Elementen - NoteObjects
        for ch in range (chordObjects.length):
            for basic in chordObjects[ch].getElementsByTagName('basic'):       # alle Noten der Zeile auf gewnschtes Tag untersuchen
                tag = basic.getAttribute('tag')
                if tag in Tags:                                                # wenn gefunden
                    #messageBox('BS',str(tag))
                    tag_found=1
                    if sy_start==-1:
                        StartZeile=sy
                        StartChordList.append(chordObjects[ch])
                        #StartSpalteList.append(ch) ##nur fr debug
                        #messageBox('BS1',str(tag) + ', sy ' + str(sy)+',  sy_start: '+str(sy_start)
                        #+'\nSSpList: '+str(StartSpalteList)+'  TSpList: '+str(TargetSpalteList))
                    else:
                        #messageBox('BS1x',str(tag) + ', sy ' + str(sy)+',  sy_start: '+str(sy_start)
                        #+'\nSSpList: '+str(StartSpalteList)+'  TSpList: '+str(TargetSpalteList))
                        TargetZeile=sy
                        TargetChordList.append(chordObjects[ch])
                        #TargetSpalteList.append(ch) ##nur fr debug
                        Targettag=tag

        if tag_found==1:
            if sy_start==-1:
                found=1
                sy_start=sy
            else:
                found=2
            #if messageBox('BS2','sy: '+str(sy)+'  found: '+str(found)
            #    +'\nTargetag= '+str(Targettag)
            #    +'\nStart/Targetzeile = '+str(StartZeile)+'/'+str(TargetZeile)
            #    +'\nListen S/T: '+str(StartChordList)+'/'+str(TargetChordList),0,1)==0:
            #    raise Abbruch

            if Targettag in Tags[2:] and found==2: # ==Begleitnote
                stCnt=sy-StartZeile
                y3 = str(stCnt * abstand / 1.05)
                y4 = str(stCnt * abstand * 1.05)
                #if messageBox('found '+str(Targettag),'Anzahl: '+str(len(StartChordList))
                #    +'\nStartListen Sp/Z = '+str(StartSpalteList)+'/'+str(TargetSpalteList)+' Cnt: '+str(stCnt)
                #    +'\nListen S/T: '+str(StartChordList)+'/'+str(TargetChordList),0,1)==0:
                #    raise Abbruch
                for st_chord in StartChordList:
                    #messageBox('BS2x',str(st_chord) + ', sy ' + str(sy)+',  sy_start: '+str(sy_start)
                    #  +'\nSSpList: '+str(StartSpalteList)+'  TSpList: '+str(TargetSpalteList))
                    newDos      = addElementNode(st_chord,'drawObjects')
                    newdrawObj  = addNewElementNode(newDos,'drawObj')
                    newSlur     = addElementNode(newdrawObj,'slur')
                    newBasic    = addElementNode(newdrawObj,'basic')
                    newSlur.setAttribute('x1','-0.4')
                    newSlur.setAttribute('y1','0')
                    newSlur.setAttribute('x2','-3.5')
                    newSlur.setAttribute('y2','0.343')
                    newSlur.setAttribute('x3','-3.5')
                    newSlur.setAttribute('y3',y3)
                    newSlur.setAttribute('x4','-0.4')
                    newSlur.setAttribute('y4',y4)
                    farbe = FarbenListeX[NFarbe[st]]                                           # Farbe der Stimme
                    newSlur.setAttribute('color',farbe)
                    newBasic.setAttribute('noAdjust','true')
                    newForm  = addNewElementNode(newSlur,'form')
                    newForm.setAttribute('endWidth','0.2')
                    newForm.setAttribute('midWidth','0.2')

            StartChordList=TargetChordList
            TargetChordList=[]
            #StartSpalteList=TargetSpalteList ##nur fr debug
            #TargetSpalteList=[] ##nur fr debug
            StartZeile=sy
            #if messageBox('endslur','Zeile:'+str(StartZeile)+',  StartSpalteList:'+str(StartSpalteList)+
            #    '\nListen S/T: '+str(StartChordList)+'/'+str(TargetChordList),0,1)==0:
            #    raise Abbruch


noBackground= ['A','B','E','F','I','J']

def hollowHead(score):
    # Hohle Kpfe mit weissem Kreis wirklich aushhlen
    # Hintergrundzeichen zum Fllen der Kpfe im Font definiert parallel zu Note als "Lower"-Zeichen
    # C-> c / H -> h ...
    #ber Liste noBackground werden die Zeichen ohne Hintergrund ausgeblendet

    global FontFace

    for system in score.getElementsByTagName('system'):

        for drawObj in system.getElementsByTagName('drawObj'):
            for basic in drawObj.getElementsByTagName('basic'):
                tag = basic.getAttribute('tag')
                tag=tag[:8] #Anhang der Stimme erst mal berlesen
                if tag in ['2086-102', '2086-103', '2086-104', '2086-105']:
                    for text in basic.parentNode.getElementsByTagName('text'):                     # nur Texte suchen, an denen das Tag steht --> nur 1 x parent
                        x = text.getAttribute('x')
                        y = text.getAttribute('y')                                                 # 3.0.26
                        Font=text.getElementsByTagName('font')
                        groesse=Font[0].getAttribute('height')
                        #messageBox('X',str(x))
                        content = basic.parentNode.getElementsByTagName('content')                 # 3.0.26
                        formNote = content[0].firstChild.nodeValue
                        #messageBox('TEST0',str(form) + '\n' + str(x)+'\ntext '+str(Font[0].getAttribute('face')))
                        if formNote not in noBackground:
                            newDos      = addElementNode(drawObj.parentNode.parentNode,'drawObjects')
                            newdrawObj  = addNewElementNode(newDos,'drawObj')
                            newText     = addNewElementNode(newdrawObj,'text')
                            newFont     = addNewElementNode(newText,'font')
                            newContent  = addNewElementNode(newText,'content')
                            newFont.setAttribute('face',Fontfaces[FontFace])
                            newFont.setAttribute('height',groesse)
                            newFont.setAttribute('color','FFFFFF') #weiss
                            newText.setAttribute('x',x)
                            newText.setAttribute('y',y)                                            # 3.0.26
                            newContent.appendChild(score.parentNode.createTextNode(formNote.lower()))
                            break                                                                  # 3.0.27 sonst wird bei unisono ein zustzlicher falsch plazierter Abdecker eingesteuert
                    note = basic.parentNode.cloneNode(1)             #Note selbst in den Vordergrund
                    drawObj.parentNode.appendChild(note)
                    drawObj.parentNode.removeChild(drawObj)


def cleanup1(score):
    # Brackets weg
    for layout in score.getElementsByTagName('layout'):
        for brackets in layout.getElementsByTagName('brackets'):
            brackets.parentNode.removeChild(brackets)

    # Notenzeilen weg
    for system in score.getElementsByTagName('system'):
        for staff in system.getElementsByTagName('staff'):
            if staff.getAttribute('layout') != 'Tischharfe':
                if system.parentNode != None:       #Abfrage, weil eine komplette Zeile gelscht wird, aber sie mehrere Staff haben kann
                    system.parentNode.removeChild(system)

    # staffLayout auf eine Stimme reduzieren und Intreument 'Tischharfe' eintragen
    staffLayout = score.getElementsByTagName('staffLayout')
    staves=staffLayout[0].parentNode
    for sl in range(len(staffLayout)):
        if sl==0:
            staffLayout[sl].setAttribute('description','Tischharfe')
        else:
            staves.removeChild(staffLayout[sl])


def cleanup2(score):
    # drawObjs mit Tag weg und Triolen als letztes child einfgen

    for system in score.getElementsByTagName('system'):
        for drawObj in system.getElementsByTagName('drawObj'):
            for basic in drawObj.getElementsByTagName('basic'):
                tag = basic.getAttribute('tag')
                tag=tag[:8]
                if  tag in ['2086-100', '2086-101', '2086-109', '2086-110', '2086-111', '2086-112', '2086-113', \
                            '2086-107', '2086-108', '2086-115'] :
                    if drawObj.parentNode:
                        drawObj.parentNode.removeChild(drawObj)
                if tag == '2086-106':                                                              # zuerst die Triolen der Melodiestimme in den Vordergrund bringen
                    if drawObj.parentNode:
                        #font = drawObj.getElementsByTagName('font')
                        triole = drawObj.cloneNode(1)
                        drawObj.parentNode.appendChild(triole)
                        drawObj.parentNode.removeChild(drawObj)


def insertArrow(el,rechts):
    #Pfeil einsetzen und ggf Marker um Sprungziel

    global vfarbe, strich, ZielMarker
    global zfarbe, FaktorZielMarker, notengroesse

########################
#Bunten Hintergrund um Sprungziel machen
    if ZielMarker==1:                                               # Ring um Zielnote einsetzen
        newDos     = addElementNode(el,'drawObjects')
        newdrawObj = addNewElementNode(newDos,'drawObj')
        newE       = addNewElementNode(newdrawObj,'ellipse')
        newBasic   = addElementNode(newdrawObj,'basic')
        newE.setAttribute('lineWidth','0.8')
        newE.setAttribute('lineColor',FarbenListeX[zfarbe])

        if notengroesse == 0:        # kleine Noten
            x1 = -2
            x2 =  3
            y1 = -1.8
            y2 =  1.8
        elif notengroesse == 1:      # mittlere Noten
            x1 = -2.5
            x2 =  3.5
            y1 = -2.2
            y2 =  2.2
        else:                        # groe Noten
            x1 = -3.3
            x2 =  4.3
            y1 = -2.6
            y2 =  2.6
        newE.setAttribute('x1',str(x1))
        newE.setAttribute('x2',str(x2))
        newE.setAttribute('y1',str(y1))
        newE.setAttribute('y2',str(y2))
        newBasic.setAttribute('behindNotes','true')
########################

    newDos = addElementNode(el,'drawObjects')                        # Pfeil einsetzen
    newdrawObj   = addNewElementNode(newDos,'drawObj')
    newpoly      = addNewElementNode(newdrawObj,'polygon')
    newpoly.setAttribute('filled','true')
    newpoly.setAttribute('fillColor',FarbenListeX[vfarbe])
    newpoly.setAttribute('lineColor',FarbenListeX[vfarbe])
    newpoints    = addNewElementNode(newpoly,'points')

    if strich == 0:              # dnner Strich
        x0R = 2.27
        x0L = -1.4
        xB  = 2
        yH  = 0.6
    elif strich == 1:            # mittlerer Strich
        x0R = 2.33
        x0L = -1.5
        xB  = 2.4
        yH  = 0.9
    else:                        # dicker Strich
        x0R = 2.4
        x0L = -1.6
        xB  = 2.8
        yH  = 1.2

    if rechts>0:
        x1 = x0R
        x2 = x0R+xB
    else:
        x1 = x0L
        x2 = x0L-xB
    yoffs=0.5

    newpoint1    = addNewElementNode(newpoints,'point')
    newpoint1.setAttribute('x',str(x1))
    newpoint1.setAttribute('y',str(yoffs))
    newpoint2    = addNewElementNode(newpoints,'point')
    newpoint2.setAttribute('x',str(x2))
    newpoint2.setAttribute('y',str( yoffs-yH))
    newpoint3    = addNewElementNode(newpoints,'point')
    newpoint3.setAttribute('x',str(x2))
    newpoint3.setAttribute('y',str(yoffs+yH))


def insertRep(score,AuswahlStimmen):
###### Wiederholungslinien einzeichnen
# Ergnzung: mit "AuswahlStimmen" kann das Erstellen der Wiederholungslinien auf eine Stimme begrenzt werden.
# Die Option kann helfen, wenn z.B. neben einer Bass-Stimme auch die 1. Stimme auf ein Notenblatt soll
# und --- wichtig --- die beiden Stimmen sich nicht berlappen.
# Die "Einzelstimme" muss links von der anderen Stimme sein.
# ->Feature, das in Einzelfllen helfen kann. Fixer Parameter: doppelteWdhLinien

    global instrument, rastral, linkerRand, rechterRand, paperDef
    global vfarbe, Melodiestimmen, strich, abstand

#fr die Offsetbewertung: Damit werden Linien parallel nur verschoben, wenn an einer Saite schon einmal eine senkrechte Linie angehngt ist
# noch zu prfen: wie mit Rndern bei Solo-Harfe, bzw. A4-hoch umgehen
    LinienListe=[0]*anzahlSaiten[instrument]
#fr max./min. Sprunglinien
    maxsaiten = anzahlSaiten[instrument]-1
    minsaiten = 0

    Tags=['2086-102','2086-103','2086-104','2086-105']
    #      Melodie   Haltebogen  Begleit   Haltebogen

    Fontsize=StdFontSize.get(rastral,'0')
    if AuswahlStimmen=='all':
        kanalListe=['0','1','2','3']
        alleNoten=True
    else:
        kanalListe=[AuswahlStimmen]      #Bei Wiederholungslinien nur eine Stimme analysieren, damit 2 Notengruppen nebeneinander sein knnen
        alleNoten=False

    systems = score.getElementsByTagName('system')

    #das erste System mit Noten und dort die am meisten rechts stehende Note suchen
    ersteNote    = 0
    ersteChords  = 0
    erstesSystem = 0
    for sys_i in range(len(systems)):
        chords=systems[sys_i].getElementsByTagName('chord')
        for ixChord in range(len(chords)):
            chord=chords[ixChord]
            for basic in chord.getElementsByTagName('basic'):                                      # alle Noten der Zeile auf gewnschtes Tag untersuchen
                tag = basic.getAttribute('tag')
                kanal=tag[-1:]
                tag=tag[:8]
                if tag in Tags and kanal in kanalListe:                                            # kanal des Tag mit prfen wegen doppelter Linien
                    ersteNote = ixChord
                    ersteChords = chords
        if ersteNote>0:
            erstesSystem = sys_i
            break

    #Wiederholungen einzeichnen

    #offsets mit "insertArrow" abgeglichen
    if strich == 0:
        offset = 4.635
    elif strich == 1:
        offset = 5.385
    else:
        offset = 6.55

    X2Offs_rechts=3
    X2Offs_links=-2

    for kp in klammerpaare:
        tagS=kp[0]
        tagE=kp[1]
        sysCntLok    = 0
        chordCntMax   = ersteNote
        chordCntMin   = ersteNote
        sysBegin      = erstesSystem
        wait4tagE     = 0
        chordsBegin   = 0
        tagExtR       = ''
        #if messageBox('Klammern',str(tagS) +' - '+str(tagE)+'  //  '+str(ersteNote),0,1)==0:
        #    raise Abbruch

        for system in score.getElementsByTagName('system'):

            chords=system.getElementsByTagName('chord')                           # erzeugt Liste mit DOM Elementen - chord
            for ixChord in range(len(chords)):
                chord=chords[ixChord]
                if chordsBegin==0:
                    chordsBegin=chords
                for obj in chord.getElementsByTagName('drawObjects'):
                    for basic in obj.getElementsByTagName('basic'):
                        tagx = basic.getAttribute('tag')
                        kanal=tagx[-1:]
                        tag=tagx[:8]

                        #if tag == '2086-107':
                        #    woVolta = 'innerhalb'
                        if tag in Tags and kanal in kanalListe:                   # Abfrage notwendig??
                            #messageBox('Mel.','Cnt: '+str(ixChord) +', min/max: '+str(chordCntMin)+' / '+str(chordCntMax)+' / '+str(tagx))
                            ixKanal=ixChord                                                     # Kanal merken, wird fr doppelte Linien gebraucht
                            chordCntMax=max(ixChord,chordCntMax)                                # nur Max-Bildung bei Melodiestimme
                            chordCntMin=min(ixChord,chordCntMin)                                # Min-Bildung bei Melodiestimme
                        if tag == tagS:                                                         # begin tag
                            chordsBegin=chords
                            if alleNoten:
                                chordCntMax = ixChord
                                chordCntMin = ixChord
                                ixChordBegin= ixChord
                            else:
                                chordCntMax = ixKanal                                           # maximale "Untere Note", wenn nicht alle genutzt werden
                                chordCntMin = ixKanal
                                ixChordBegin= ixKanal
                            sysBegin=sysCntLok
                            #messageBox('tagS',str(tag)+' '+str(kanal)+' : ix='+str(ixChord)+', Begin='+str(ixChordBegin))
                            wait4tagE=1
                            if tag in ['2086-107','2086-112']:
                                tagExtR=tagx[9:10]
                                #messageBox('tagS',tagS+':  '+tagx)

                        if tag == tagE:                                                         # end tag
                            if wait4tagE==0:                                                    # kein Starttag vorhanden
                                ixChordBegin  = ersteNote                                       # --> erste Note als Ersatz nehmen
                                sysBegin = erstesSystem
                                chordsBegin = ersteChords
                            if tag in ['2086-101','2086-109','2086-110']:
                                tagExtR=tagx[9:10]
                            #messageBox('tagE',tag+' ix/ixMax '+str(ixChord)+'/'+str(chordCntMax))

                            if alleNoten:                                                       # Relevant ist aktueller Index oder hchste Note der ausgewhlten Stimme
                                ixRelevant=ixChord
                            else:
                                ixRelevant=ixKanal
                            chordCntMax=max(ixRelevant,chordCntMax)                             # nur Max-Bildung bei Melodiestimme
                            chordCntMin=min(ixRelevant,chordCntMin)                             # Min-Bildung bei Melodiestimme
                            chordCntMax=min(chordCntMax,maxsaiten)
                            chordCntMin=max(chordCntMin,minsaiten)

                            #messageBox('D','min/max '+str(chordCntMin)+'/'+str(chordCntMax)
                            #            +'\n Begin/Ziel '+str(ixChordBegin)+'/'+str(ixRelevant))
                            deltaplus_Begin= chordCntMax-ixChordBegin
                            deltaplus_Ziel = chordCntMax-ixRelevant
                            deltaneg_Begin = ixChordBegin -chordCntMin
                            deltaneg_Ziel  = ixRelevant-chordCntMin

                            if tag=='2086-108' or tag=='2086-113':
                                fullLine=0.5                                                    # waagrechte Linie "gestrichelt"
                                vorwaerts=1
                                chordsPfeil=chords
                                ixPfeil=ixRelevant
                            else:
                                fullLine=1
                                vorwaerts=0
                                chordsPfeil=chordsBegin
                                ixPfeil=ixChordBegin

                            #if messageBox('deltas','plus '+str(deltaplus_Begin)+','+str(deltaplus_Ziel)+';  negativ '+str(deltaneg_Begin)+','+str(deltaneg_Ziel)
                            #+'\n  IX='+str(ixChordBegin)+'  Cnt='+str(ixRelevant)+'\n  max='+str(chordCntMax)+'/'+str(maxsaiten)+'  min='+str(chordCntMin),0,1)==0:
                            #    raise Abbruch

# "Begin" ist immer obere Note (egal ob Linie vorwrts oder rckwarts)
# "Ziel" ist immer untere Note

# Linien bei Mehrstimmigkeit dann immer nach rechts, wenn in Hauptstimme keine Note ist, ansonsten je nach dem krzeren Weg
#
# Grundlagen Linien:
# Abstand von Note: pos xoffs=3.5; neg: xoffs=-1.6
# Behandlung Seitenrnder:
#  links bei Note auf Position 0 und Druck linksbndig oder Quadrat  --> Repeat-Linien rechts der Position 0 verschieben
#  rechts bei Note auf Position MaxSaite und Druck rechtsbndig oder Quadrat  --> Repeat-Linien links der maximalen Noten verschieben
#
# Linien werden ber "range" an die jeweiligen Indices angehngt --> unabhngig von Rastral (und damit "mult")

#                            if Melodiestimmen.count(-1)<3 or max(deltaplus_Begin,deltaplus_Ziel) < max(deltaneg_Begin,deltaneg_Ziel):
                            if max(deltaplus_Begin,deltaplus_Ziel) <= max(deltaneg_Begin,deltaneg_Ziel) or tagExtR=='1':
                                linienRechtsRum=1
                                PfeilL=1
                                if chordCntMax==maxsaiten and rechterRand < paperDef.get('minRight'): #instrument in [0,2,4,5,8,10]:         # maxsaiten bei A4quer bzw. Soloharfe
                                    ixZwischenwert = chordCntMax-2
                                    if ixPfeil==maxsaiten:
                                        PfeilL=-1
                                else:
                                    ixZwischenwert = chordCntMax
                                #messageBox('Rechts','1' + '\ndeltaplus_Begin=' + str(deltaplus_Begin) + '\ndeltaplus_Ziel=' + str(deltaplus_Ziel)+'\nmax = '+str(chordCntMax)+' / '+str(ixZwischenwert))
                            else:
                                linienRechtsRum=-1
                                PfeilL=-1
                                if chordCntMin<=minsaiten+1 and linkerRand < paperDef.get('minLeft'):           # minsaiten
                                    ixZwischenwert=2
                                    if ixPfeil<=minsaiten+1:
                                        PfeilL=1
                                else:
                                    ixZwischenwert=chordCntMin
                                #messageBox('Links','1' + '\ndeltaplus_Begin=' + str(deltaplus_Begin) + '\ndeltaplus_Ziel=' + str(deltaplus_Ziel)+'\nmax = '+str(chordCntMax)+' / '+str(maxsaiten))

                            #if LinienListe[ixZwischenwert]>=3:    #wird wahrscheinlich selten gebraucht, daher keine Abfrage, ob nchstes Feld auch voll
                            #    if chordCntMax<maxsaiten:         #ausgeblendet: funktioniert nicht, wenn Zwischenwert=maxsaiten ist
                            #        ixZwischenwert=ixZwischenwert+1
                            #    else:
                            #        ixZwischenwert=ixZwischenwert-1

                            ixOben= [min(ixZwischenwert, ixChordBegin),max(ixZwischenwert, ixChordBegin)]
                            ixUnten=[min(ixZwischenwert, ixRelevant)     ,max(ixZwischenwert, ixRelevant)]
                            X2Offset=(offset+LinienListe[ixZwischenwert]*1.2)*linienRechtsRum #0.8
                            textOffset= offset*0.9*linienRechtsRum                                                  # Offset fr Text
                            LinienListe[ixZwischenwert]=LinienListe[ixZwischenwert]+1

                            if vorwaerts==1:
                                if ixZwischenwert < ixChordBegin:
                                    xOben=[X2Offset,0]
                                else:
                                    xOben=[0,X2Offset]
                                if PfeilL==1:
                                    xUnten=[X2Offs_rechts,X2Offset]
                                else:
                                    xUnten=[X2Offset,X2Offs_links]
                            else:
                                if PfeilL==1:
                                    xOben=[X2Offs_rechts,X2Offset]
                                else:
                                    xOben=[X2Offset,X2Offs_links]
                                if ixRelevant <= ixZwischenwert:
                                    xUnten=[0,X2Offset]
                                else:
                                    xUnten=[X2Offset,0]

                            #if messageBox('Linesx','ixChord '+str(ixChord)+'; X2Zw '+str(ixZwischenwert)+'; ixChordBegin '+str(ixChordBegin)+
                            #          '\nPfeilL '+str(PfeilL)+'  X2Offset '+str(X2Offset)+'  xOben '+str(xOben)+'  xUnten '+str(xUnten)+
                            #          '\ntextOffset '+str(textOffset)+': '+str(tagx[11:])+' rechts '+str(linienRechtsRum)+
                            #          '\nLinienliste: '+str(LinienListe),0,1)==0:
                            #     raise Abbruch

                            insertLine(chordsBegin, ixOben[0], ixOben[1], 0,0,xOben[0] ,xOben[1], fullLine)
                            insertLine(chords,      ixUnten[0],ixUnten[1],0,0,xUnten[0],xUnten[1],fullLine)

                            y2 = (sysCntLok-sysBegin) * abstand                                               # Zeilenabstand einrechnen
                            insertLine(chordsBegin, ixZwischenwert, ixZwischenwert, 0, y2, X2Offset, X2Offset,1)

                            insertArrow(chordsPfeil[ixPfeil],PfeilL)                                  # Pfeil einsetzen

                            if textOffset>0:
                                textAlign='right'
                            else:
                                textAlign='left'
                            voltaString=tagx[11:]
                            if tag=='2086-101':
                                if voltaString!='NA' and voltaString!='1':
                                    insertText(score,chords[ixZwischenwert],tagx[11:],Fontsize,FarbenListeX[vfarbe],'NA',str(textOffset),'0','700','false',textAlign)                    # Nummer der Klammer einsetzen
                            if tag=='2086-108':
#                                if voltaString!='NA' and voltaString!='2':   #2 als "default" wird nicht angezeigt
                                if voltaString!='NA':   #auch die 2 als "default" wird angezeigt
                                    insertText(score,chordsBegin[ixZwischenwert],voltaString,Fontsize,FarbenListeX[vfarbe],'NA',str(textOffset),'2.5','700','false',textAlign)    # Nummer der Klammer neben die senkrechte Linie
                            elif tag=='2086-113':
                                insertText(score,chordsBegin[ixZwischenwert],'Schluss',Fontsize,FarbenListeX[vfarbe],'NA',str(textOffset),'2.5','700','false',textAlign)   # text "Kopf"

                            wait4tagE=0
                            chordCntMax=0
            sysCntLok += 1


def insertLine(chords, ix1, ix2, y1, y2, x1, x2, full ):
    # Linie ziehen
    global vfarbe, strich

    y1=y1+0.5
    y2=y2+0.5

    rangeLok=(ix2-ix1)
    newDos       = addElementNode(chords[ix1],'drawObjects')
    newdrawObj   = addNewElementNode(newDos,'drawObj')
    if strich == 0:
        lineWidth = '0.2'
    elif strich == 1:
        lineWidth = '0.3'
    else:
        lineWidth = '0.4'

    if full<1:
        #Linien als gerade "slur" gestrichelt zeichnen

        newLine  = addNewElementNode(newdrawObj,'slur')
        newLine.setAttribute('x1',str(x1))
        newLine.setAttribute('y1',str(y1))
        newLine.setAttribute('x2',str(x1))
        newLine.setAttribute('y2',str(y1))
        newLine.setAttribute('x3',str(x2))
        newLine.setAttribute('y3',str(y2))
        newLine.setAttribute('x4',str(x2))
        newLine.setAttribute('y4',str(y2))
        newForm  = addNewElementNode(newLine,'form')
        newForm.setAttribute('endWidth',lineWidth)
        newForm.setAttribute('midWidth',lineWidth)
        newForm.setAttribute('dotDist','2')
        newForm.setAttribute('dotWidth',str(full))
    else:
        #normale Linie
        newLine  = addNewElementNode(newdrawObj,'line')
        newLine.setAttribute('x1',str(x1))
        newLine.setAttribute('y1',str(y1))
        newLine.setAttribute('x2',str(x2))
        newLine.setAttribute('y2',str(y2))
        newLine.setAttribute('lineWidth',lineWidth)
    #messageBox('Line','x1,x2,y1,y2: '+str(x1)+','+str(x2)+','+str(y1)+','+str(y2))
    newBasic     = addNewElementNode(newdrawObj,'basic')
    newBasic.setAttribute('noAdjust','true')
    newLine.setAttribute('color',FarbenListeX[vfarbe])
    newBasic.setAttribute('behindNotes','true')
    if rangeLok>0:
        newBasic.setAttribute('noteRange',str(rangeLok))


def getPos(sy, st, vo, no):
    # ermittelt die Position des angeforderten Objekts

    #messageBox('getPOS',str(activeScore().system)+'  '+ str(st)+'  '+str(vo)+'  '+str(no))
    PosList = []
    Isystem = activeScore().system(sy)
    Istaff  = Isystem.staff(st)
    Ivoice1 = Istaff.voice(vo)
    anz1    = Ivoice1.nNoteObjs()
    n1      = 0
    while n1 < anz1:
        obj1 = Ivoice1.noteObj(n1)
        if obj1.subType() == NoteObj.CHORD or obj1.subType() == NoteObj.REST or obj1.subType() == NoteObj.EXPL_BARLINE:
            opo1 = obj1.posX(0)    #Parameter 0 --> Position ohne Verschiebung zurckgeben
            PosList.append(opo1)
            #messageBox('Results', 'masterPosList  =  ' + str(obj1.subType()) + '\n' + str(opo1))
        n1 = n1 +1
    pos = PosList[no]
    return pos


def getPosList(score, sy):
    # erzeugt die Positionsliste der 1. Stimme des angeforderten Systems
    global masterPosList

    masterPosList = []
    systems = score.getElementsByTagName('system')
    SYSTEMCNT = systems.length
    if SYSTEMCNT == 0:
        return
    else:
        Isystem = activeScore().system(sy)
        Istaff  = Isystem.staff(0)
        Ivoice1 = Istaff.voice(0)
        anz1       = Ivoice1.nNoteObjs()
        n1         = 0
    while n1 < anz1:
        obj1 = Ivoice1.noteObj(n1)
        if obj1.subType() == NoteObj.CHORD or obj1.subType() == NoteObj.REST or obj1.subType() == NoteObj.EXPL_BARLINE:
            opo1 = obj1.posX(0)
            masterPosList.append(opo1)
        n1 = n1 +1
    return


def CheckPause(noteObjects, chord, ix, Pitches, ersterTonLok, verschieben):
    # Pause prfen: ggf unsichtbar / Verschiebung ermitteln
    global invisPause
    PType = 'R'
    invis=0
    disply=chord.getElementsByTagName('display')
    if disply != [] and invisPause==1:
        invis=disply[0].getAttribute('invisible')
        if invis =='true':
            PType='NA'
    if PType == 'R':
        if verschieben==1 or ersterTonLok == 'NA':         #nchsten Ton auch suchen, wenn "kein vorhergehender Ton"
            noNrlok=ix     # lokal nchste "Note" suchen
            while noNrlok<len(noteObjects):
                nextChild=noteObjects[noNrlok]
                if nextChild != 'NA':
                    if nextChild.nodeType == nextChild.ELEMENT_NODE:
                        if nextChild.tagName == 'chord':
                            Pitches = getPitch(nextChild)
                            break
                noNrlok +=1
        if ersterTonLok == 'NA':
            ersterTonLok = 'R'
    #messageBox('CheckPause',str(ersterTonLok)+'  v='+str(verschieben)+' Pitch='+str(Pitches)+' PType='+str(PType))
    return (PType,Pitches,ersterTonLok)


def copyObjects(score):
    # Voltenklammern in alle Stimmen kopieren
    # JK hier auch Segnos etc kopieren

    global Melodiestimmen, voltaDO, segnoDO, masterPosList, masterPosListT, codaCnt

    systems = score.getElementsByTagName('system')
    for sy in range(systems.length):                                                           # Voltenklammern oder Segnos in erster Stimme lokalisieren
        staff = systems[sy].getElementsByTagName('staff')
        voice = staff[0].getElementsByTagName('voice')
        nos = voice[0].getElementsByTagName('noteObjects')
        elPosIx = 0
        for child in nos[0].childNodes:
            if child.nodeType == child.ELEMENT_NODE:
                if (child.tagName == 'chord' or child.tagName == 'rest' or child.tagName == 'barline'):
                    volta4Copy = checkVolta(child,1)  #1: clone Node nach voltaDO
                    segno4Copy = searchSegno(child)
                    elPosIx = elPosIx + 1
                    if volta4Copy > 0 or segno4Copy > 0:                                       # wenn gefunden
                        getPosList(score, sy)                                                  # Positionsliste der 1. Stimme erzeugen
                        elPos = masterPosList[elPosIx-1]                                       # und Position des Elements mit der Volta merken
                        staffT = systems[sy].getElementsByTagName('staff')
                        voCnt = 0
                        for st in range(staffT.length):
                            voiceT = staffT[st].getElementsByTagName('voice')
                            for vo in range(voiceT.length):
                                if voCnt == Melodiestimmen[0]:                                 # wenn Stimme bereinstimmt Volta kopieren
                                    nosT = voiceT[vo].getElementsByTagName('noteObjects')
                                    elCnt = 0
                                    for childT in nosT[0].childNodes:
                                        if childT.nodeType == child.ELEMENT_NODE:
                                            if childT.tagName == 'chord' or childT.tagName == 'rest' or childT.tagName == 'barline':
                                                pos = getPos(sy, st, vo, elCnt)
                                                elCnt = elCnt + 1
                                                if pos == elPos:
                                                    dOs = addElementNode(childT,'drawObjects')
                                                    if volta4Copy !=0:
                                                        dOs.appendChild(voltaDO)
                                                    else:
                                                        dOs.appendChild(segnoDO)
                                                    break
                                    voCnt = voCnt + 1
                                else: voCnt = voCnt + 1
                    if searchCircle(child):                                                           # wenn gefunden
                        getPosList(score, sy)                                                  # Positionsliste der 1. Stimme erzeugen
                        #messageBox('WEL',str(elPosIx) + ',   Melodiestimmen: '+str(Melodiestimmen)+ '\n' + str(masterPosList))
                        elPos = masterPosList[elPosIx-1]                                       # und Position des Elements mit der Volta merken
                        staffT = systems[sy].getElementsByTagName('staff')
                        voCnt = 0
                        for st in range(staffT.length):
                            voiceT = staffT[st].getElementsByTagName('voice')
                            for vo in range(voiceT.length):
                                if voCnt == Melodiestimmen[0]:                                 # wenn Stimme bereinstimmt Circle kopieren
                                    nosT = voiceT[vo].getElementsByTagName('noteObjects')
                                    elCnt = 0
                                    for childT in nosT[0].childNodes:
                                        if childT.nodeType == child.ELEMENT_NODE:
                                             #messageBox('copy-Ziel',str(childT.tagName)+'  q: '+str(child.tagName))
                                             if childT.tagName == 'chord' or childT.tagName == 'rest' or childT.tagName == 'barline':
                                                pos = getPos(sy, st, vo, elCnt)
                                                elCnt=elCnt+1
                                                #messageBox('pos',str(elPosIx) + ' elcnt:'+str(elCnt)+'\nQuelle: ' + str(elPos)+'  Ziel:'+str(pos))
                                                if pos==elPos:
                                                    copyCircle(childT,0)
                                                    break
                                    voCnt = voCnt + 1
                                else: voCnt = voCnt + 1



def klavierLine(newPO,x1,x2,y1,y2):
    newDO = addNewElementNode(newPO,'drawObj')
    newLine  = addNewElementNode(newDO,'line')
    newLine.setAttribute('x1',str(x1))
    newLine.setAttribute('x2',str(x2))
    newLine.setAttribute('y1',str(y1))
    newLine.setAttribute('y2',str(y2))
    newLine.setAttribute('lineWidth','0.2')
    newLine.setAttribute('color','AAAA7F')
    newBasic = addNewElementNode(newDO,'basic')
    newBasic.setAttribute('noAdjust',"true")
    #newBasic.setAttribute('behindNotes',"true")


def klavierRectangle(newPO,x1,x2,y1,y2):
    newDO = addNewElementNode(newPO,'drawObj')
    newLine  = addNewElementNode(newDO,'rectangle')
    newLine.setAttribute('LineColor','FFFFFF')
    newLine.setAttribute('filled','true')
    newLine.setAttribute('fillColor','D5D5D5')
    newLine.setAttribute('x1',str(x1))
    newLine.setAttribute('x2',str(x2))
    newLine.setAttribute('y1',str(y1))
    newLine.setAttribute('y2',str(y2))
    newBasic = addNewElementNode(newDO,'basic')
    newBasic.setAttribute('noAdjust',"true")
    newBasic.setAttribute('behindNotes',"true")


def klavierstreifen(score):
    #Klavierstreifen einfgen
    global instrument

    klaviersymbole = ('0','B','0','B','0','B','0','L','B','0','B','0','L','B','0','B','0','B','0','L','B','0','B','0','L','B','0','B','0','B','0','L','B','0','B','0','L','B','0')
    #                  F  Fis  G   Gis A   Ais H   c   cis d   dis e   f  fis  g  gis  a  ais  h   c' cis' d' dis' e'  f' fis' g' gis' a' ais' h'  c" cis" d" dis" e"  f" fis" g"
    untersteSaite = (18, 18, 6, 6, 14, 2, 14, 2, 2, 16, 0, 16, 0)

    newPO = getNodePO(score)

    indexSymbol=untersteSaite[instrument]
    lastCt=indexSymbol+anzahlSaiten[instrument]
    if (horizAbstVar == 1):
        xPos=(abstandSaiten[1]-abstandSaiten[0])/UmrechnungVonMM
    else:
        xPos=0
    y1 = -paperDef.get('Top')/UmrechnungVonMM
    y2 = paperSizeY[instrument]/UmrechnungVonMM+y1

    while indexSymbol < lastCt:
       # messageBox('BL',klaviersymbole[indexSymbol]+'('+str(ct)+'):'+str(xPos))
        if klaviersymbole[indexSymbol]=='B':
            x1=xPos-1.9
            x2=xPos+2.1
            klavierRectangle(newPO,x1,x2,y1,y2)
        elif klaviersymbole[indexSymbol]=='L':
            x1=max(0,xPos-abstandSaiten[0]/2/UmrechnungVonMM)
            x2=x1
            klavierLine(newPO,x1,x2,y1,y2)
        indexSymbol=indexSymbol+1
        xPos=xPos+abstandSaiten[0]/UmrechnungVonMM


##############################
def changeDoc(score, stimmen):
    # Hauptroutine
    global doc, form, instrument, StimmenIndex
    global lineCount, linie, BkNumber, BkRange, chordOldRep
    global ersterTon, pausen, takt, taktinhalt, timeSign, masterPosList
    global volta, voltaSave
    global Melodiestimmen, StimmenNutzung, stimmeprint
    global segno, Coda_second
    global abstand, klavier, taktnummerBasis, doppelteWdhLinien, akkordTon

    doc      = score.parentNode
    chordOldRep = 'NA'
    form     = 'NA'
    pause_verschieben = 1

    lineCount = 0

    ersterTon = ['NA','NA','NA','NA']
    taktinhalt = 0
    segno = 0
    Coda_second=0
    barCountReset=0

    copyObjects(score)                                                           # Voltenklammern und Akkorde in alle Stimmen kopieren
    move_PageObjects(score)
    suppressNoteLines(score)
    calcPageDefinition(score)

    systems = score.getElementsByTagName('system')

#Vorbelegung

    for sy in range(systems.length):                                             # nur ausgewhlte Notenzeile bearbeiten
        Ivoice  = ['NA','NA','NA','NA']
        voice   = [[],[],[],[]]
        noten   = [[],[],[],[]]
        objects = [[],[],[],[]]                                                  # Liste der Tne erzeugen, nur Noten, Pausen, feste Taktstriche und Taktzahl
        timeList= [[],[],[],[]]                                                  # neu (4.3.1): Positionsliste durch Zeitliste ersetzt --> auch "Ganztaktpausen" haben "richtige Zeit"

        obj_keineNote     = []
        timeList_keineNote = []
        Isystem = activeScore().system(sy)
        vc = 0

        for IvoiceX in Isystem.voices():
            for st in range(4):
                if Melodiestimmen[st]>=0 and StimmenIndex[Melodiestimmen[st]] == vc:
                    Ivoice[st] = IvoiceX
            vc = vc + 1

        barCount=systems[sy].getElementsByTagName('barCount')                    # nderung der Taktnummerierung?
        if barCount.length==1:
            obj_keineNote.append(barCount[0])                                    # steht immer nur am Anfang der Zeilendef. --> time=0
            timeList_keineNote.append(0)

        voices=systems[sy].getElementsByTagName('voice')

        FehlerAnzahlStimmen=0
        lenVoices=len(voices)
        for st in range(4):
            if Melodiestimmen[st]>=0:
                if StimmenIndex[Melodiestimmen[st]]>=lenVoices:
                    FehlerAnzahlStimmen=1
                    break
                voice[st] = voices[StimmenIndex[Melodiestimmen[st]]]
                noten[st] = getElementObjects(voice[st].getElementsByTagName('noteObjects')[0].childNodes)
        if FehlerAnzahlStimmen==1:
            messageBox('Hinweis','\nProblem: In Zeile '+str(sy+1)+' ist ein anderes Stimmenlayout\nKeine Umsetzung mglich',3)
            raise Abbruch

        for st in range(4):
            for obj1 in noten[st]: #TODO: was hier bei leerem Object?
                #messageBox('tags',str(obj1) + '\n' + obj1.tagName)

                if obj1.tagName == 'chord' or obj1.tagName == 'rest':
                    objects[st].append(obj1)
                if st==0 and (obj1.tagName == 'barline' or obj1.tagName == 'timeSign'):
                    obj_keineNote.append(obj1)

            if Ivoice[st]!='NA':
                #messageBox('VOI',str(st)+' :'+str(Ivoice[st]) + '\n' + str(Ivoice[st].noteObjs()))
                for obj1 in Ivoice[st].noteObjs():                                                    # Liste mit Positionen der Melodiestimme erzeugen
                    if obj1.subType() == NoteObj.CHORD or obj1.subType() == NoteObj.REST:
                        timeList[st].append(obj1.time())
                    if st==0 and (obj1.subType() == NoteObj.EXPL_BARLINE or obj1.subType() == NoteObj.METER):
                        timeList_keineNote.append(obj1.time())

        timeListAlle=sortUnique(timeList[0]+timeList[1]+timeList[2]+timeList[3]+timeList_keineNote)      #unique-Positionsliste aller Objekte
        timeList_keineNote.append('NA')
        for st in range(4):
            timeList[st].append('NA')

        ix=[0,0,0,0]
        ix_kN=0

        BkNumber=['0','0','0','0']
        BkRange =['NA','NA','NA','NA']

        bartypeBarLine=''
        #if messageBox('timeList_keineNoten',str(timeList_keineNote),0,1)==0:
        #    raise Abbruch
        for timex in timeListAlle:

            toene=['NA','NA','NA','NA']
            base =['1','1','1','1']
            dots =[0,0,0,0]
            Pitches=[['NA'],['NA'],['NA'],['NA']]
            Type =['NA','NA','NA','NA']

            # if messageBox('timeList_keineNoten',str(timeList_keineNote)+'\n'+str(timeListAlle)+'\nindex= '+str(ix_kN)+'\nobj_keineNote: '+str(obj_keineNote),0,1)==0:
            #    raise Abbruch
            while timeList_keineNote[ix_kN]==timex:
                #Takt, Taktstrich oder Korrektur Taktzhlung gefunden

                #if messageBox(str(timex),'timeList_keineNote: '+str(timeList_keineNote)
                #       +',  index= '+str(ix_kN)+'\nobj_keineNote: '+str(obj_keineNote)
                #       +'\ntag: '+str(obj_keineNote[ix_kN].tagName),0,1)==0:
                #    raise Abbruch

                if obj_keineNote[ix_kN].tagName == 'barCount':          #Taktzhlung korrigieren
                    barCountAdd=0
                    if obj_keineNote[ix_kN].hasAttribute('nAdd'):
                        barCountAdd=int(obj_keineNote[ix_kN].getAttribute('nAdd'))
                    if obj_keineNote[ix_kN].hasAttribute('reset'):
                        if obj_keineNote[ix_kN].getAttribute('reset'):
                            # Reset am Anfang einer Notenzeile --> Resets werden gezhlt, um eine nderung zu erkennen und nur dann den Zhler zurckzusetzen
                            barCountReset+=1
                    taktnummerBasis=str([barCountAdd,barCountReset])
                elif obj_keineNote[ix_kN].tagName == 'timeSign':                                     # falls Taktzahl Taktschnittstelle aufsetzen
                    timeSign = obj_keineNote[ix_kN].getAttribute('time')
                elif obj_keineNote[ix_kN].tagName == 'barline':
                    bartypeBarLine=obj_keineNote[ix_kN].getAttribute('type')
                    if bartypeBarLine in ['repEndBegin','repBegin', 'repEnd','double']:
                        ersterTon= ['NA','NA','NA','NA']   #damit keine berbindung ber Wiederholung
                        pause_verschieben=1
                    toene[0]=obj_keineNote[ix_kN]
                    volta = checkVolta(toene[0],0)
                    if volta >= 1:          #alt: Abfrage auf 2. Save muss auch bei 1 sein
                        voltaSave = volta
                    segno = searchSegno(toene[0])
                    if segno==3:
                        pause_verschieben=1
                    #if sy == systems.length-1:
                    #if 1 or not(bartypeBarLine=='end' and sy == systems.length-1 and ix_kN == len(timeList_keineNote)-2 and segno==0):  #nicht letzte Zeile oder letzte Zeile mit Segno?
                    appendSystem(score,toene,Pitches,base,dots,['BL','NA','NA','NA'])   # Tne in einer Zeile einfgen
                ix_kN+=1

            for st in range(4):
                #if messageBox('st-range','ix = '+str(ix)+' ; '+str(timeList),0,1)==0:
                #    raise Abbruch
                if ix[st] < len(timeList[st]) and Melodiestimmen[st]>=0:
                    if timeList[st][ix[st]]==timex and ix[st] < len(objects[st]):
                        #Note oder Pause in st gefunden
                        toene[st]=objects[st][ix[st]]
                        #if messageBox('Type','Tne('+str(st)+'): '+str(toene[st].tagName),0,1)==0:
                        #    raise Abbruch

                        duration = toene[st].getElementsByTagName('duration')
                        base[st] = duration[0].getAttribute('base')
                        dots[st]  = duration[0].getAttribute('dots')
                        xbracket = toene[st].getElementsByTagName('bracket')                       # Wenn n-Tole, dann Art und Range merken
                        if xbracket:
                            BkNumber[st] = xbracket[0].getAttribute('number')
                            xBasic  = xbracket[0].parentNode.getElementsByTagName('basic')
                            BkRange[st]  = xBasic[0].getAttribute('noteRange')
                        searchCircle(toene[st])
                        if st==0:
                            segno = searchSegno(toene[0])
                            #if segno <> 0:
                            #    messageBox('3Segno',str(segno))
                            if segno==3:
                                pause_verschieben=1
                            volta = checkVolta(toene[0],0)
                        if toene[st].tagName == 'chord':
                            Type[st] = 'C'
                            ersterTon[st] = 'C'
                            pause_verschieben=0
                            Pitches[st] = getPitch(toene[st])
                        elif toene[st].tagName == 'rest':
                            Type[st], Pitches[st], ersterTon[st] = CheckPause(objects[st], toene[st], ix[st], Pitches[st], ersterTon[st], pause_verschieben)
                        #if messageBox('Fehler','Ton tag ('+str(toene)+' = '+str(toene[st].tagName)+'  pitch='+str(pitch),0,1)==0:
                        #   raise Abbruch

                        ix[st]=ix[st]+1

            if Type.count('NA')<4:  #ist ein Wert gefunden?  alt:toene.count
                 appendSystem(score,toene,Pitches,base,dots,Type)   # Tne in einer Zeile einfgen
#            else:
#            lineCount = 1

    cleanup1(score)                                                                                # originale Notenzeilen lschen

#  Rastral anpassen, damit Noten auf eine Seite gehen, nderungen begrenzt auf min(rast)=0.7
    if rastral==11 and lineCount>MaxZeilenA3_Abst1 and abstand==1:

        msg='Das System enthlt '+str(lineCount)+' Zeilen\n(max. Zeilenanzahl= '+str(MaxZeilenA3_Abst1)+')\n'
        aenderungsFaktor = float(MaxZeilenA3_Abst1) / float(lineCount)                # mgliche Zeilenzahl / akt. Zeilen
        if aenderungsFaktor < 0.7:
            mBRetWert= messageBox('Notenzeilen',msg+'Es kann mit dem minimalen Stauchungsfaktor 0.7 nicht auf 1 Seite skaliert werden',2,1)
            if mBRetWert==0:
                raise Abbruch
        else:
            strStauch=str(float(int(aenderungsFaktor*100))/100)
            mBRetWert= messageBox('Notenzeilen',msg+'Soll es mit dem Stauchungsfaktor '+strStauch+' auf 1 Seite skaliert werden?',1,3)
            if mBRetWert==0:
                raise Abbruch
            elif mBRetWert==2:
                rast=str(float(stauchung.get(10,'0')) * aenderungsFaktor)
                stauchung[11]=rast
                for staffLines in score.getElementsByTagName('staffLines'):                                    # Rastral setzen
                    staffLines.setAttribute('normal',rast)

    if stimmeprint == 1:
        if Melodiestimmen.count(-1)==3:
            textListe=['Stimme:  '+stimmen[Melodiestimmen[0]]]
            Farbenliste=[FarbenListeX[11]]
        else:
            textListe=['Stimmen:\n']
            Farbenliste=[FarbenListeX[11]]
            for st in range(4):
                if Melodiestimmen[st]>=0:
                    textListe.append('   '+stimmen[Melodiestimmen[st]])
                    Farbenliste.append(FarbenListeX[NFarbe[st]])

        if pageStimmeObjKoordVH[0]=='NA':
            textx='5'
            texty='11'
        else:
            textx,texty=pageStimmeObjKoordVH
        insertTextOnPage(score,textListe,Farbenliste,'9','1',textx,texty,'700','false', 'false','false','')            # Stimme ausdrucken

    insertRep(score,'all')                                                                               # Wiederholungspfeile einzeichen
    if doppelteWdhLinien:
        for reps in range(1,4):
            if StimmenNutzung[reps]==0:
                insertRep(score,str(reps))
    anlegekanteEinfuegen(score)                                                                    # Anlegekante einfgen
    for st in range(4):
        if StimmenNutzung[st]>=0:               #Stimme genutzt?
            drawSlur(score,st)                      #Haltebgen an Noten
            if StimmenNutzung[st]==0: #Melodie
                drawLines(score, 'MT', st,st)                                                           # Melodietne verbinden
            elif linie != 1:
                Mst=StimmenNutzung[st]-1            #Index der zugehrenden Melodie
                drawLines(score, 'BT', Mst,st)                                                           # Melodietne verbinden
#Melodie oder Begleitung und Linie!=1

    hollowHead(score)                               # hohle Notenkpfe wirklich hohl anzeigen
    set_Taktnummern(score)
    if debugging==0:
        cleanup2(score)                                                                                # drawObjs mit Tag weg und Triolen 3er in der Vordergrund bringen
    if klavier == 1:                                                                               # Klavierstreifen einfgen
        klavierstreifen(score)

    if True in AkkordeVerworfen:
        msg=''
        if akkordTon==2:
            obNote='unterste'
        else:
            obNote='oberste'
        for st in range(4):
            if AkkordeVerworfen[st]:
                msg+='Stimme "'+stimmen[Melodiestimmen[st]]+'" hat Begleitstimme\n'
        msg+='deshalb wird vom Akkord nur die '+obNote+' Note verwendet\n'
        messageBox('Hinweis',msg, 2,0)

def getStimmenListe(score):
    #Liste der Stimmen und ihrer Indices ermitteln
    global StimmenIndex

    systems = score.getElementsByTagName('systems')
    layout = score.getElementsByTagName('layout')
    stimmen=[]
    alleStimmenCnt=0
    StimmenIndex=[]

    system  = systems[1].getElementsByTagName('system')[0]

    # TODO: hier vorher prfen, dass alle System(Zeilen) die gleiche Stimmen und Stimmenanzahl haben?
    #          wird beim Auslesen fr die "genutzten" Zeilen geprft

    # Stimmenauswahl: max. 4 Stimmen.
    #                 Typ Melodie, d.h. Linien verbunden oder Begleitung (mit Querstrichen zur Melodie)
    # 4 senkrechte Felder mit Combox-Box-Auswahl: 4 x Melodie, daneben fr Felder 2-4: Auswahl: Melodie bzw. zu welchem Feld Begleitung
    staffLayout  = layout[0].getElementsByTagName('staffLayout')
    staff = system.getElementsByTagName('staff')
    layoutUsed=[]
    for iStaff in range(len(staff)):
        layoutUsed.append(latin1_e(staff[iStaff].getAttribute('layout')))

    suppress= (layout[0].hasAttribute('singlePart') and layout[0].getAttribute('singlePart')=='true')
    for iSL in range(len(staffLayout)):
        LayoutDesc=staffLayout[iSL].getAttribute('description')
        notas = staffLayout[iSL].getElementsByTagName('notation')
        suppressGanzeZeile= notas[0].hasAttribute('suppressSingle') and notas[0].getAttribute('suppressSingle')=='true'
        suppressAuswahl=['123456']
        if suppress and not suppressGanzeZeile and notas[0].hasAttribute('suppressSingleVoices'):
            suppressAuswahl=notas[0].getAttribute('suppressSingleVoices')

        LayoutGefunden=0
        for iStaff in range(len(layoutUsed)):
            if layoutUsed[iStaff]== LayoutDesc:       #zugehrende Layoutzeile
                LayoutGefunden=1
                break
        if LayoutGefunden==1:
            anzahl_voices=len(staff[iStaff].getElementsByTagName('voice'))

            for cnt in range(1,anzahl_voices+1):
                if not (suppress and suppressGanzeZeile):
                    if anzahl_voices==1:
                        element1 = layoutUsed[iStaff]
                        stimmen.append(element1)
                        StimmenIndex.append(alleStimmenCnt)
                    elif suppressAuswahl.count(str(cnt))==0:
                        element1 = layoutUsed[iStaff] + ' (' + str(cnt)+')'
                        stimmen.append(element1)
                        StimmenIndex.append(alleStimmenCnt)
                    alleStimmenCnt+=1
    return stimmen


def inputCheck(score):
    #Partitur auf bersetzbarkeit prfen
    #Rckgabe: 'Err': Abbruch / 'OK':
    global instrument, StimmenIndex, Melodiestimmen, doc

    Erg='OK'
    keinTon=1
    msg = ''
    doc = score.parentNode
    systems = score.getElementsByTagName('system')
    rangeFehler = 0
    notenFehler = 0
    for sy in range(systems.length):                                                         # nur ausgewhlte Notenzeile bearbeiten
        voiceIx = 0
        for voice in systems[sy].getElementsByTagName('voice'):
            for st in range(4):
                if Melodiestimmen[st]>=0 and voiceIx == StimmenIndex[Melodiestimmen[st]]:
                    rangeFehler += checkRange(voice)                                         # Prfung auf nicht bersetzbare Noten

                    noteObjects1 = voice.getElementsByTagName('noteObjects')                 # Prfung auf nicht untersttzte Ton-Lngen
                    for child in noteObjects1[0].childNodes:
                        if child.nodeType == child.ELEMENT_NODE:
                            if child.tagName == 'chord':
                                keinTon=0   #Ton gefunden
                                duration = child.getElementsByTagName('duration')
                                base  = duration[0].getAttribute('base')
                                dots  = duration[0].getAttribute('dots')
                                if dots>'1' or not base in ['1/16','1/8','1/4','1/2','1/1','1']:
                                    notenFehler=1
                                    break
            if notenFehler or rangeFehler:
               break
            voiceIx = voiceIx + 1

    if rangeFehler != 0:
        msg = msg + '\n- Die Partitur enthlt fr das gewhlte Instrument nicht bersetzbare Tne.\n  Hinweis: Diese Tne sind rot markiert\n'
    if notenFehler !=0:
        msg = msg + '\n- Die Partitur enthlt nicht untersttzte Notenlngen.\n  Hinweis: Es sind nur 1/16,1/8,1/4,1/2 und 1/1 Noten\n  einschlielich einfache Punktierung untersttzt.\n  Bei Bedarf die Notenlnge des Stcks verdoppeln\n'

    clefSignFound = 0                                                                        # Prfung ob die Partitur am Anfang eine Taktangabe enthlt
    staves = systems[0].getElementsByTagName('staff')
    voices = staves[0].getElementsByTagName('voice')
    noteObjects1 = voices[0].getElementsByTagName('noteObjects')
    for child in noteObjects1[0].childNodes:
        if child.nodeType == child.ELEMENT_NODE:
            #messageBox('TS1',str(child.tagName) + '\n' + str(clefSignFound) + '\n' + str(rc4))
            if child.tagName == 'clefSign':
                clefSignFound = 1
                break
            elif child.tagName == 'chord' or child.tagName == 'rest':
                if clefSignFound == 0:
                    msg = msg + '\n- Die Partitur enthlt am Anfang keinen Notenschlssel.\n'
                    break
    if keinTon:
        msg = msg + '\n- Die Partitur enthlt keine Noten.\n'

    if msg:
        messageBox('Partiturproblem',str(msg))
        Erg = 'Err'                                                                          # bei Partiturfehlern speichern verhindern
    return Erg

def latin1_e(u):
    return u.encode('Latin-1')


#Stimmenauswertung und Dialog-Menue
#Returnwert: 'OK','Err','Quit'  (Quit=Abbruch ohne Fehler)
def pqDialog(score, opt, stimmen):
    global instrument, rastral, StimmenIndex, linie, pause, invisPause, taktprint, auftaktprint, namenprint, Melodiestimmen, StimmenNutzung, AkkordeNutzbar, AkkordeVerworfen, stimmenCnt
    global NFarbe, vfarbe, zfarbe, notengroesse, FontFace, strich, trioform, stimmeprint, menu, gdgorg, gdgtab, abstand, leer, datumprint, DaCapoNurText
    global Pfeilanz,Taktstrichanz, Taktnummerierung, klavier, druckLayout, anlegeKante, horizAbstVar, ZielMarker
    global Parametervorlage, akkordTon

    instrument   = '1'
    rastral      = '0'
    color        = '0'
    linie        = '0'
    pause        = '0'
    invisPause   = '0'
    taktprint    = '0'
    auftaktprint = '0'
    notengroesse = '0'
    FontFace     = '0'
    namenprint   = '0'
    Melodiestimmen = [-1,-1,-1,-1]                  #>=0 : Indices der genutzten Stimme, -1 : nicht genutzt
    MelSt1=MelSt2=MelSt3=MelSt4 = '-1'
    StimmenNutzung = [0,0,0,0]                      #0: Melodiestimme, 1..3: Begleitstimme zu Melodiestimme[index-1]
    #StNu1='0'
    StNu2=StNu3=StNu4='0'
    AkkordeNutzbar = [True,True,True,True]          #Akkorde werden nur verarbeitet, wenn Melodiestimme keine Begleitung hat, oder die Stimme Begleitstimme ist
    AkkordeVerworfen = [False,False,False,False]    #Akkorde waren in den Noten und wurden nicht verwendet --> am Ende Hinweis anzeigen
    NFarbe        = [11,11,11,11]
    vfarbe       = 5
    zfarbe       = 5
    ZielMarker=1
    trioform     = '0'
    gdgorg       = 0
    gdgtab       = 0
    strich       = '1'
    vabstand     = '2'
    leer         = 1
    datumprint   = 0
    Taktnummerierung = 2
    Pfeilanz     = 1
    Taktstrichanz= 1
    klavier      = 0
    anlegeKante  = 1
    horizAbstVar = 0
    DaCapoNurText= 1

    maxHeads=0

    stimmenCnt = len(stimmen)-1

    lablLeer     = Label('  ',width=4)
    lablLeer2    = Label(' ')

    if stimmenCnt>=3:
        StimmenNutzungen2=['Melodie','Begleitung zu Stimme 1','ungltig','Begleitung zu Stimme 3']
    else:
        StimmenNutzungen2=['Melodie','Begleitung zu Stimme 1','ungltig']
    StimmenNutzungen3=['Melodie','Begleitung zu Stimme 1','Begleitung zu Stimme 2','ungltig']
    StimmenNutzungen4=['Melodie','Begleitung zu Stimme 1','Begleitung zu Stimme 2','Begleitung zu Stimme 3']

    Melodiestimmen[0]=min(max(int(opt.get('MelSt1',0)),0),stimmenCnt)
    comMS1 = ComboBox(stimmen,width=20,value=Melodiestimmen[0])
    #comSN1 = ComboBox(['(immer Melodie)'], width=11,value=0)  # 1 muss immer Melodie sein

    stimmen.append('nicht genutzt')

    if (stimmenCnt>=1):
        Melodiestimmen[1]=min(max(int(opt.get('MelSt2',1)),-1),stimmenCnt)
    else:
        Melodiestimmen[1]=-1
    if Melodiestimmen[1]>=0:
        xStNu=min(int(opt.get('StNu2',0)),len(StimmenNutzungen2)-1)
    else:
        xStNu=-1
    comMS2 = ComboBox(stimmen, width=20,value=Melodiestimmen[1])
    comSN2 = ComboBox(StimmenNutzungen2, width=16,value=xStNu)

    if (stimmenCnt>=2):
        Melodiestimmen[2]=min(max(int(opt.get('MelSt3',2)),-1),stimmenCnt)
    else:
        Melodiestimmen[2]=-1
    if Melodiestimmen[2]>=0:
        xStNu=min(int(opt.get('StNu3',0)),len(StimmenNutzungen3)-1)
    else:
        xStNu=-1
    comMS3 = ComboBox(stimmen, width=20,value=Melodiestimmen[2])
    comSN3 = ComboBox(StimmenNutzungen3, width=16,value=xStNu)

    if (stimmenCnt>=3):
        Melodiestimmen[3]=min(max(int(opt.get('MelSt4',3)),-1),stimmenCnt)
    else:
        Melodiestimmen[3]=-1
    if Melodiestimmen[3]>=0:
        xStNu=min(int(opt.get('StNu4',0)),len(StimmenNutzungen4)-1)
    else:
        xStNu=-1
    comMS4 = ComboBox(stimmen, width=20,value=Melodiestimmen[3])
    comSN4 = ComboBox(StimmenNutzungen4, width=16,value=xStNu)

    RFarbe    = ['rot','orange','orange-gelb','gelb','gelb-grn','grn','blau-grn','grn-blau','blau','violett','rot-violett','schwarz','dunkelgrau','hellgrau','cyan','weiss']
    comFarbe1 = ComboBox(RFarbe,width=11,value=int(opt.get('farbe1',11)))
    comFarbe2 = ComboBox(RFarbe,width=11,value=int(opt.get('farbe2',8)))
    comFarbe3 = ComboBox(RFarbe,width=11,value=int(opt.get('farbe3',5)))
    comFarbe4 = ComboBox(RFarbe,width=11,value=int(opt.get('farbe4',4)))

    comVFarbe       = ComboBox(RFarbe,width=11,value=int(opt.get('vfarbe',0)))
    lblVFarbe       = Label('Wiederholungspfeile',width=16)
    HBoxVFarbe      = HBox([Label(' ',width=29),lblVFarbe,comVFarbe])

    HBoxSt1=HBox([Label('Stimme1:  '),comMS1,Label(' (immer Melodie) ',width=16), lablLeer2, comFarbe1])
    HBoxSt2=HBox([Label('Stimme2:  '),comMS2,comSN2, lablLeer2, comFarbe2])
    HBoxSt3=HBox([Label('Stimme3:  '),comMS3,comSN3, lablLeer2, comFarbe3])
    HBoxSt4=HBox([Label('Stimme4:  '),comMS4,comSN4, lablLeer2, comFarbe4])

    if stimmenCnt==0:
        boxListe=[HBoxSt1,lablLeer2,HBoxVFarbe,lablLeer  ,lablLeer,  lablLeer  ]
    elif  stimmenCnt==1:
        boxListe=[HBoxSt1,HBoxSt2,  lablLeer2, HBoxVFarbe,lablLeer,  lablLeer  ]
    elif  stimmenCnt==2:
        boxListe=[HBoxSt1,HBoxSt2,  HBoxSt3,   lablLeer2, HBoxVFarbe,lablLeer  ]
    elif  stimmenCnt>=3:
        boxListe=[HBoxSt1,HBoxSt2,  HBoxSt3,   HBoxSt4,   lablLeer2, HBoxVFarbe]

    #durch Kombination H- und VBox mit text weniger vertiakler Gap
    BoxStimmen=HBox([VBox(boxListe)],text='Stimmenauswahl (maximal 4 Stimmen, keine Stimme doppelt)   und   Farbauswahl')

    HarfenListe = ["Tischharfe - 18 Saiten   Sopran\t  h - e\"  \t DIN A4 hoch",
                   "Tischharfe - 18 Saiten   Sopran\t  h - e\"  \t DIN A4 quer",
                   "Tischharfe - 18 Saiten   Bass\t  H - e'  \t DIN A4 hoch",
                   "Tischharfe - 18 Saiten   Bass\t  H - e'  \t DIN A4 quer",
                   "Tischharfe - 25 Saiten   Sopran/Alt\t  g - g\"  \t DIN A4 quer",
                   "Tischharfe - 25 Saiten   Tenor/Bass\t  G - g'  \t DIN A4 quer",
                   "Tischharfe - 25 Saiten   Sopran/Alt\t  g - g\"  \t DIN A3 quer",
                   "Tischharfe - 25 Saiten   Tenor/Bass\t  G - g'  \t DIN A3 quer",
                   "Tischharfe - 37 Saiten   Solo\t  G - g\"  \t DIN A3 quer",
                   "Tischharfe - 21 Saiten   Sopran\t  a - f\"  \t DIN A4 quer",
                   "Tischharfe - 25 Saiten   Bass\t  F - f'  \t DIN A4 quer",                  #gibt es die noch?
                   "Tischharfe - 21 Saiten   Sopran\t  a - f\"  \t DIN A3 quer",
                   "Tischharfe - 25 Saiten   Bass\t  F - f'  \t DIN A3 quer"]                  #gibt es die noch?

    RastralListe = ['Rastral 0\t- 2,3 mm' ,'Rastral 1\t- 2,0 mm','Rastral 2\t- 1,88 mm','Rastral 3\t- 1,76 mm','Rastral 4\t- 1,6 mm',
                    'Rastral 5\t- 1,52 mm','Rastral 6\t- 1,4 mm','Rastral 6.5\t- 1,3 mm'  ,'Rastral 7\t- 1,2 mm' ,'Rastral 7.5\t- 1,1 mm' ,
                    'Rastral 8\t- 1,02 mm'  ,'autom. (bei Abst 1)']
    CBxColor        = CheckBox('farbig',value=int(opt.get('color',0)))
    CBxTriole       = CheckBox('Triolendarstellung in der Note  ',value=int(opt.get('trioform',0)))
    radioBegleitSt  = Radio(['Begleitstimme verbinden','Begleitstimme nicht verbinden','Begleitstimme nur verbinden bei eigenstndiger Melodie'], value=int(opt.get('linie',0)),text='Begleitstimme')
    radioPause      = Radio(['Pausen','gehaltene Noten','Mglichst unterdrcken. Verbleibende Pausen werden gehaltene Noten','Mglichst unterdrcken. Verbleibende Pausen werden Pausen'], value=int(opt.get('pause',0)))
    radioPause1     = Radio(['Normal behandeln','Immer ausblenden'], value=int(opt.get('invisPause',0)),text='Unsichtbare Pausen')
    CBxTakt         = CheckBox('Taktangabe ausdrucken',value=int(opt.get('taktprint',0)))
    CBxDatum        = CheckBox('Datumsangabe ausdrucken',value=int(opt.get('datumprint',1)))

    CBxLeer         = CheckBox('zustzl. Abstand bei Doppelstrich, vor Wdh  ',value=int(opt.get('leer',1)))
    CBxStimme       = CheckBox('Stimmenbezeichnung ausdrucken',value=int(opt.get('stimmeprint',0)))
    CBxNamen        = CheckBox('Notennamen ausdrucken',value=int(opt.get('namenprint',0)))
    radioGroesse    = Radio(['klein', 'mittel', 'gross'], value=int(opt.get('notengroesse',0)),text='Notengroesse')
    radioFont       = Radio(['rund' , 'oval'  , 'oval (Standard-Pause)'], value=int(opt.get('FontFace',2)),text='Notenform')
    radioAkkord     = Radio(['oberste Note' , 'alle Noten' ,'unterste Note'], value=int(opt.get('akkordTon',2)),text='Akkord-Nutzung')
    radioStrich     = Radio(['dnn','mittel','dick            '],value=int(opt.get('strich',1)),text='Wiederholungslinien')

    CBxSprungZiel   = CheckBox('Rahmen um Sprungziel',value=int(opt.get('ZielMarker',1)))
    comZFarbe       = ComboBox(RFarbe,width=11,value=int(opt.get('zfarbe',1)))
    HBoxZFarbe      = HBox([comZFarbe,Label('  Farbe Rahmen')])

    RVabstand       = ['1','2','3','4','5','6']
    comVabstand     = ComboBox(RVabstand,width=11,value=int(opt.get('vabstand',3)))

    CBxPfeilanz     = CheckBox('TaktPfeile',value=int(opt.get('Pfeilanz',1)))
    radioAuftakt    = Radio(['nur bei Auftakt','erster ganzer Takt','jeder Taktanfang'], value=int(opt.get('auftaktprint',0)))
    CBxTaktStriche  = CheckBox('Taktstriche anzeigen',value=int(opt.get('Taktstrichanz',1)))
    TaktnummerAnzeigen  = ['ohne','1','2','3','4','5']
    comTaktNr       = ComboBox(TaktnummerAnzeigen,width=5,value=int(opt.get('Taktnummerierung',2)))
    HBoxTaktNr      = HBox([Label('Anzeige alle    \nn Taktnummern'),comTaktNr], padding=12)

    AnlegekanteAnzeigen = ['keine','links','rechts','beidseitig']
    ver, sub, sr = capVersion()
    if ver<8:
        Druckformat         = ['links (normal)','rechtsbndig']     #Quadratische Papierdefinition macht nur Sinn mit Capella-PDF-Export
    else:
        Druckformat         = ['links (normal)','rechtsbndig','Papier quadratisch']
    CBxKlavier      = CheckBox('Klavierlinien anzeigen',value=int(opt.get('klavier',0)))
    comAnlegeKante  = ComboBox(AnlegekanteAnzeigen,width=9,value=int(opt.get('anlegeKante',1)))
    HBoxAnlegeKante = HBox([Label(' Anlegekante    '), comAnlegeKante])
    comDruck        = ComboBox(Druckformat,width=15,value=int(opt.get('druckLayout',0)))
    HBoxDruck       = HBox([comDruck,Label(' Layout A3 (auer Solo)')])
    DaCapoAlsText   = CheckBox('"Da Capo" nur als Text',value=int(opt.get('DaCapoNurText',1)))

    Harfe           = ComboBox(HarfenListe,width=56,value=int(opt.get('instrument',6)))
    CBxHorizAbst    = CheckBox('kleinerer Abstand fr 1. u. letzte Note (besserer Druck bei A4-hoch bzw. Solo-Harfe)',value=int(opt.get('horizAbstVar',1)))
    VBoxInstrument  = VBox([Harfe, CBxHorizAbst, HBoxDruck])
    BoxInstrument   = HBox([VBoxInstrument],text='Instrumententyp und Papierformat')          #dadurch weniger vertikalen Abstand

    radioOrgDat     = Radio(['Originaldatei wird berschrieben, Anwender muss selbst sichern + speichern',
                             'Originaldatei wird gesichert, eigene Tabulaturdatei wird erzeugt',
                             'Originaldatei wird nicht gesichert, eigene Tabulaturdatei wird erzeugt'], value=int(opt.get('gdgorg',1)),text='Originaldatei')
    radioTabDat     = Radio(['einzelne Datei (.._VH.capx ), Datei wird immer berschrieben',
                             'Datei stimmenspezifisch (.._VH_a_b.capx ), Datei wird immer berschrieben',
                             'Datei stimmenspezifisch mit Versionsnummer (.._VH_a_b(n).capx )'], value=int(opt.get('gdgtab',0)),text='Tabulaturdatei')
    CBxOptLokal     = CheckBox('Parameter merken (aktuelle Vorlage: '+Parametervorlage+')',value=int(opt.get('lokaleParameter',1)))
    HBoxGDG         = VBox([radioOrgDat,radioTabDat,CBxOptLokal],text='Dateioptionen')
    VBoxLinks       = VBox([BoxInstrument,BoxStimmen,HBoxGDG])

    Rastral         = ComboBox(RastralListe,width=17,value=int(opt.get('rastral',0)))
    HBoxRastral     = HBox([Rastral],text='Rastral')

    HBoxVAbstand    = HBox([comVabstand,lablLeer],text='vertikaler Zeilenabstand')
    HBoxRaster      = HBox([HBoxRastral,HBoxVAbstand])
    HBoxNoten       = HBox([radioGroesse,radioFont,radioAkkord])
    VBoxN           = VBox([HBoxRaster,HBoxNoten])

    VBoxRechts1a    = VBox([CBxColor,CBxTakt,CBxTriole,CBxDatum,HBoxAnlegeKante,lablLeer2])    # Checkboxen 1
    VBoxRechts1b    = VBox([CBxNamen,CBxStimme,CBxLeer,CBxKlavier, DaCapoAlsText])             # Checkboxen 2

    HBoxRechts1c    = HBox([VBoxRechts1a,Label('  '),VBoxRechts1b])
    VBoxRechtsO     = VBox([HBoxRechts1c,radioBegleitSt])

    BoxTakt         = VBox([CBxPfeilanz,radioAuftakt, lablLeer, lablLeer, CBxTaktStriche,HBoxTaktNr],text='Takt-Kennzeichnungen')               # Anzeige und Nummern
    HBoxRechts2    = HBox([VBoxRechtsO,BoxTakt])

    HBoxPausen      = HBox([radioPause,radioPause1],text='Pausen Darstellung')

    VBoxWdh         = VBox([radioStrich,CBxSprungZiel,HBoxZFarbe])
    HBoxRechtsUnten = HBox([VBoxN,VBoxWdh])

    VBoxDarstellungR = VBox([HBoxRechts2, HBoxPausen,HBoxRechtsUnten])
    HBoxDarstellung = HBox([VBoxDarstellungR],text='Darstellung')   #weniger Hhe. Warum??

    HBoxPar         = HBox([VBoxLinks,HBoxDarstellung])

    lbl2RTM         = Label('Veeh-Harfe und Veeh-Noten sind eingetragene Warenzeichen der Firma Hermann Veeh GmbH u. CO.KG ')
    box             = VBox([HBoxPar,lbl2RTM])


    while 1:
        dlg = Dialog('Tischharfen Script,  Version : ' + str(version), HBoxPar, help='Dokumentation und Schriftarten \nsiehe http://peter-becker-cap.de/scripts_meine.htm')

        runflag= dlg.run()
        lokaleParameter = CBxOptLokal.value()
        gdgorg       = radioOrgDat.value()
        gdgtab       = radioTabDat.value()

        if lokaleParameter==1 and Parametervorlage != 'Standard':                  # wurde eine lokale Parameterdatei genutzt?
            Datei.nameOldVH=opt.get('vh_datei_save','')                            # fr die Verschiebungen

        if runflag==0:
            return ('Quit',opt)
#           #############

        instrument   = Harfe.value()
        rastral      = Rastral.value()
        color        = CBxColor.value()
        linie        = radioBegleitSt.value()
        pause        = radioPause.value()
        invisPause   = radioPause1.value()
        taktprint    = CBxTakt.value()
        auftaktprint = radioAuftakt.value()
        Pfeilanz     = CBxPfeilanz.value()
        notengroesse = radioGroesse.value()
        FontFace     = radioFont.value()
        namenprint   = CBxNamen.value()
        anlegeKante   = comAnlegeKante.value()
        if instrument in [0,2,8]:
            horizAbstVar = CBxHorizAbst.value()  #nur fr Solo und A4 hoch
        else:
            horizAbstVar = 0
        druckLayout = 0   #0=links (standard), A3 auer Solo: 1=rechts,2=quadrat
        if instrument in [6,7,11,12]:
            druckLayout=comDruck.value()

        if comMS1.value()<=stimmenCnt:      #'ungueltig' auf -1 setzen
            MelSt1  = comMS1.value()
        else:
            MelSt1  = -1
        Melodiestimmen[0]=MelSt1
        StimmenNutzung[0]=0

        if comMS2.value()<=stimmenCnt:
            MelSt2       = comMS2.value()
            StNu2        = comSN2.value()
            StimmenNutzung[1] =StNu2
        else:
            MelSt2       = -1
            StimmenNutzung[1] = -1
            # StNu bleibt unverndert
        Melodiestimmen[1]=MelSt2

        if comMS3.value()<=stimmenCnt:
            MelSt3       = comMS3.value()
            StNu3        = comSN3.value()
            StimmenNutzung[2] =StNu3
        else:
            MelSt3       = -1
            StimmenNutzung[2] = -1
        Melodiestimmen[2]=MelSt3

        if comMS4.value()<=stimmenCnt:
            MelSt4       = comMS4.value()
            StNu4        = comSN4.value()
            StimmenNutzung[3] =StNu4
        else:
            MelSt4       = -1
            StimmenNutzung[3] = -1
        Melodiestimmen[3]=MelSt4

        farbe1       = comFarbe1.value()
        NFarbe[0]    = farbe1
        farbe2       = comFarbe2.value()
        NFarbe[1]    = farbe2
        farbe3       = comFarbe3.value()
        NFarbe[2]    = farbe3
        farbe4       = comFarbe4.value()
        NFarbe[3]    = farbe4
        vfarbe       = comVFarbe.value()
        zfarbe       = comZFarbe.value()
        trioform     = CBxTriole.value()
        stimmeprint  = CBxStimme.value()
        strich       = radioStrich.value()
        vabstand     = comVabstand.value()
        leer         = CBxLeer.value()
        datumprint   = CBxDatum.value()
        Taktstrichanz= CBxTaktStriche.value()

        klavier      = CBxKlavier.value()
        Taktnummerierung =comTaktNr.value()
        DaCapoNurText= DaCapoAlsText.value()
        ZielMarker=CBxSprungZiel.value()
        akkordTon=radioAkkord.value()

        #Stimmenzuordnung prfen
        auswahlfehler=0
        hinweisZuordnung=''
        for st in range(4):
            if Melodiestimmen[st]>=0:
                if Melodiestimmen.count(Melodiestimmen[st]) > 1:  # Stimme wird doppelt angezogen
                    hinweisZuordnung=hinweisZuordnung+'Stimme "'+stimmen[Melodiestimmen[st]]+'" wurde mehrfach ausgewhlt\n'
                    auswahlfehler=1
                    break
                if StimmenNutzung[st]==0 and StimmenNutzung.count(Melodiestimmen[st]+1)>0:
                    AkkordeNutzbar[st]=False
        for st in range(1, 4):
            if Melodiestimmen[st]>=0:
                if StimmenNutzung[st]>0 and StimmenNutzung[StimmenNutzung[st]-1]>0:
                    hinweisZuordnung=hinweisZuordnung+'Stimme '+str(st+1)+' ('+stimmen[st]+') \nmuss einer Melodiestimme zugeordnet werden\n'
                    auswahlfehler=1
                    break
                if StimmenNutzung[st]==-1:
                    hinweisZuordnung=hinweisZuordnung+'Typ der Stimme '+str(st+1)+' ('+stimmen[st]+') \nist nicht definiert (Melodie / Begleitung?)\n'
                    auswahlfehler=1
                    break
                if st==(StimmenNutzung[st]-1):
                    hinweisZuordnung=hinweisZuordnung+'Stimme '+str(st+1)+' ('+stimmen[st]+') \nkann nicht die eigene Begleitstimme sein\n'
                    auswahlfehler=1
                    break
        if auswahlfehler==1:
            messageBox('Hinweis',hinweisZuordnung,2,0)
        else:
            opt = dict(lokaleParameter=lokaleParameter,instrument=instrument,rastral=rastral,color=color,linie=linie,pause=pause,invisPause=invisPause,taktprint=taktprint,auftaktprint=auftaktprint,notengroesse=notengroesse,
               FontFace=FontFace,namenprint=namenprint,trioform=trioform,
               MelSt1=MelSt1,MelSt2=MelSt2,MelSt3=MelSt3,MelSt4=MelSt4,StNu2=StNu2,StNu3=StNu3,StNu4=StNu4,
               farbe1=farbe1,farbe2=farbe2,farbe3=farbe3,farbe4=farbe4,vfarbe=vfarbe,zfarbe=zfarbe,
               stimmeprint=stimmeprint,gdgorg=gdgorg,gdgtab=gdgtab,strich=strich,vabstand=vabstand,leer=leer,datumprint=datumprint,DaCapoNurText=DaCapoNurText,
               Taktnummerierung=Taktnummerierung,Pfeilanz=Pfeilanz,Taktstrichanz=Taktstrichanz,klavier=klavier,druckLayout=druckLayout,
               anlegeKante=anlegeKante, horizAbstVar=horizAbstVar, ZielMarker=ZielMarker, vh_datei_save='',akkordTon=akkordTon)

            prepareInstrument()
            rc = inputCheck(score)
            if rc == 'OK':
                break   #Ende Dialog

    # bis hier do while bis Ende Dialog
    Datei.genErw(gdgtab)                                                       # Namen ggf. abh. von Stimmen und Generationen erzeugen
    opt['vh_datei_save']=Datei.nameNewVH()

    if color==0:                                                               # keine Farbe --> alle Farben auf Schwarz setzen. Dann Unterschiedung im Code nicht mehr notwendig
        vfarbe = 11                                                            # schwarz
        NFarbe=[11,11,11,11]

    abstand=int(RVabstand[vabstand])

    if Pfeilanz==0 :              #keine Anzeige ausgewhlt
        auftaktprint=3            #-->wie alte Wahl "nichts anzeigen"

    return ('OK', opt)
#   ###########


def getOptions(stimmen):
    #OPT-Datei auswhlen, neu: verwendete Stimmen anzeigen
    global Parametervorlage

    options = ScriptOptions()
    options_global=options
    opt = options.get()

    paramFileName = Datei.nameVH
    paramExt   ='.opt'
    Parametervorlage='Standard'
    lenpFN=len(paramFileName)
    lenExt=len(paramExt)

    lokaleParameter=int(opt.get('lokaleParameter',1))       #wenn Wert nicht da, dann 1 als default
    if lokaleParameter==1:
        if not os.path.isdir(Datei.parDir):
            os.makedirs(Datei.parDir)
        else:
            paramFileList=[]
            paramStimmenList=[]
            files = os.listdir(Datei.parDir)

            for fp in files:
                if fp[:lenpFN]==paramFileName and fp[-lenExt:]==paramExt:
                    paramFileList.append(fp)
                    stIndeces=fp[lenpFN+1:-lenExt]
                    stUsed=stIndeces.split("_")
                    if stUsed[0]!='' :
                        try:
                            optSt='   [Stimmen: '
                            for stimm in stUsed:
                                optSt+=stimmen[int(stimm)-1]+";"
                            optSt=optSt[:-1]+"]"
                        except:
                            optSt=''    #Wenn Stimmen nicht aus dem Dateinamen ermittelbar sind
                        fp+=optSt
                    paramStimmenList.append(fp)

            if len(paramFileList)==1:     #nur eine opt-Dateien gefunden
                optName=Datei.parDir+paramFileList[0]
                options = ScriptOptions(optName)
                Parametervorlage=paramFileList[0]

            elif len(paramFileList)>1:
                paramStimmenList.append('Standard Parameter benutzen')
                OptCombo = Radio(paramStimmenList,value=0)
                BoxOpt  = HBox([OptCombo])
                dlgO = Dialog('Auswahl Parameterdatei', BoxOpt)

                if dlgO.run()==0:
                    return ('Quit',dict())
    #               #############

                OptIndex = OptCombo.value()
                if OptIndex<len(paramFileList):
                    options = ScriptOptions(Datei.parDir+paramFileList[OptIndex])
                    Parametervorlage=paramFileList[OptIndex]
            opt = options.get()
        vh_datei_save=opt.get('vh_datei_save','')       #Default
        Datei.nameErw=vh_datei_save[lenpFN:]            #Default: Alte Extensions
    return ('OK',opt)


def saveOpt(opt):
    #OPT-Datei speichern, lokal je nach Parameter, global immer
    lokaleParameter=int(opt.get('lokaleParameter',0))
    if lokaleParameter==1:      #lokale Parameter nur schreiben, wenn Parameter gesetzt
        if not os.path.isdir(Datei.parDir):
            os.makedirs(Datei.parDir)
        options = ScriptOptions(Datei.parFile())      #lokale Parameterdatei
        options.set(opt)
    options = ScriptOptions()                         #globale Parameterdatei
    options.set(opt)


def autoPlacingWeg(score):
    # Node editOptions entfernen
    editOption = score.getElementsByTagName('editOptions')
    if editOption:
        rC = score.removeChild(editOption[0])
    #Attribute 'placement' berall lschen
    for system in score.getElementsByTagName('system'):
        for drawObj in system.getElementsByTagName('drawObj'):
            for basic in drawObj.getElementsByTagName('basic'):
                removeAttr(basic,'placement')


def runScript(score):
    global Erg, tempInput
    for system in score.getElementsByTagName('system'):
        for staff in system.getElementsByTagName('staff'):
            layout = staff.getAttribute('layout')
            if layout == 'Tischharfe' or layout=='Veeh':  #'Veeh': alte Bezeichnung
                messageBox('Hinweis','Das System ist schon eine Tischharfen-Datei',3,0)
                Erg =''
                return
#               ############
    if checkSegno(score)=='Err':        #Prfen, dass die Segnos richtig verankert sind
        Erg='Quit'                      # mit Quit werden die nderungen (gefrbte Segnos) angezeigt
        return
#       ############

    try:
        optNew=dict()
        stimmen=getStimmenListe(score)
        Erg, opt = getOptions(stimmen)
        if Erg == 'OK':
            Erg, optNew = pqDialog(score,opt,stimmen)

            if Erg == 'OK':
                if gdgorg == 1:                     # manuelle nderungen erhalten mit Sicherung
                    activeScore().write(Datei.src)
                    closeActiveScore()              # Um Quelle neu zu ffnen "ohne den nderungsstern"
                    openScore(Datei.src)
                openScore(tempInput)

                if capVersion() >= (9, 0, 0):
                    autoPlacingWeg(score)
                changeDoc(score, stimmen)

        if len(optNew)>0:
            if Erg != 'OK':
                optNew['vh_datei_save']=opt.get('vh_datei_save','')
            saveOpt(optNew)                     # hier speichern nachdem alles durchgelaufen ist

    except Abbruch:
        Erg='Abbruch'

    except:
        if sys.version_info >= (2, 5):
            messageBox('UPS Das war ein Fehler',str(traceback.format_exc()),4)
        else:
            raise
            messageBox('UPS Das war ein Fehler',str(sys.exc_info()[0]),4)
        Erg='Err'

    return


# Hauptprogramm:
class ScoreChange(ScoreChange):

    def changeScore(self, score):

        runScript(score)
        return

if activeScore():
    global tempInput

    activeScore().registerUndo("Tisch-Harfe")
    Datei=DateiNamen(activeScore().pathName())    #Init der Klasse

    if Datei.dir=='/':
        messageBox('Hinweis','Bitte Datei sichern vor Ausfhren des Plugin',3,0)
    else:
        tempInput = tempfile.mktemp('_in.capx')
        tempOutput = tempfile.mktemp('_out.capx')
        activeScore().write(tempInput)
        if os.path.exists(tempInput):       #Abfangen: write wird nicht ausgefhrt bei genderter Datei und Demo-Programm

            ScoreChange(tempInput, tempOutput)                                         # ber die Klasse werden die nderungen gestartet
            if Erg in ['Err','Abbruch']:
                if activeScore().pathName()==tempInput.replace('\\','/'):
                    closeActiveScore()                      # Temp-input lschen, nur wenn schon geffnet
                if Erg == 'Err':# and FirstLine==0:           # schon nderungen durchgefhrt?
                    openScore(tempOutput)                   # dann auch Anzeige des Tmp-Files
            elif Erg == 'OK':
                if gdgorg == 0:
                    closeActiveScore()                                                 # Tab schlieen und
                    activeScore().read(tempOutput)                                     # in ungesicherte Quelle lesen
                else:                                                                  # Anzeigen und ggf Speichern
                    activeScore().read(tempOutput)
                    dsname_VH = Datei.VH()
                    activeScore().write(dsname_VH)                                     # umgewandelte Datei als einzelne Datei sichern
                    closeActiveScore()                                                 # Temp-Score lschen
                    openScore(dsname_VH)                                               # und als Tab ffnen
            elif Erg == 'Quit':                         # Quelle mit evtl. nderungen (z.B. rot markierten Fehlern) anzeigen
                activeScore().read(tempOutput)

            os.remove(tempInput)
            os.remove(tempOutput)

